clc
clf
clear all
close all
Hs=10;     %significant wave height%
Tp_min=0;
Tp_estm_max=30;

Tp=Tp_min:0.1:Tp_estm_max;
alfa_1=zeros((Tp_estm_max-Tp_min)*10+1,1);
mid_1=zeros((Tp_estm_max-Tp_min)*10+1,1);

%1. NPS%
c_1=1;     %scale coefficient for location parameter%
c_2=1;     %coefficient which control linear and quadratic%
c_3=1;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=100;    %coefficient which control sensitive to period or not%
c_6=0.1;   %measure of variability around the mean 30-minute maximum%

for i=1:1:(Tp_estm_max-Tp_min)*10+1
    mid_1(i,1)=1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3;
    alfa_1(i,1)=c_1*Hs^c_2*(1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3);
    beita_1(i,1)=c_2*c_6*alfa_1(i);
end

% 2. 30, 100
c_1=1;     %scale coefficient for location parameter%
c_2=1;     %coefficient which control linear and quadratic%
c_3=30;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=100;    %coefficient which control sensitive to period or not%
c_6=0.1;   %measure of variability around the mean 30-minute maximum%

alfa_3=zeros((Tp_estm_max-Tp_min)*10+1,1);
mid_3=zeros((Tp_estm_max-Tp_min)*10+1,1);

for i=1:1:(Tp_estm_max-Tp_min)*10+1
    mid_3(i,1)=1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3;
    alfa_3(i,1)=c_1*Hs^c_2*(1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3);
    beita_3(i,1)=c_2*c_6*alfa_3(i);
end

% 3. 70, 100
c_1=1;     %scale coefficient for location parameter%
c_2=1;     %coefficient which control linear and quadratic%
c_3=70;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=100;    %coefficient which control sensitive to period or not%
c_6=0.1;   %measure of variability around the mean 30-minute maximum%

alfa_4=zeros((Tp_estm_max-Tp_min)*10+1,1);
mid_4=zeros((Tp_estm_max-Tp_min)*10+1,1);

for i=1:1:(Tp_estm_max-Tp_min)*10+1
    mid_4(i,1)=1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3;
    alfa_4(i,1)=c_1*Hs^c_2*(1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3);
    beita_4(i,1)=c_2*c_6*alfa_4(i);
end

% 4. 30, 60
c_1=1;     %scale coefficient for location parameter%
c_2=1;     %coefficient which control linear and quadratic%
c_3=100;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=60;    %coefficient which control sensitive to period or not%
c_6=0.1;   %measure of variability around the mean 30-minute maximum%

alfa_5=zeros((Tp_estm_max-Tp_min)*10+1,1);
mid_5=zeros((Tp_estm_max-Tp_min)*10+1,1);

for i=1:1:(Tp_estm_max-Tp_min)*10+1
    mid_5(i,1)=1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3;
    alfa_5(i,1)=c_1*Hs^c_2*(1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3);
    beita_5(i,1)=c_2*c_6*alfa_5(i);
end

% 5. 70, 60
c_1=1;     %scale coefficient for location parameter%
c_2=1;     %coefficient which control linear and quadratic%
c_3=70;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=60;    %coefficient which control sensitive to period or not%
c_6=0.1;   %measure of variability around the mean 30-minute maximum%

alfa_6=zeros((Tp_estm_max-Tp_min)*10+1,1);
mid_6=zeros((Tp_estm_max-Tp_min)*10+1,1);

for i=1:1:(Tp_estm_max-Tp_min)*10+1
    mid_6(i,1)=1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3;
    alfa_6(i,1)=c_1*Hs^c_2*(1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3);
    beita_6(i,1)=c_2*c_6*alfa_6(i);
end

%6.PS%
c_1=1;     %scale coefficient for location parameter%
c_2=1;     %coefficient which control linear and quadratic%
c_3=100;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=60;    %coefficient which control sensitive to period or not%
c_6=0.1;   %measure of variability around the mean 30-minute maximum%

alfa_2=zeros((Tp_estm_max-Tp_min)*10+1,1);
mid_2=zeros((Tp_estm_max-Tp_min)*10+1,1);

for i=1:1:(Tp_estm_max-Tp_min)*10+1
    mid_2(i,1)=1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3;
    alfa_2(i,1)=c_1*Hs^c_2*(1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3);
    beita_2(i,1)=c_2*c_6*alfa_2(i);
end

% figure(1)
% h1=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),mid_1(1:(Tp_estm_max-Tp_min)*10+1),'b','LineWidth',2);  
% hold on;
% h2=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),mid_2(1:(Tp_estm_max-Tp_min)*10+1),'r','LineWidth',2);
% legend([h1 h2],'c_2=1','c_2=2','Location','Best');
% ylabel('Paramter','FontWeight','bold','FontSize',16);
% xlabel('Peak Period','FontWeight','bold','FontSize',16);
% axis([0 30 0 2.1]);
% 
% figure(2)
% h1=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),alfa_1(1:(Tp_estm_max-Tp_min)*10+1),'b','LineWidth',2);  
% hold on;
% h2=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),alfa_2(1:(Tp_estm_max-Tp_min)*10+1),'r','LineWidth',2);
% legend([h1 h2],'c_2=1','c_2=2','Location','Best');
% ylabel('alfa','FontWeight','bold','FontSize',16);
% xlabel('Peak Period','FontWeight','bold','FontSize',16);
% axis([0 30 0 300]);
% 
% figure(3)
% h1=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),beita_1(1:(Tp_estm_max-Tp_min)*10+1),'b','LineWidth',2);  
% hold on;
% h2=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),beita_2(1:(Tp_estm_max-Tp_min)*10+1),'r','LineWidth',2);
% legend([h1 h2],'c_2=1','c_2=2','Location','Best');
% ylabel('beita','FontWeight','bold','FontSize',16);
% xlabel('Peak Period','FontWeight','bold','FontSize',16);
% axis([0 30 0 60]);

figure(2)
h1=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),alfa_1(1:(Tp_estm_max-Tp_min)*10+1),'--b','LineWidth',4);
hold on;
h2=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),alfa_3(1:(Tp_estm_max-Tp_min)*10+1),'-r','LineWidth',4);
hold on;
h3=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),alfa_4(1:(Tp_estm_max-Tp_min)*10+1),'-.m','LineWidth',4);
hold on;
h4=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),alfa_5(1:(Tp_estm_max-Tp_min)*10+1),':k','LineWidth',4);
hold on;
h5=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),alfa_6(1:(Tp_estm_max-Tp_min)*10+1),'-g','LineWidth',4);
hold on;
h6=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),alfa_2(1:(Tp_estm_max-Tp_min)*10+1),'--k','LineWidth',4);
AX=legend([h1 h2 h3 h4 h5 h6],'c_3=1, c_5=100','c_3=30, c_5=100','c_3=70, c_5=100','c_3=30, c_5=60','c_3=70, c_5=60','c_3=100, c_5=60','Location','NorthEast');
LEG = findobj(AX,'type','text');
set(LEG,'FontSize',20)
ylabel('Location Parameter \alpha','FontWeight','bold','FontSize',25);
xlabel('Peak Period T_p(s)','FontWeight','bold','FontSize',25);
axis([0 30 10 20.5]);
set(gca,'fontsize',25)

% figure(3)
% h1=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),beita_1(1:(Tp_estm_max-Tp_min)*10+1),'b','LineWidth',2);  
% hold on;
% h2=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),beita_2(1:(Tp_estm_max-Tp_min)*10+1),'r','LineWidth',2);
% legend([h1 h2],'c_6=0.1','c_6=0.3','Location','NorthEast');
% ylabel('Scale Parameter beta','FontWeight','bold','FontSize',16);
% xlabel('Peak Period','FontWeight','bold','FontSize',16);
% axis([0 30 1.5 6.5]);
