clc
clf
clear all
close all
Hs=0:0.1:25;     %significant wave height%
Tp=15;

% lINEAR CASE
alfa_1=zeros(1,251);
c_1=1;     %scale coefficient for location parameter%
c_2=1;     %coefficient which control linear and quadratic%
c_3=1;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=100;    %coefficient which control sensitive to period or not%
c_6=0.1;   %measure of variability around the mean 30-minute maximum%

for i=1:1:125
    
    alfa_1(1,i)=c_1*Hs(1,i)^c_2*(1+(cos((2*pi*(Tp-c_4)/c_5)))^c_3);
    
end

% NON-LINEAR CASE
alfa_2=zeros(1,251);
c_1=1;     %scale coefficient for location parameter%
c_2=2;     %coefficient which control linear and quadratic%
c_3=1;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=100;    %coefficient which control sensitive to period or not%
c_6=0.1;   %measure of variability around the mean 30-minute maximum%

for i=1:1:251
    
    alfa_2(1,i)=c_1*Hs(1,i)^c_2*(1+(cos((2*pi*(Tp-c_4)/c_5)))^c_3);
    
end

figure(1)
h1=plot(Hs(1:251),alfa_1(1:251),'b','LineWidth',4);
hold on;
h2=plot(Hs(1:251),alfa_2(1:251),'--r','LineWidth',4);
AX=legend([h1 h2],'Linear Response Case, c_2=1','Quadratic Response Case, c_2=2','Location','NorthWest');
LEG = findobj(AX,'type','text');
set(LEG,'FontSize',25)


ylabel('Location Parameter \alpha','FontWeight','bold','FontSize',25);
xlabel('Significant Wave Height h_s (m)','FontWeight','bold','FontSize',25);
axis([0 10 0 200]);
set(gca,'fontsize',25)

