clc
clf
clear all
close all
Hs=10;     %significant wave height%
Tp_min=0;
Tp_estm_max=30;

Tp=Tp_min:0.1:Tp_estm_max;
alfa_1=zeros((Tp_estm_max-Tp_min)*10+1,1);
beta_1=zeros((Tp_estm_max-Tp_min)*10+1,1);

%1. NPS%
c_1=1;     %scale coefficient for location parameter%
c_2=1;     %coefficient which control linear and quadratic%
c_3=1;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=100;    %coefficient which control sensitive to period or not%
c_6=0.1;   %measure of variability around the mean 30-minute maximum%

for i=1:1:(Tp_estm_max-Tp_min)*10+1
    
    alfa_1(i,1)=c_1*Hs^c_2*(1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3);
    beta_1(i,1)=c_2*c_6*alfa_1(i,1);
end

% 2. 30, 100
c_1=1;     %scale coefficient for location parameter%
c_2=1;     %coefficient which control linear and quadratic%
c_3=1;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=100;    %coefficient which control sensitive to period or not%
c_6=0.3;   %measure of variability around the mean 30-minute maximum%

alfa_2=zeros((Tp_estm_max-Tp_min)*10+1,1);
beta_2=zeros((Tp_estm_max-Tp_min)*10+1,1);

for i=1:1:(Tp_estm_max-Tp_min)*10+1
    
    alfa_2(i,1)=c_1*Hs^c_2*(1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3);
    beta_2(i,1)=c_2*c_6*alfa_2(i,1);
end

figure(1)
h1=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),alfa_1(1:(Tp_estm_max-Tp_min)*10+1),'b','LineWidth',4);
hold on;
h2=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),alfa_2(1:(Tp_estm_max-Tp_min)*10+1),'--r','LineWidth',4);
AX=legend([h1 h2],'c_6=0.1','c_6=0.3','Location','NorthWest');
LEG = findobj(AX,'type','text');
set(LEG,'FontSize',25)
ylabel('Location Parameter \alpha','FontWeight','bold','FontSize',25);
xlabel('Peak Period t_p(s)','FontWeight','bold','FontSize',25);
axis([0 30 15.5 20.5]);
set(gca,'fontsize',25)

figure(2)
h1=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),beta_1(1:(Tp_estm_max-Tp_min)*10+1),'b','LineWidth',4);
hold on;
h2=plot(Tp(1:(Tp_estm_max-Tp_min)*10+1),beta_2(1:(Tp_estm_max-Tp_min)*10+1),'--r','LineWidth',4);
AX=legend([h1 h2],'c_6=0.1','c_6=0.3','Location','NorthWest');
LEG = findobj(AX,'type','text');
set(LEG,'FontSize',25)
ylabel('Location Parameter \beta','FontWeight','bold','FontSize',25);
xlabel('Peak Period t_p(s)','FontWeight','bold','FontSize',25);
axis([0 30 1.5 6.8]);
set(gca,'fontsize',25)
