clc
clf
clear all
close all
Wdata=load('\\sambaad.stud.ntnu.no\tianzuoy\Desktop\Thesisdata.txt');

%------------------------------Chapter 1. Notation of Generic Response System--------------------------------%

%----------------------------Chapter 2. Joint Probability Distribution Function--------------------------------%

%------------------------------Scatter Diagram-----------------------------------%

%find largest and lowest wave height and wave period%
Hs_max_real=max(Wdata(:,7));      
Hs_min_real=min(Wdata(:,7));     
Tp_max_real=max(Wdata(:,8));     
Tp_min_real=min(Wdata(:,8));   

Hs_max=17;    %manually find%
Hs_min=0;     %manually find%
Tp_max=23;    %manually find%
Tp_min=2;     %manually find%

%now we use wave height i as column, use wave period j as row%
n=length(Wdata(:,7));
interval_hs=0.5;
interval_tp=1;
scatter=zeros(Hs_max/interval_hs,(Tp_max-Tp_min)/interval_tp);

for k=1:1:n;
    for i=Hs_min/interval_hs:1:Hs_max/interval_hs-1;
        for j=Tp_min/interval_tp:1:Tp_max/interval_tp-1;
            if (Wdata(k,7)>i*0.5)&(Wdata(k,7)<=i*0.5+0.5)&(Wdata(k,8)>j)&(Wdata(k,8)<=j+1);
                scatter(i+1,j-1)=scatter(i+1,j-1)+1;
            end
        end
    end
end
N=sum(sum(scatter,2));

%------------------------------Distribution of Hs-----------------------------------%

%get the probability by plotting on the probability paper, need define interval for the cumulative function%
interval=0.2;
num_row=17/interval-1;                         %because the minimum wave height is 0.3, so there will be no wave in interval 0-0.2%
h_distribution=zeros(num_row,1);

for i=1:1:num_row
    for j=1:1:163133
        if (Wdata(j,7)>(i*interval))&(Wdata(j,7)<=(i+1)*interval)
            h_distribution(i,1)=h_distribution(i,1)+1;
        end
    end
end

fHm0=zeros(num_row,1);
for i=1:1:num_row
    fHm0(i,1)=h_distribution(i,1)/(N+1);
    h_s(i,1)=i*interval;
    ln_h_s(i,1)=log(i*interval);
end

F_H=cumsum(fHm0);
y=log(-log(1-F_H));

%In this thesis, we use three parameter Weibull distribution.%

lp=0:0.2:(2-0.2);    %lp: location parameter. By experience that lp should be less than 1. So the range is taken from 0 to 2 with an interval of 0.2%
ln_hs=zeros(num_row,2/0.2);
      
for i=1:1:num_row
    for j=1:1:2/0.2
              ln_hs(i,j)=log(h_s(i)-lp(j));
    end
end

kay_1=zeros(2/0.2,1);
lamda_1=zeros(2/0.2,1);
devia_1=zeros(2/0.2,1);


for i=1:1:2/0.2
  [cfun,gof,output]=fit(ln_hs(i:num_row,i),y(i:num_row,1),'poly1');
  cfun;
  gof;
  output;
  kay_1(i,1)=cfun.p1;
  lamda_1(i,1)=exp(-cfun.p2/cfun.p1);
    for j=i:1:num_row
        devia_1(i,1)=devia_1(i,1)+(kay_1(i,1)*ln_hs(j,i)-kay_1(i,1)*log(lamda_1(i,1))-y(j,1))^2;
    end
        devia_1(i,1)=(devia_1(i,1)/(num_row-i))^0.5;
end
                                                  
lp_final=0.4;
kay_1_final=1.2851;
lamda_1_final=2.2491;


hs_extr=zeros(6,1);
q_extr=[0.63;0.1;0.01;0.001;0.0001;0.00001];
for i=1:1:6
%     hs_extr(i,1)=exp(1/kay_1_final*log(-log(1-q_extr(i)/2920))+log(lamda_1_final))+lp_final;
    hs_extr(i,1)=lamda_1_final*(-log(q_extr(i)/2920))^(1/kay_1_final)+lp_final;
end
  
%-------------------Distribution of T_p given H_s-------------------------%

%first get mean and variance number of Tp in each interval%

for i=0:1:(num_row-1)
    index=find(Wdata(:,7)>(i*interval)&Wdata(:,7)<=(i*interval)+1);
    Length_tp=length(index);
    Tp_mean(i+1)=sum(log(Wdata(index,8)))/Length_tp;
    Tp_var(i+1)=sum((log(Wdata(index,8))).^2)/Length_tp-(Tp_mean(i+1)).^2;
end

%now the nonlinear fit for miu and var%
p=[-1;1;-1];                                                           %define two initial value%
q=[0.0011;0.1147;0.308];
mu=@(p,x)(p(1)+p(2)*x.^p(3));                                          %function of the variable%
varia=@(q,x)(q(1)+q(2)*exp(-x.*q(3)));

% p_val=nlinfit(Hs_ran(2:(17/interval+1)),Tp_mean,mu,p);                 %nonlinear fit process%
% q_val=nlinfit(Hs_ran(2:(17/interval+1)),Tp_var,varia,q);

p_val=[1.09;1.019;0.2];                                                %by studying the automatic fitting, some optimized value has been proposed%

Hs_estm_max=25;
Tp_estm_max=30;

for i=1:1:Hs_estm_max/interval+1
    Hs_ran(i,1)=(i-1)*interval;
end

mu_val=p_val(1)+p_val(2).*Hs_ran(1:Hs_estm_max/interval).^p_val(3);
% q_val=[0.00073;0.1122;0.32];    
% q_val=[0.001;0.0992;0.30]; 
% q_val=[0.003;0.1022;0.33];
q_val=[0.005;0.1022;0.36];  

sig_val=q_val(1)+q_val(2).*exp(-Hs_ran(1:Hs_estm_max/interval).*q_val(3));


%-----------------------Verification of Joint Distribution Function-------------------------%

%get the probability density for each interval of hs%
scatter_veri_hs_bs=zeros(Hs_estm_max/interval,1);    %before scale%
scatter_veri_hs=zeros(Hs_estm_max/interval,1);       %after scale%

for i=3:1:round(Hs_estm_max/interval)-1
    scatter_veri_hs_bs(i,1)=(1-exp(-((Hs_ran(i+1)-lp_final)/lamda_1_final)^kay_1_final))-(1-exp(-((Hs_ran(i)-lp_final)/lamda_1_final)^kay_1_final));
end

P_veri_hs_bs=sum(scatter_veri_hs_bs); 

for i=3:1:round(Hs_estm_max/interval)-1
    scatter_veri_hs(i,1)=scatter_veri_hs_bs(i,1)/P_veri_hs_bs;
end
P_veri_hs=sum(scatter_veri_hs); 

 %get the probability for tp given hs%
scatter_veri_tp_bs=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
scatter_veri_tp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
P_veri_tp_bs=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp_bs(i,j)=(0.5*erfc(-(log(j*interval)-mu_val(i))/(sig_val(i)^0.5*2^0.5)))-(0.5*erfc(-(log((j-1)*interval)-mu_val(i))/(sig_val(i)^0.5*2^0.5)));
    end
end

P_veri_tp_bs=sum(scatter_veri_tp_bs,2);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp(i,j)=scatter_veri_tp_bs(i,j)/P_veri_tp_bs(i,1);
    end
end

P_veri_tp=sum(scatter_veri_tp,2);

%get the probability for each hs and tp interval%
scatter_veri_hstp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_hstp(i,j)=scatter_veri_hs(i,1)*scatter_veri_tp(i,j);
    end
end

P_veri_hstp=sum(sum(scatter_veri_hstp,2));

%---------------------------------Chapter 3. Uncertainty Quatification-----------------------------------%

c_1=1;     %scale coefficient for location parameter%
c_2=1;     %coefficient which control linear and quadratic%
c_3=1;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=100;   %coefficient which control sensitive to period or not%
c_6=0.1;   %measure of variability around the mean 30-minute maximum%

% f_hstp=kay_1_final/lamda_1_final*((hs-lp)/lamda_1_final)^(kay_1_final-1)*exp(-((hs-lp)/lamda_1_final)^kay_1_final)*    1/(tp*(2*pi*(q(1)+q(2)*exp(-hs*q(3))))^0.5)*exp(-0.5*((log(tp)-(p(1)+p(2)*hs^p(3)))/(q(1)+q(2)*exp(-hs*q(3))))^2);  
                                                                                                                                                                  
% F_x_hstp=exp(-exp((-x+(c_1*hs^c_2*(1+(cos((2*pi*(tp-c_4)/c_5)))^c_3)-0.57722*(0.7797*c_2*c_6*(c_1*hs^c_2*(1+(cos((2*pi*(tp-c_4)/c_5)))^c_3)))))/(0.7797*c_2*c_6*(c_1*hs^c_2*(1+(cos((2*pi*(tp-c_4)/c_5)))^c_3)))));

%using definition of integration%
scatter_rsp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);        %matrix of response for all sea state%
scatter_rsp_hstp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);   %matrix of response for each hs and tp interval%
int=1;
if c_2==1&&c_5==100
    X_extm_max=67;                     %define X_estm_max=160 is because P_veri_rsp(X_estm_max=160)=1.000000(exact 1), so X_estm_max=160 is a safe estimation of maximum response value%
else if c_2==2&&c_5==100
        X_extm_max=1420;
    else if c_2==1&&c_5==60
            X_extm_max=53;
        else 
            X_extm_max=756;
        end
    end
end
P_veri_rsp=zeros(X_extm_max/int,1);
Ad_y=zeros(X_extm_max/int,1);                                        %fitted y value for Gumbel distribution%
Ad_y_fit=zeros(X_extm_max/int,1); 

hs_rsp=zeros(Hs_estm_max/interval,1);  %middle point for each hs interval%     
tp_rsp=zeros(Tp_estm_max/interval,1);  %middle point for each tp interval%
scatter_rsp_hstp_veri=zeros(Hs_estm_max/interval,Tp_estm_max/interval);

%problem may lies in how to get the scatter diagram, should be F(x+1)-F(x), not each F(x) for each x%
for k=1:1:2000
    x(k,1)=k;
end

for k=1:1:X_extm_max/int
    for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        x(k,1)=k;
        hs_rsp(i,1)=(i-0.5)*interval;
        tp_rsp(j,1)=(j-0.5)*interval;
        
        scatter_rsp_hstp(i,j)=exp(-exp((-x(k)+(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)-0.57722*(0.7797*c_2*c_6*(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)))))/(0.7797*c_2*c_6*(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)))));
        scatter_rsp(i,j)=scatter_veri_hstp(i,j)*scatter_rsp_hstp(i,j);
%         miu=(c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3))
%         sig=(c_2*c_6*c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3))
%         alfa=((c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3))-0.57722*0.7797*(c_2*c_6*c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3)))
%         beta=(0.7797*(c_2*c_6*c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3)))
    end
    end
    P_veri_rsp(k,1)=sum(sum(scatter_rsp,2));
    Ad_y(k,1)=-log(-log(P_veri_rsp(k,1)));
end

%The corresponding exceedance per 3-hour sea state is 10e-5/2920 = 1/292000000. The corresponding cumulative probability = 1-1/292000000. 
%If introduce into ln (-ln (F)) you get 19.49. There is no need to go higher response levels than what corresponds to 20.
%In the Ad_y matrix, Ad_y(94,1)=19.9768, >19.49. Thus only consier values below 94
index=find(Ad_y(:,1)>10&Ad_y(:,1)<20);               %purpose is to do a better fitting for tail data, not affected by the previous data%
C=find(Ad_y(:,1)>10&Ad_y(:,1)<20,1,'last');            %find the last original data needed in the plot%
D=find(Ad_y(:,1)>10&Ad_y(:,1)<20,1,'first');
Q=C+10/int;

[dfun,gof,output]=fit(x(index),Ad_y(index),'poly1');
dfun;
gof;
output;

for k=1:1:X_extm_max/int
    Ad_y_fit(k,1)=dfun.p1*x(k)+dfun.p2;
end


%verification of fitted model%
F_10=1-1/(10*365*24/3);
F_100=1-1/(100*365*24/3);          %ULS case%
F_10000=1-1/(10000*365*24/3);      %ALS case%

x_10=1/dfun.p1*(-dfun.p2+(-log(-log(F_10))));
x_100=1/dfun.p1*(-dfun.p2+(-log(-log(F_100))))
x_10000=1/dfun.p1*(-dfun.p2+(-log(-log(F_10000))))



%non-exceedance,exceedance for response and relative cases%
scatter_nonex=zeros(Hs_estm_max/interval,Tp_estm_max/interval);        %scatter diagram for non-exceedance probability for given hs and tp%
scatter_ex=zeros(Hs_estm_max/interval,Tp_estm_max/interval);           %scatter diagram for exceedance probability for given hs and tp%
scatter_ex_rsp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);       %scatter diagram for exceedance probability for generic cases%
scatter_rel_ex_rsp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);   %scatter diagram for relative exceedance probability for generic cases%

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        hs_rsp(i,1)=(i-0.5)*interval;
        tp_rsp(j,1)=(j-0.5)*interval;
        scatter_nonex(i,j)=exp(-exp((-x_100+(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)-0.57722*(0.7797*c_2*c_6*(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)))))/(0.7797*c_2*c_6*(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)))));
        scatter_ex(i,j)=1-scatter_nonex(i,j);
        scatter_ex_rsp(i,j)=scatter_veri_hstp(i,j)*scatter_ex(i,j);
    end
end

A=sum(sum(scatter_ex_rsp,2));
for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_rel_ex_rsp(i,j)=scatter_ex_rsp(i,j)/A;
    end
end


%contour line of scatter_rsp%
Codn=zeros(Hs_estm_max/interval*Tp_estm_max/interval,3);
for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        Codn(Tp_estm_max/interval*i-Tp_estm_max/interval+j,1)=hs_rsp(i,1);
        Codn(Tp_estm_max/interval*i-Tp_estm_max/interval+j,2)=tp_rsp(j,1);
        Codn(Tp_estm_max/interval*i-Tp_estm_max/interval+j,3)=scatter_rel_ex_rsp(i,j);
    end
end

% figure(31)     %the question here is how to plot scatter_rel_ex_rsp%
% [HS TP] = meshgrid(9:0.005:20, 14.5:0.005:19);
% RSP = griddata(Codn(:,1), Codn(:,2), Codn(:,3), HS, TP);
% F = [.05 .1 .05; .1 .4 .1; .05 .1 .05];
% ZC = conv2(RSP,F,'same');
% ZC1= conv2(ZC,F,'same');
% zlevs = 0.01:0.016:0.23;
% contour(HS, TP, ZC1, zlevs, 'ShowText','on')
% ylabel('TP','FontWeight','bold','FontSize',16);
% xlabel('HS','FontWeight','bold','FontSize',16);
% % axis([11 20 15 19])
% colormap cool
% set(gca,'YDir','Reverse')


%--------------------------------------------Below Belong to Chapter 2--------------------------------------------------%

 %some figures for fitting of tp given hs%     
 %first, method of moment. Find mu_tp and sig_tp, with known distribution function, using autofitting tool in matlab to find the parameters%
I=6;
J=Tp_estm_max;
F_tp_mom=zeros(I,150);
inte=2;
Tp_mean_mom=zeros(I,1);        %8 is (Hs_estm-1)/2%
Tp_var_mom=zeros(I,1);
F_tp=zeros(I,150);                      %I take ten examples from hs(2,4,6,8,..., 20)and get each hs's cumulative probability for increasing tp%
F_tp_real=zeros(I,150);
ln_tp=zeros(150,1);
X=zeros(150,I);


for i=1:1:I
    index=find(Wdata(:,7)>(i*inte-interval)&Wdata(:,7)<=(i*inte));
    Length_tp=length(index);
    Tp_mean_mom(i)=sum(log(Wdata(index,8)))/Length_tp;
    Tp_var_mom(i)=sum((log(Wdata(index,8))).^2)/Length_tp-(Tp_mean_mom(i)).^2;
   
   for j=1:1:150   
     F_tp_mom(i,j)=0.5*erfc(-(log(tp_rsp(j))-Tp_mean_mom(i))/(2*Tp_var_mom(i))^0.5);
     index_hs=find((Wdata(:,7)<hs_rsp(10*i)+0.1)&(Wdata(:,7)>hs_rsp(10*i)-0.1));
     index_tp_hs=find((Wdata(:,8)<j*0.2)&(Wdata(:,7)<hs_rsp(10*i)+0.1)&(Wdata(:,7)>hs_rsp(10*i)-0.1));
     F_tp_real(i,j)=length(index_tp_hs)/length(index_hs);
     ln_tp(j)=log(tp_rsp(j));
     X(j,i)=norminv(F_tp_real(i,j),0,1);
   end
   
end
   
%seconde, use linear fitting method
miu_2=zeros(I,1);
sig_2=zeros(I,1);

for i=1:1:6
    index=find(X(:,i)>-10&X(:,i)<10);      
    [cfun,gof,output]=fit(ln_tp(index),X(index,i),'poly1');
    cfun;
    gof;
    output;
    sig_2(i,1)=1/cfun.p1;
    miu_2(i,1)=-cfun.p2/cfun.p1;

end
% comparison for the previous two methods, whcih simulates better?
%--------------------------------------------Previous Belong to Chapter 2--------------------------------------------------%


%environmental contour line method%
B=norminv(0.01/2920);                                 %here remains the question how to find the approximate number but not integral, i.e. 4.4983 to 4.5 but not 5%
R_max_100=4.5;                                        %radius for the 10e-2 annual probability sphere%
int=0.1;                                              %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                      %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_100=zeros((R_max_100*2/int)*2+1,2);         %coordinates for each point in the physical space%


for i=1:1:R_max_100*2/int+1
    u_1(i,1)=-R_max_100+int*(i-1);
    u_2(i,1)=(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con=q_val(1)+q_val(2)*exp(-h(i,1)*q_val(3));
    t(i,1)=exp(mu_val_con+sig_val_con^0.5*u_2(i,1));
end

for i=R_max_100*2/int+2:1:(R_max_100*2/int)*2+1
    u_1(i,1)=R_max_100-int*(i-R_max_100*2/int-1);
    u_2(i,1)=-(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con=q_val(1)+q_val(2)*exp(-h(i,1)*q_val(3));
    t(i,1)=exp(mu_val_con+sig_val_con^0.5*u_2(i,1));
end

for i=1:1:(R_max_100*2/int)*2+1
    Codn_cont_100(i,1)=h(i,1);
    Codn_cont_100(i,2)=t(i,1);
end
   
R_max_10000=5.4;                                        %radius for the 10e-4 annual probability sphere%
int=0.1;                                                %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                        %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_10000=zeros((R_max_10000*2/int)*2+1,2);       %coordinates for each point in the physical space%


for i=1:1:R_max_10000*2/int+1
    u_1(i,1)=-R_max_10000+int*(i-1);
    u_2(i,1)=(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con=q_val(1)+q_val(2)*exp(-h(i,1)*q_val(3));
    t(i,1)=exp(mu_val_con+sig_val_con^0.5*u_2(i,1));
end

for i=R_max_10000*2/int+2:1:(R_max_10000*2/int)*2+1
    u_1(i,1)=R_max_10000-int*(i-R_max_10000*2/int-1);
    u_2(i,1)=-(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con=q_val(1)+q_val(2)*exp(-h(i,1)*q_val(3));
    t(i,1)=exp(mu_val_con+sig_val_con^0.5*u_2(i,1));
end

for i=1:1:(R_max_10000*2/int)*2+1
    Codn_cont_10000(i,1)=h(i,1);
    Codn_cont_10000(i,2)=t(i,1);
end
   
figure(32)
% h1=plot(Codn_cont_100(:,1),Codn_cont_100(:,2),'b','LineWidth',4);
% hold on;
% h2=plot(Codn_cont_10000(:,1),Codn_cont_10000(:,2),'LineWidth',4);
% hold on;
[HS TP] = meshgrid(9:0.005:20, 14.5:0.005:19);
RSP = griddata(Codn(:,1), Codn(:,2), Codn(:,3), HS, TP);
F = [.05 .1 .05; .1 .4 .1; .05 .1 .05];
ZC = conv2(RSP,F,'same');
ZC1= conv2(ZC,F,'same');
zlevs = 0.001:0.005:0.03;
contour(HS, TP, ZC1, zlevs, 'ShowText','on')

xlabel('Significant Wave Height H_s(m)','FontWeight','bold','FontSize',25);
ylabel('Spectral Peak Period T_p(s)','FontWeight','bold','FontSize',25);
axis([8 20 10 20])
set(gca,'fontsize',25)
AX=legend([h1],'10e^{-2} Annual Probability Contour Line','Location','NorthEast');
LEG = findobj(AX,'type','text');
set(LEG,'FontSize',25)
colormap cool
% set(gca,'YDir','Reverse')



y_tt=zeros(301,1);
t_p_tt=zeros(301,1);

figure(33)
for x_tt=1:3:25
  for i=1:1:301
    t_p_tt(i,1)=0.1*i-0.1;
    y_tt(i,1)=1/(t_p_tt(i,1)*(2*pi*(0.005+0.1022*exp(-0.36*x_tt)))^0.5)*exp(-(log(t_p_tt(i,1))-(1.09+1.019*x_tt^0.2))^2/(2*(0.005+0.1022*exp(-0.36*x_tt))));
  end
    h1=plot(t_p_tt(:,1), y_tt(:,1),'color',rand(1,3),'LineWidth',2);
    hold on;
%     hold on;
%     h2=plot([15.7,15.7],[0,0.298],'m','LineWidth',2);
%     hold on;
%     h3=plot([14.9,14.9],[0,0.294],'m','LineWidth',2);    
    legend([h1],'Density Probability for Peak Period for different h_s=x m','Location','SouthEast');
    ylabel('Probability Value','FontWeight','bold','FontSize',16);
    xlabel('Peak Period','FontWeight','bold','FontSize',16);
end

% % SINCE THERE IS A CORRECTION ON THE CODE OF IMPORTANT CONTRIBUTION AREA,
% % THUS THE VERIFICATION CODE IS NO LONGER NECESSARY.
% figure(34)
% for x_tt=15          %value of H_s, for NPS case, H_s=15, for PS case, H_s=11%
%   for i=1:1:301
%     t_p_tt(i,1)=0.1*i-0.1;
%     y_tt(i,1)=1/(t_p_tt(i,1)*(2*pi*(0.005+0.1022*exp(-0.36*x_tt)))^0.5)*exp(-(log(t_p_tt(i,1))-(1.09+1.019*x_tt^0.2))^2/(2*(0.005+0.1022*exp(-0.36*x_tt))));
%   end
%     h1=plot(t_p_tt(:,1), y_tt(:,1),'b','LineWidth',2);
%     hold on;
%     h2=plot([16.7,16.7],[0,0.303],'--m','LineWidth',2);
%     hold on;
%     h3=plot([17.5,17.5],[0,0.294],'--m','LineWidth',2);
% %     hold on;
% %     h2=plot([15.7,15.7],[0,0.298],'--m','LineWidth',2);
% %     hold on;
% %     h3=plot([14.9,14.9],[0,0.294],'--m','LineWidth',2); 
%     
%     legend([h1 h2],'Density Probability for Peak Period when h_s=15m','t_p=16.7s, 17.5s','Location','SouthEast');
%     ylabel('Probability Value','FontWeight','bold','FontSize',16);
%     xlabel('Peak Period','FontWeight','bold','FontSize',16);
% end

