clc
clf
clear all
close all
Wdata=load('\\sambaad.stud.ntnu.no\tianzuoy\Desktop\Thesisdata.txt');

%------------------------------Chapter 1. Notation of Generic Response System--------------------------------%


%----------------------------Chapter 2. Joint Probability Distribution Function--------------------------------%

%------------------------------Scatter Diagram-----------------------------------%

%find largest and lowest wave height and wave period%
Hs_max_real=max(Wdata(:,7));      
Hs_min_real=min(Wdata(:,7));     
Tp_max_real=max(Wdata(:,8));     
Tp_min_real=min(Wdata(:,8));   

Hs_max=17;    %manually find%
Hs_min=0;     %manually find%
Tp_max=23;    %manually find%
Tp_min=2;     %manually find%

%now we use wave height i as column, use wave period j as row%
n=length(Wdata(:,7));
interval_hs=0.5;
interval_tp=1;
scatter=zeros(Hs_max/interval_hs,(Tp_max-Tp_min)/interval_tp);

for k=1:1:n;
    for i=Hs_min/interval_hs:1:Hs_max/interval_hs-1;
        for j=Tp_min/interval_tp:1:Tp_max/interval_tp-1;
            if (Wdata(k,7)>i*0.5)&(Wdata(k,7)<=i*0.5+0.5)&(Wdata(k,8)>j)&(Wdata(k,8)<=j+1);
                scatter(i+1,j-1)=scatter(i+1,j-1)+1;
            end
        end
    end
end
N=sum(sum(scatter,2));

%------------------------------Distribution of Hs-----------------------------------%

%get the probability by plotting on the probability paper, need define interval for the cumulative function%
interval=0.2;
num_row=17/interval-1;                         %because the minimum wave height is 0.3, so there will be no wave in interval 0-0.2%
h_distribution=zeros(num_row,1);

for i=1:1:num_row
    for j=1:1:163133
        if (Wdata(j,7)>(i*interval))&(Wdata(j,7)<=(i+1)*interval)
            h_distribution(i,1)=h_distribution(i,1)+1;
        end
    end
end

fHm0=zeros(num_row,1);
for i=1:1:num_row
    fHm0(i,1)=h_distribution(i,1)/(N+1);
    h_s(i,1)=i*interval;
    ln_h_s(i,1)=log(i*interval);
end

F_H=cumsum(fHm0);
y=log(-log(1-F_H));

%In this thesis, we use three parameter Weibull distribution.%

lp=0:0.2:(2-0.2);    %lp: location parameter. By experience that lp should be less than 1. So the range is taken from 0 to 2 with an interval of 0.2%
ln_hs=zeros(num_row,2/0.2);
      
for i=1:1:num_row
    for j=1:1:2/0.2
              ln_hs(i,j)=log(h_s(i)-lp(j));
    end
end

kay_1=zeros(2/0.2,1);
lamda_1=zeros(2/0.2,1);
devia_1=zeros(2/0.2,1);


for i=1:1:2/0.2
  [cfun,gof,output]=fit(ln_hs(i:num_row,i),y(i:num_row,1),'poly1');
  cfun;
  gof;
  output;
  kay_1(i,1)=cfun.p1;
  lamda_1(i,1)=exp(-cfun.p2/cfun.p1);
    for j=i:1:num_row
        devia_1(i,1)=devia_1(i,1)+(kay_1(i,1)*ln_hs(j,i)-kay_1(i,1)*log(lamda_1(i,1))-y(j,1))^2;
    end
        devia_1(i,1)=(devia_1(i,1)/(num_row-i))^0.5;
end

% figure(5)
% h1=plot(lp(1:2/0.2),devia_1,'r.','MarkerSize',5);    %as can be seen from the figure, when lp=0.4, the deviation has the minimum value.%
%                                                   %when lp=0.4, lamda_1= , kay_1= %
% ylabel('Standard Deviation','FontWeight','bold','FontSize',16);
% xlabel('Location Parameter','FontWeight','bold','FontSize',16);
% axis([0 2 0 0.4]);

% now use eye fittinig B)%
% for i=1:1:5               %here it plots when lp=0, 0.2, 0.4, 0.6, 0.8%
%     figure(i+5)
%     h1=plot(ln_hs(i:84,i),y(i:84,1),'r.','MarkerSize',5);
%     ylabel('ln(-ln(1-F(h_s)))','FontWeight','bold','FontSize',16);
%     xlabel('ln(h_s-lp)','FontWeight','bold','FontSize',16);
%     hold on;
%     h2=plot(ln_hs(i:84,i),kay_1(i,1)*ln_hs(i:84,i)-kay_1(i,1)*log(lamda_1(i,1)),'LineWidth',2);
%     legend([h1 h2],'Original Points','Fitted Curve','Location','SouthEast');
% end                       %by both diviation and eye fitting, we can see that when lp=0.4, it is the best fit%
                                                   
lp_final=0.4;
kay_1_final=1.2851;
lamda_1_final=2.2491;

% figure(11)
% y_fig2=zeros(84,1);
% for i=1:1:84
%     y_fig2(i,1)=1-exp(-((h_s(i,1)-lp_final)/lamda_1_final)^kay_1_final);
% end
% h1=plot(h_s(3:84),y_fig2(3:84),'LineWidth',2);
% hold on;
% h2=plot(h_s(1:84),F_H(1:84),'r.','MarkerSize',5);
% 
% legend([h1 h2],'Fitted Curve','Original Points');
% ylabel('Cumulative Probability of h_s','FontWeight','bold','FontSize',16);
% xlabel('h_s','FontWeight','bold','FontSize',16);
% axis([0 18 0 1.2])

hs_extr=zeros(6,1);
q_extr=[0.63;0.1;0.01;0.001;0.0001;0.00001];
for i=1:1:6
%     hs_extr(i,1)=exp(1/kay_1_final*log(-log(1-q_extr(i)/2920))+log(lamda_1_final))+lp_final;
    hs_extr(i,1)=lamda_1_final*(-log(q_extr(i)/2920))^(1/kay_1_final)+lp_final;
end
  
%-------------------Distribution of T_p given H_s-------------------------%

%first get mean and variance number of Tp in each interval%

for i=0:1:(num_row-1)
    index=find(Wdata(:,7)>(i*interval)&Wdata(:,7)<=(i*interval)+1);
    Length_tp=length(index);
    Tp_mean(i+1)=sum(log(Wdata(index,8)))/Length_tp;
    Tp_var(i+1)=sum((log(Wdata(index,8))).^2)/Length_tp-(Tp_mean(i+1)).^2;
end

%now the nonlinear fit for miu and var%
p=[-1;1;-1];                                                           %define two initial value%
q=[0.0011;0.1147;0.308];
mu=@(p,x)(p(1)+p(2)*x.^p(3));                                          %function of the variable%
varia=@(q,x)(q(1)+q(2)*exp(-x.*q(3)));

p_val=[1.09;1.019;0.2];                                                %by studying the automatic fitting, some optimized value has been proposed%

Hs_estm_max=25;
Tp_estm_max=30;

for i=1:1:Hs_estm_max/interval+1
    Hs_ran(i,1)=(i-1)*interval;
end

mu_val=p_val(1)+p_val(2).*Hs_ran(1:Hs_estm_max/interval).^p_val(3);
q_val_1=[0.00073;0.1122;0.32];    
q_val_2=[0.001;0.0992;0.30]; 
q_val_3=[0.003;0.1022;0.33];
q_val_4=[0.005;0.1022;0.36];  

sig_val_1=q_val_1(1)+q_val_1(2).*exp(-Hs_ran(1:Hs_estm_max/interval).*q_val_1(3));
sig_val_2=q_val_2(1)+q_val_2(2).*exp(-Hs_ran(1:Hs_estm_max/interval).*q_val_2(3));
sig_val_3=q_val_3(1)+q_val_3(2).*exp(-Hs_ran(1:Hs_estm_max/interval).*q_val_3(3));
sig_val_4=q_val_4(1)+q_val_4(2).*exp(-Hs_ran(1:Hs_estm_max/interval).*q_val_4(3));

% figure(13)
% h1=plot(Hs_ran(2:76),Tp_var(2:76),'r*','MarkerSize',8);
% hold on;
% h2=plot(Hs_ran(1:Hs_estm_max/interval),sig_val_1,'-r','LineWidth',3);
% hold on;
% h3=plot(Hs_ran(1:Hs_estm_max/interval),sig_val_2,'--g','LineWidth',3);
% hold on;
% h4=plot(Hs_ran(1:Hs_estm_max/interval),sig_val_3,'-.b','LineWidth',3);
% hold on;
% h5=plot(Hs_ran(1:Hs_estm_max/interval),sig_val_4,':k','LineWidth',3);
% ylabel('Standard Deviation of ln(T_p) given H_s','FontWeight','bold','FontSize',25);
% xlabel('H_s(m)','FontWeight','bold','FontSize',25);
% AX=legend([h1 h2 h3 h4 h5],'original data','lower bound is 0.00073','lower bound is 0.001','lower bound is 0.003','lower bound is 0.005');
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',25)
% axis([0 25 0 0.12]);
% set(gca,'fontsize',25)

%-----------------------Verification of Joint Distribution Function-------------------------%

%get the probability density for each interval of hs%
scatter_veri_hs_bs=zeros(Hs_estm_max/interval,1);    %before scale%
scatter_veri_hs=zeros(Hs_estm_max/interval,1);       %after scale%

for i=3:1:round(Hs_estm_max/interval)-1
    scatter_veri_hs_bs(i,1)=(1-exp(-((Hs_ran(i+1)-lp_final)/lamda_1_final)^kay_1_final))-(1-exp(-((Hs_ran(i)-lp_final)/lamda_1_final)^kay_1_final));
end

P_veri_hs_bs=sum(scatter_veri_hs_bs); 

for i=3:1:round(Hs_estm_max/interval)-1
    scatter_veri_hs(i,1)=scatter_veri_hs_bs(i,1)/P_veri_hs_bs;
end
P_veri_hs=sum(scatter_veri_hs); 

%1. get the probability for tp given hs%
scatter_veri_tp_bs_1=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
scatter_veri_tp_1=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
P_veri_tp_bs_1=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp_bs_1(i,j)=(0.5*erfc(-(log(j*interval)-mu_val(i))/(sig_val_1(i)*2^0.5)))-(0.5*erfc(-(log((j-1)*interval)-mu_val(i))/(sig_val_1(i)*2^0.5)));
    end
end

P_veri_tp_bs_1=sum(scatter_veri_tp_bs_1,2);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp_1(i,j)=scatter_veri_tp_bs_1(i,j)/P_veri_tp_bs_1(i,1);
    end
end

P_veri_tp_1=sum(scatter_veri_tp_1,2);

%get the probability for each hs and tp interval%
scatter_veri_hstp_1=zeros(Hs_estm_max/interval,Tp_estm_max/interval);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_hstp_1(i,j)=scatter_veri_hs(i,1)*scatter_veri_tp_1(i,j);
    end
end

P_veri_hstp_1=sum(sum(scatter_veri_hstp_1,2));

%environmental contour line method%
B=norminv(0.01/2920);                                 %here remains the question how to find the approximate number but not integral, i.e. 4.4983 to 4.5 but not 5%
R_max_100=4.5;                                        %radius for the 10e-2 annual probability sphere%
int=0.1;                                              %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                      %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t_1=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_100_1=zeros((R_max_100*2/int)*2+1,2);         %coordinates for each point in the physical space%


for i=1:1:R_max_100*2/int+1
    u_1(i,1)=-R_max_100+int*(i-1);
    u_2(i,1)=(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_1=q_val_1(1)+q_val_1(2)*exp(-h(i,1)*q_val_1(3));
    t_1(i,1)=exp(mu_val_con+sig_val_con_1^0.5*u_2(i,1));
end

for i=R_max_100*2/int+2:1:(R_max_100*2/int)*2+1
    u_1(i,1)=R_max_100-int*(i-R_max_100*2/int-1);
    u_2(i,1)=-(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_1=q_val_1(1)+q_val_1(2)*exp(-h(i,1)*q_val_1(3));
    t_1(i,1)=exp(mu_val_con+sig_val_con_1^0.5*u_2(i,1));
end

for i=1:1:(R_max_100*2/int)*2+1
    Codn_cont_100_1(i,1)=h(i,1);
    Codn_cont_100_1(i,2)=t_1(i,1);
end
   
R_max_10000=5.4;                                        %radius for the 10e-4 annual probability sphere%
int=0.1;                                                %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                        %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t_1=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_10000_1=zeros((R_max_10000*2/int)*2+1,2);       %coordinates for each point in the physical space%


for i=1:1:R_max_10000*2/int+1
    u_1(i,1)=-R_max_10000+int*(i-1);
    u_2(i,1)=(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_1=q_val_1(1)+q_val_1(2)*exp(-h(i,1)*q_val_1(3));
    t_1(i,1)=exp(mu_val_con+sig_val_con_1^0.5*u_2(i,1));
end

for i=R_max_10000*2/int+2:1:(R_max_10000*2/int)*2+1
    u_1(i,1)=R_max_10000-int*(i-R_max_10000*2/int-1);
    u_2(i,1)=-(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_1=q_val_1(1)+q_val_1(2)*exp(-h(i,1)*q_val_1(3));
    t_1(i,1)=exp(mu_val_con+sig_val_con_1^0.5*u_2(i,1));
end

for i=1:1:(R_max_10000*2/int)*2+1
    Codn_cont_10000_1(i,1)=h(i,1);
    Codn_cont_10000_1(i,2)=t_1(i,1);
end
   

%2. get the probability for tp given hs%
scatter_veri_tp_bs_2=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
scatter_veri_tp_2=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
P_veri_tp_bs_2=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp_bs_2(i,j)=(0.5*erfc(-(log(j*interval)-mu_val(i))/(sig_val_2(i)*2^0.5)))-(0.5*erfc(-(log((j-1)*interval)-mu_val(i))/(sig_val_2(i)*2^0.5)));
    end
end

P_veri_tp_bs_2=sum(scatter_veri_tp_bs_2,2);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp_2(i,j)=scatter_veri_tp_bs_2(i,j)/P_veri_tp_bs_2(i,1);
    end
end

P_veri_tp_2=sum(scatter_veri_tp_2,2);

%get the probability for each hs and tp interval%
scatter_veri_hstp_2=zeros(Hs_estm_max/interval,Tp_estm_max/interval);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_hstp_2(i,j)=scatter_veri_hs(i,1)*scatter_veri_tp_2(i,j);
    end
end

P_veri_hstp_2=sum(sum(scatter_veri_hstp_2,2));

%environmental contour line method%
B=norminv(0.01/2920);                                 %here remains the question how to find the approximate number but not integral, i.e. 4.4983 to 4.5 but not 5%
R_max_100=4.5;                                        %radius for the 10e-2 annual probability sphere%
int=0.1;                                              %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                      %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t_1=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_100_2=zeros((R_max_100*2/int)*2+1,2);         %coordinates for each point in the physical space%

for i=1:1:R_max_100*2/int+1
    u_1(i,1)=-R_max_100+int*(i-1);
    u_2(i,1)=(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_2=q_val_2(1)+q_val_2(2)*exp(-h(i,1)*q_val_2(3));
    t_2(i,1)=exp(mu_val_con+sig_val_con_2^0.5*u_2(i,1));
end

for i=R_max_100*2/int+2:1:(R_max_100*2/int)*2+1
    u_1(i,1)=R_max_100-int*(i-R_max_100*2/int-1);
    u_2(i,1)=-(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_2=q_val_2(1)+q_val_2(2)*exp(-h(i,1)*q_val_2(3));
    t_2(i,1)=exp(mu_val_con+sig_val_con_2^0.5*u_2(i,1));
end

for i=1:1:(R_max_100*2/int)*2+1
    Codn_cont_100_2(i,1)=h(i,1);
    Codn_cont_100_2(i,2)=t_2(i,1);
end
   
R_max_10000=5.4;                                        %radius for the 10e-4 annual probability sphere%
int=0.1;                                                %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                        %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t_2=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_10000_2=zeros((R_max_10000*2/int)*2+1,2);       %coordinates for each point in the physical space%


for i=1:1:R_max_10000*2/int+1
    u_1(i,1)=-R_max_10000+int*(i-1);
    u_2(i,1)=(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_2=q_val_2(1)+q_val_2(2)*exp(-h(i,1)*q_val_2(3));
    t_2(i,1)=exp(mu_val_con+sig_val_con_2^0.5*u_2(i,1));
end

for i=R_max_10000*2/int+2:1:(R_max_10000*2/int)*2+1
    u_1(i,1)=R_max_10000-int*(i-R_max_10000*2/int-1);
    u_2(i,1)=-(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_2=q_val_2(1)+q_val_2(2)*exp(-h(i,1)*q_val_2(3));
    t_2(i,1)=exp(mu_val_con+sig_val_con_2^0.5*u_2(i,1));
end

for i=1:1:(R_max_10000*2/int)*2+1
    Codn_cont_10000_2(i,1)=h(i,1);
    Codn_cont_10000_2(i,2)=t_2(i,1);
end

 %3. get the probability for tp given hs%
scatter_veri_tp_bs_3=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
scatter_veri_tp_3=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
P_veri_tp_bs_3=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp_bs_3(i,j)=(0.5*erfc(-(log(j*interval)-mu_val(i))/(sig_val_3(i)*2^0.5)))-(0.5*erfc(-(log((j-1)*interval)-mu_val(i))/(sig_val_3(i)*2^0.5)));
    end
end

P_veri_tp_bs_3=sum(scatter_veri_tp_bs_3,2);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp_3(i,j)=scatter_veri_tp_bs_3(i,j)/P_veri_tp_bs_3(i,1);
    end
end

P_veri_tp_3=sum(scatter_veri_tp_3,2);

%get the probability for each hs and tp interval%
scatter_veri_hstp_3=zeros(Hs_estm_max/interval,Tp_estm_max/interval);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_hstp_3(i,j)=scatter_veri_hs(i,1)*scatter_veri_tp_3(i,j);
    end
end

P_veri_hstp_3=sum(sum(scatter_veri_hstp_3,2));

%environmental contour line method%
B=norminv(0.01/2920);                                 %here remains the question how to find the approximate number but not integral, i.e. 4.4983 to 4.5 but not 5%
R_max_100=4.5;                                        %radius for the 10e-2 annual probability sphere%
int=0.1;                                              %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                      %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t_3=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_100_3=zeros((R_max_100*2/int)*2+1,2);         %coordinates for each point in the physical space%


for i=1:1:R_max_100*2/int+1
    u_1(i,1)=-R_max_100+int*(i-1);
    u_2(i,1)=(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_3=q_val_3(1)+q_val_3(2)*exp(-h(i,1)*q_val_3(3));
    t_3(i,1)=exp(mu_val_con+sig_val_con_3^0.5*u_2(i,1));
end

for i=R_max_100*2/int+2:1:(R_max_100*2/int)*2+1
    u_1(i,1)=R_max_100-int*(i-R_max_100*2/int-1);
    u_2(i,1)=-(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_3=q_val_3(1)+q_val_3(2)*exp(-h(i,1)*q_val_3(3));
    t_3(i,1)=exp(mu_val_con+sig_val_con_3^0.5*u_2(i,1));
end

for i=1:1:(R_max_100*2/int)*2+1
    Codn_cont_100_3(i,1)=h(i,1);
    Codn_cont_100_3(i,2)=t_3(i,1);
end
   
R_max_10000=5.4;                                        %radius for the 10e-4 annual probability sphere%
int=0.1;                                                %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                        %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t_3=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_10000_3=zeros((R_max_10000*2/int)*2+1,2);       %coordinates for each point in the physical space%


for i=1:1:R_max_10000*2/int+1
    u_1(i,1)=-R_max_10000+int*(i-1);
    u_2(i,1)=(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_3=q_val_3(1)+q_val_3(2)*exp(-h(i,1)*q_val_3(3));
    t_3(i,1)=exp(mu_val_con+sig_val_con_3^0.5*u_2(i,1));
end

for i=R_max_10000*2/int+2:1:(R_max_10000*2/int)*2+1
    u_1(i,1)=R_max_10000-int*(i-R_max_10000*2/int-1);
    u_2(i,1)=-(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_3=q_val_3(1)+q_val_3(2)*exp(-h(i,1)*q_val_3(3));
    t_3(i,1)=exp(mu_val_con+sig_val_con_3^0.5*u_2(i,1));
end

for i=1:1:(R_max_10000*2/int)*2+1
    Codn_cont_10000_3(i,1)=h(i,1);
    Codn_cont_10000_3(i,2)=t_3(i,1);
end

 %4. get the probability for tp given hs%
scatter_veri_tp_bs_4=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
scatter_veri_tp_4=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
P_veri_tp_bs_4=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp_bs_4(i,j)=(0.5*erfc(-(log(j*interval)-mu_val(i))/(sig_val_4(i)*2^0.5)))-(0.5*erfc(-(log((j-1)*interval)-mu_val(i))/(sig_val_4(i)*2^0.5)));
    end
end

P_veri_tp_bs_4=sum(scatter_veri_tp_bs_4,2);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp_4(i,j)=scatter_veri_tp_bs_4(i,j)/P_veri_tp_bs_4(i,1);
    end
end

P_veri_tp_4=sum(scatter_veri_tp_4,2);

%get the probability for each hs and tp interval%
scatter_veri_hstp_4=zeros(Hs_estm_max/interval,Tp_estm_max/interval);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_hstp_4(i,j)=scatter_veri_hs(i,1)*scatter_veri_tp_4(i,j);
    end
end

P_veri_hstp_4=sum(sum(scatter_veri_hstp_4,2));

%environmental contour line method%
B=norminv(0.01/2920);                                 %here remains the question how to find the approximate number but not integral, i.e. 4.4983 to 4.5 but not 5%
R_max_100=4.5;                                        %radius for the 10e-2 annual probability sphere%
int=0.1;                                              %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                      %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t_4=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_100_4=zeros((R_max_100*2/int)*2+1,2);         %coordinates for each point in the physical space%


for i=1:1:R_max_100*2/int+1
    u_1(i,1)=-R_max_100+int*(i-1);
    u_2(i,1)=(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_4=q_val_4(1)+q_val_4(2)*exp(-h(i,1)*q_val_4(3));
    t_4(i,1)=exp(mu_val_con+sig_val_con_4^0.5*u_2(i,1));
end

for i=R_max_100*2/int+2:1:(R_max_100*2/int)*2+1
    u_1(i,1)=R_max_100-int*(i-R_max_100*2/int-1);
    u_2(i,1)=-(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_4=q_val_4(1)+q_val_4(2)*exp(-h(i,1)*q_val_4(3));
    t_4(i,1)=exp(mu_val_con+sig_val_con_4^0.5*u_2(i,1));
end

for i=1:1:(R_max_100*2/int)*2+1
    Codn_cont_100_4(i,1)=h(i,1);
    Codn_cont_100_4(i,2)=t_4(i,1);
end
   
R_max_10000=5.4;                                        %radius for the 10e-4 annual probability sphere%
int=0.1;                                                %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                        %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t_1=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_10000_4=zeros((R_max_10000*2/int)*2+1,2);       %coordinates for each point in the physical space%


for i=1:1:R_max_10000*2/int+1
    u_1(i,1)=-R_max_10000+int*(i-1);
    u_2(i,1)=(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_4=q_val_4(1)+q_val_4(2)*exp(-h(i,1)*q_val_4(3));
    t_4(i,1)=exp(mu_val_con+sig_val_con_4^0.5*u_2(i,1));
end

for i=R_max_10000*2/int+2:1:(R_max_10000*2/int)*2+1
    u_1(i,1)=R_max_10000-int*(i-R_max_10000*2/int-1);
    u_2(i,1)=-(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_4=q_val_4(1)+q_val_4(2)*exp(-h(i,1)*q_val_4(3));
    t_4(i,1)=exp(mu_val_con+sig_val_con_4^0.5*u_2(i,1));
end

for i=1:1:(R_max_10000*2/int)*2+1
    Codn_cont_10000_4(i,1)=h(i,1);
    Codn_cont_10000_4(i,2)=t_4(i,1);
end


figure(32)
h1=plot(Codn_cont_100_1(:,2),Codn_cont_100_1(:,1),'-r','LineWidth',4);
hold on;
h2=plot(Codn_cont_100_2(:,2),Codn_cont_100_2(:,1),'--g','LineWidth',4);
hold on;
h3=plot(Codn_cont_100_3(:,2),Codn_cont_100_3(:,1),'-.b','LineWidth',4);
hold on;
h4=plot(Codn_cont_100_4(:,2),Codn_cont_100_4(:,1),':k','LineWidth',4);
hold on;
% h9=plot(Codn_cont_100_1(96,2),Codn_cont_100_1(96,1),'r*','MarkerSize',8);
% hold on;
% h10=plot(Codn_cont_100_2(96,2),Codn_cont_100_2(96,1),'r*','MarkerSize',8);
% hold on;
% h11=plot(Codn_cont_100_3(95,2),Codn_cont_100_3(95,1),'r*','MarkerSize',8);
% hold on;
% h12=plot(Codn_cont_100_4(94,2),Codn_cont_100_4(94,1),'r*','MarkerSize',8);
legend([h1 h2 h3 h4],'lower bound is 0.00073','lower bound is 0.001','lower bound is 0.003','lower bound is 0.005');
hold on;
h5=plot(Codn_cont_10000_1(:,2),Codn_cont_10000_1(:,1),'-r','LineWidth',4);
hold on;
h6=plot(Codn_cont_10000_2(:,2),Codn_cont_10000_2(:,1),'--g','LineWidth',4);
hold on;
h7=plot(Codn_cont_10000_3(:,2),Codn_cont_10000_3(:,1),'-.b','LineWidth',4);
hold on;
h8=plot(Codn_cont_10000_4(:,2),Codn_cont_10000_4(:,1),':k','LineWidth',4);
% hold on;
% h13=plot(Codn_cont_10000_1(120,2),Codn_cont_10000_1(120,1),'r*','MarkerSize',8);
% hold on;
% h14=plot(Codn_cont_10000_2(120,2),Codn_cont_10000_2(120,1),'r*','MarkerSize',8);
% hold on;
% h15=plot(Codn_cont_10000_3(117,2),Codn_cont_10000_3(117,1),'r*','MarkerSize',8);
% hold on;
% h16=plot(Codn_cont_10000_4(115,2),Codn_cont_10000_4(115,1),'r*','MarkerSize',8)
AX=legend([h5 h6 h7 h8],'lower bound is 0.00073','lower bound is 0.001','lower bound is 0.003','lower bound is 0.005');
LEG = findobj(AX,'type','text');
set(LEG,'FontSize',25)
ylabel('Significant Wave Height H_s(m)','FontWeight','bold','FontSize',25);
xlabel('Spectral Peak Period T_p(s)','FontWeight','bold','FontSize',25);
set(gca,'fontsize',25)

for i=1:1:Hs_estm_max/interval
    hs_rsp(i,1)=(i-0.5)*interval;
end
%1. study of the contour line%
h_exc=[12.2;14.19;16.54;20.97];         %significant wave height for q= 0.63, 10-1, 10-2 and 10-4%
mu_exc=zeros(4,1);                      %respective mu, also conditional mean for each hs above%
var_exc_1=zeros(4,1);                     %respective var for hs above%
X_low_1=zeros(4,1);                       %lower value for range of 90% of tp%
X_high_1=zeros(4,1);                      %higher value for range of 90% of tp%

for i=1:1:4
    mu_exc(i,1)=p_val(1)+p_val(2)*h_exc(i,1)^p_val(3);
    var_exc_1(i,1)=q_val_1(1)+q_val_1(2)*exp(-h_exc(i,1)*q_val_1(3));
    X_low_1(i,1)=norminv(0.05,mu_exc(i,1),var_exc_1(i,1)^0.5);
    X_high_1(i,1)=norminv(0.95,mu_exc(i,1),var_exc_1(i,1)^0.5);
end

%calculattion and comparison of mean of tp for each class of hs%
T_zrcrs_1=zeros(125,1);
for i=1:1:125
    T_zrcrs_1(i,1)=2*pi*(1/(2*(p_val(1)+p_val(2)*hs_rsp(i,1)^p_val(3))+0.5*2^2*(q_val_1(1)+q_val_1(2)*exp(-hs_rsp(i,1)*q_val_1(3)))))^0.5;
end

%comparison with the material 5 from Prof., this figure has same axis as Figure7 in the material%
Mean_tp_1=zeros(Hs_estm_max/interval,1);
Std_tp_1=zeros(Hs_estm_max/interval,1);
Mean_tp_real_1=zeros(Hs_estm_max/interval,1);
Std_tp_real_1=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    Mean_tp_1(i,1)=exp(mu_val(i,1)+sig_val_1(i,1)/2);
    Std_tp_1(i,1)=(exp(sig_val_1(i,1))-1)^0.5*exp(mu_val(i,1)+sig_val_1(i,1)/2);
    index=find(Wdata(:,7)>(i*interval-interval)&Wdata(:,7)<=(i*interval));
    Length_tp=length(index);
    Mean_tp_real_1(i)=sum((Wdata(index,8)))/Length_tp;
    Std_tp_real_1(i)=(sum(((Wdata(index,8))).^2)/Length_tp-(Mean_tp_real_1(i)).^2)^0.5;
end

%study of the contour line%
h_exc=[12.2;14.19;16.54;20.97];         %significant wave height for q= 0.63, 10-1, 10-2 and 10-4%
mu_exc=zeros(4,1);                      %respective mu, also conditional mean for each hs above%
var_exc_1=zeros(4,1);                     %respective var for hs above%
X_low_1=zeros(4,1);                       %lower value for range of 90% of tp%
X_high_1=zeros(4,1);                      %higher value for range of 90% of tp%

for i=1:1:4
    mu_exc(i,1)=p_val(1)+p_val(2)*h_exc(i,1)^p_val(3);
    var_exc_1(i,1)=q_val_1(1)+q_val_1(2)*exp(-h_exc(i,1)*q_val_1(3));
    X_low_1(i,1)=norminv(0.05,mu_exc(i,1),var_exc_1(i,1)^0.5);
    X_high_1(i,1)=norminv(0.95,mu_exc(i,1),var_exc_1(i,1)^0.5);
end

%calculattion and comparison of mean of tp for each class of hs%
T_zrcrs_1=zeros(125,1);
for i=1:1:125
    T_zrcrs_1(i,1)=2*pi*(1/(2*(p_val(1)+p_val(2)*hs_rsp(i,1)^p_val(3))+0.5*2^2*(q_val_1(1)+q_val_1(2)*exp(-hs_rsp(i,1)*q_val_1(3)))))^0.5;
end

%comparison with the material 5 from Prof., this figure has same axis as Figure7 in the material%
Mean_tp_1=zeros(Hs_estm_max/interval,1);
Std_tp_1=zeros(Hs_estm_max/interval,1);
Mean_tp_real_1=zeros(Hs_estm_max/interval,1);
Std_tp_real_1=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    Mean_tp_1(i,1)=exp(mu_val(i,1)+sig_val_1(i,1)/2);
    Std_tp_1(i,1)=(exp(sig_val_1(i,1))-1)^0.5*exp(mu_val(i,1)+sig_val_1(i,1)/2);
    index=find(Wdata(:,7)>(i*interval-interval)&Wdata(:,7)<=(i*interval));
    Length_tp=length(index);
    Mean_tp_real_1(i)=sum((Wdata(index,8)))/Length_tp;
    Std_tp_real_1(i)=(sum(((Wdata(index,8))).^2)/Length_tp-(Mean_tp_real_1(i)).^2)^0.5;
end

%2. study of the contour line%
var_exc_2=zeros(4,1);                     %respective var for hs above%
X_low_2=zeros(4,1);                       %lower value for range of 90% of tp%
X_high_2=zeros(4,1);                      %higher value for range of 90% of tp%

for i=1:1:4
    var_exc_2(i,1)=q_val_2(1)+q_val_2(2)*exp(-h_exc(i,1)*q_val_2(3));
    X_low_2(i,1)=norminv(0.05,mu_exc(i,1),var_exc_2(i,1)^0.5);
    X_high_2(i,1)=norminv(0.95,mu_exc(i,1),var_exc_2(i,1)^0.5);
end

%calculattion and comparison of mean of tp for each class of hs%
T_zrcrs_2=zeros(125,1);
for i=1:1:125
    T_zrcrs_2(i,1)=2*pi*(1/(2*(p_val(1)+p_val(2)*hs_rsp(i,1)^p_val(3))+0.5*2^2*(q_val_2(1)+q_val_2(2)*exp(-hs_rsp(i,1)*q_val_2(3)))))^0.5;
end

%comparison with the material 5 from Prof., this figure has same axis as Figure7 in the material%
Mean_tp_2=zeros(Hs_estm_max/interval,1);
Std_tp_2=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    Mean_tp_2(i,1)=exp(mu_val(i,1)+sig_val_2(i,1)/2);
    Std_tp_2(i,1)=(exp(sig_val_2(i,1))-1)^0.5*exp(mu_val(i,1)+sig_val_2(i,1)/2);
end

%3. study of the contour line%
var_exc_3=zeros(4,1);                     %respective var for hs above%
X_low_3=zeros(4,1);                       %lower value for range of 90% of tp%
X_high_3=zeros(4,1);                      %higher value for range of 90% of tp%

for i=1:1:4
    mu_exc(i,1)=p_val(1)+p_val(2)*h_exc(i,1)^p_val(3);
    var_exc_3(i,1)=q_val_3(1)+q_val_3(2)*exp(-h_exc(i,1)*q_val_3(3));
    X_low_3(i,1)=norminv(0.05,mu_exc(i,1),var_exc_3(i,1)^0.5);
    X_high_3(i,1)=norminv(0.95,mu_exc(i,1),var_exc_3(i,1)^0.5);
end

%calculattion and comparison of mean of tp for each class of hs%
T_zrcrs_3=zeros(125,1);
for i=1:1:125
    T_zrcrs_3(i,1)=2*pi*(1/(2*(p_val(1)+p_val(2)*hs_rsp(i,1)^p_val(3))+0.5*2^2*(q_val_3(1)+q_val_3(2)*exp(-hs_rsp(i,1)*q_val_3(3)))))^0.5;
end

%comparison with the material 5 from Prof., this figure has same axis as Figure7 in the material%
Mean_tp_3=zeros(Hs_estm_max/interval,1);
Std_tp_3=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    Mean_tp_3(i,1)=exp(mu_val(i,1)+sig_val_3(i,1)/2);
    Std_tp_3(i,1)=(exp(sig_val_3(i,1))-1)^0.5*exp(mu_val(i,1)+sig_val_3(i,1)/2);
end

%4. study of the contour line%
var_exc_4=zeros(4,1);                     %respective var for hs above%
X_low_4=zeros(4,1);                       %lower value for range of 90% of tp%
X_high_4=zeros(4,1);                      %higher value for range of 90% of tp%

for i=1:1:4
    mu_exc(i,1)=p_val(1)+p_val(2)*h_exc(i,1)^p_val(3);
    var_exc_4(i,1)=q_val_4(1)+q_val_4(2)*exp(-h_exc(i,1)*q_val_4(3));
    X_low_4(i,1)=norminv(0.05,mu_exc(i,1),var_exc_4(i,1)^0.5);
    X_high_4(i,1)=norminv(0.95,mu_exc(i,1),var_exc_4(i,1)^0.5);
end

%calculattion and comparison of mean of tp for each class of hs%
T_zrcrs_4=zeros(125,1);
for i=1:1:125
    T_zrcrs_4(i,1)=2*pi*(1/(2*(p_val(1)+p_val(2)*hs_rsp(i,1)^p_val(3))+0.5*2^2*(q_val_4(1)+q_val_4(2)*exp(-hs_rsp(i,1)*q_val_4(3)))))^0.5;
end

%comparison with the material 5 from Prof., this figure has same axis as Figure7 in the material%
Mean_tp_4=zeros(Hs_estm_max/interval,1);
Std_tp_4=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    Mean_tp_4(i,1)=exp(mu_val(i,1)+sig_val_4(i,1)/2);
    Std_tp_4(i,1)=(exp(sig_val_4(i,1))-1)^0.5*exp(mu_val(i,1)+sig_val_4(i,1)/2);
end

% figure (34)
% h1=plot(hs_rsp(:),Mean_tp_real_1(:),'r*','MarkerSize',5);
% hold on;
% h2=plot(hs_rsp(:),Mean_tp_1(:),'r','LineWidth',2);
% hold on;
% h3=plot(hs_rsp(:),Mean_tp_2(:),'g','LineWidth',2);
% hold on;
% h4=plot(hs_rsp(:),Mean_tp_3(:),'b','LineWidth',2);
% hold on;
% h5=plot(hs_rsp(:),Mean_tp_4(:),'k','LineWidth',2);
% ylabel('Mean Tp for given Hs','FontWeight','bold','FontSize',16);
% xlabel('Significant Wave Height','FontWeight','bold','FontSize',16);
% legend([h1 h2 h3 h4 h5],'original data','lower bound is 0.00073','lower bound is 0.001','lower bound is 0.003','lower bound is 0.005');
%  
% figure (35)
% h1=plot(hs_rsp(:),Std_tp_real_1(:),'r.','MarkerSize',5);
% hold on;
% h2=plot(hs_rsp(:),Std_tp_1(:),'r','LineWidth',2);
% hold on;
% h3=plot(hs_rsp(:),Std_tp_2(:),'g','LineWidth',2);
% hold on;
% h4=plot(hs_rsp(:),Std_tp_3(:),'b','LineWidth',2);
% hold on;
% h5=plot(hs_rsp(:),Std_tp_4(:),'k','LineWidth',2);
% ylabel('Standard Deviation for Tp give Hs','FontWeight','bold','FontSize',16);
% xlabel('Significant Wave Height','FontWeight','bold','FontSize',16);
% legend([h1 h2 h3 h4 h5],'original data','lower bound is 0.00073','lower bound is 0.001','lower bound is 0.003','lower bound is 0.005');
% 





