clc
clf
clear all
close all
Wdata=load('\\sambaad.stud.ntnu.no\tianzuoy\Desktop\Thesisdata.txt');

%------------------------------Chapter 1. Notation of Generic Response System--------------------------------%


%----------------------------Chapter 2. Joint Probability Distribution Function--------------------------------%

%------------------------------Scatter Diagram-----------------------------------%

%find largest and lowest wave height and wave period%
Hs_max_real=max(Wdata(:,7));      
Hs_min_real=min(Wdata(:,7));     
Tp_max_real=max(Wdata(:,8));     
Tp_min_real=min(Wdata(:,8));   

Hs_max=17;    %manually find%
Hs_min=0;     %manually find%
Tp_max=23;    %manually find%
Tp_min=2;     %manually find%

%now we use wave height i as column, use wave period j as row%
n=length(Wdata(:,7));
interval_hs=0.5;
interval_tp=1;
scatter=zeros(Hs_max/interval_hs,(Tp_max-Tp_min)/interval_tp);

for k=1:1:n;
    for i=Hs_min/interval_hs:1:Hs_max/interval_hs-1;
        for j=Tp_min/interval_tp:1:Tp_max/interval_tp-1;
            if (Wdata(k,7)>i*0.5)&(Wdata(k,7)<=i*0.5+0.5)&(Wdata(k,8)>j)&(Wdata(k,8)<=j+1);
                scatter(i+1,j-1)=scatter(i+1,j-1)+1;
            end
        end
    end
end
N=sum(sum(scatter,2));

%------------------------------Distribution of Hs-----------------------------------%

%get the probability by plotting on the probability paper, need define interval for the cumulative function%
interval=0.2;
num_row=17/interval-1;                         %because the minimum wave height is 0.3, so there will be no wave in interval 0-0.2%
h_distribution=zeros(num_row,1);

for i=1:1:num_row
    for j=1:1:163133
        if (Wdata(j,7)>(i*interval))&(Wdata(j,7)<=(i+1)*interval)
            h_distribution(i,1)=h_distribution(i,1)+1;
        end
    end
end

fHm0=zeros(num_row,1);
for i=1:1:num_row
    fHm0(i,1)=h_distribution(i,1)/(N+1);
    h_s(i,1)=i*interval;
    ln_h_s(i,1)=log(i*interval);
end

F_H=cumsum(fHm0);
y=log(-log(1-F_H));

%In this thesis, we use three parameter Weibull distribution.%

lp=0:0.2:(2-0.2);    %lp: location parameter. By experience that lp should be less than 1. So the range is taken from 0 to 2 with an interval of 0.2%
ln_hs=zeros(num_row,2/0.2);
      
for i=1:1:num_row
    for j=1:1:2/0.2
              ln_hs(i,j)=log(h_s(i)-lp(j));
    end
end

kay_1=zeros(2/0.2,1);
lamda_1=zeros(2/0.2,1);
devia_1=zeros(2/0.2,1);


for i=1:1:2/0.2
  [cfun,gof,output]=fit(ln_hs(i:num_row,i),y(i:num_row,1),'poly1');
  cfun;
  gof;
  output;
  kay_1(i,1)=cfun.p1;
  lamda_1(i,1)=exp(-cfun.p2/cfun.p1);
    for j=i:1:num_row
        devia_1(i,1)=devia_1(i,1)+(kay_1(i,1)*ln_hs(j,i)-kay_1(i,1)*log(lamda_1(i,1))-y(j,1))^2;
    end
        devia_1(i,1)=(devia_1(i,1)/(num_row-i))^0.5;
end

                                                  
lp_final=0.4;
kay_1_final=1.2851;
lamda_1_final=2.2491;



hs_extr=zeros(6,1);
q_extr=[0.63;0.1;0.01;0.001;0.0001;0.00001];
for i=1:1:6
%     hs_extr(i,1)=exp(1/kay_1_final*log(-log(1-q_extr(i)/2920))+log(lamda_1_final))+lp_final;
    hs_extr(i,1)=lamda_1_final*(-log(q_extr(i)/2920))^(1/kay_1_final)+lp_final;
end
  
%-------------------Distribution of T_p given H_s-------------------------%

%first get mean and variance number of Tp in each interval%

for i=0:1:(num_row-1)
    index=find(Wdata(:,7)>(i*interval)&Wdata(:,7)<=(i*interval)+1);
    Length_tp=length(index);
    Tp_mean(i+1)=sum(log(Wdata(index,8)))/Length_tp;
    Tp_var(i+1)=sum((log(Wdata(index,8))).^2)/Length_tp-(Tp_mean(i+1)).^2;
end

%now the nonlinear fit for miu and var%
p=[-1;1;-1];                                                           %define two initial value%
q=[0.0011;0.1147;0.308];
mu=@(p,x)(p(1)+p(2)*x.^p(3));                                          %function of the variable%
varia=@(q,x)(q(1)+q(2)*exp(-x.*q(3)));

p_val=[1.09;1.019;0.2];                                                %by studying the automatic fitting, some optimized value has been proposed%

Hs_estm_max=25;
Tp_estm_max=30;

for i=1:1:Hs_estm_max/interval+1
    Hs_ran(i,1)=(i-1)*interval;
end

mu_val=p_val(1)+p_val(2).*Hs_ran(1:Hs_estm_max/interval).^p_val(3);
q_val_1=[0.00073;0.1122;0.32];    
q_val_2=[0.001;0.0992;0.30]; 
q_val_3=[0.003;0.1022;0.33];
q_val_4=[0.005;0.1022;0.36];  

sig_val_1=q_val_1(1)+q_val_1(2).*exp(-Hs_ran(1:Hs_estm_max/interval).*q_val_1(3));
sig_val_2=q_val_2(1)+q_val_2(2).*exp(-Hs_ran(1:Hs_estm_max/interval).*q_val_2(3));
sig_val_3=q_val_3(1)+q_val_3(2).*exp(-Hs_ran(1:Hs_estm_max/interval).*q_val_3(3));
sig_val_4=q_val_4(1)+q_val_4(2).*exp(-Hs_ran(1:Hs_estm_max/interval).*q_val_4(3));

%-----------------------Verification of Joint Distribution Function-------------------------%

%get the probability density for each interval of hs%
scatter_veri_hs_bs=zeros(Hs_estm_max/interval,1);    %before scale%
scatter_veri_hs=zeros(Hs_estm_max/interval,1);       %after scale%

for i=3:1:round(Hs_estm_max/interval)-1
    scatter_veri_hs_bs(i,1)=(1-exp(-((Hs_ran(i+1)-lp_final)/lamda_1_final)^kay_1_final))-(1-exp(-((Hs_ran(i)-lp_final)/lamda_1_final)^kay_1_final));
end

P_veri_hs_bs=sum(scatter_veri_hs_bs); 

for i=3:1:round(Hs_estm_max/interval)-1
    scatter_veri_hs(i,1)=scatter_veri_hs_bs(i,1)/P_veri_hs_bs;
end
P_veri_hs=sum(scatter_veri_hs); 

%1. get the probability for tp given hs%
scatter_veri_tp_bs_1=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
scatter_veri_tp_1=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
P_veri_tp_bs_1=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp_bs_1(i,j)=(0.5*erfc(-(log(j*interval)-mu_val(i))/(sig_val_1(i)*2^0.5)))-(0.5*erfc(-(log((j-1)*interval)-mu_val(i))/(sig_val_1(i)*2^0.5)));
    end
end

P_veri_tp_bs_1=sum(scatter_veri_tp_bs_1,2);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp_1(i,j)=scatter_veri_tp_bs_1(i,j)/P_veri_tp_bs_1(i,1);
    end
end

P_veri_tp_1=sum(scatter_veri_tp_1,2);

%get the probability for each hs and tp interval%
scatter_veri_hstp_1=zeros(Hs_estm_max/interval,Tp_estm_max/interval);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_hstp_1(i,j)=scatter_veri_hs(i,1)*scatter_veri_tp_1(i,j);
    end
end

P_veri_hstp_1=sum(sum(scatter_veri_hstp_1,2));

%environmental contour line method%
B=norminv(0.01/2920);                                 %here remains the question how to find the approximate number but not integral, i.e. 4.4983 to 4.5 but not 5%
R_max_100=4.5;                                        %radius for the 10e-2 annual probability sphere%
int=0.1;                                              %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                      %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t_1=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_100_1=zeros((R_max_100*2/int)*2+1,2);         %coordinates for each point in the physical space%
mu_val_con=zeros((R_max_100*2/int)*2+1,2);
sig_val_con_1=zeros((R_max_100*2/int)*2+1,2);

for i=1:1:R_max_100*2/int+1
    u_1(i,1)=-R_max_100+int*(i-1);
    u_2(i,1)=(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_1=q_val_1(1)+q_val_1(2)*exp(-h(i,1)*q_val_1(3));
    t_1(i,1)=exp(mu_val_con+sig_val_con_1^0.5*u_2(i,1));
end

for i=R_max_100*2/int+2:1:(R_max_100*2/int)*2+1
    u_1(i,1)=R_max_100-int*(i-R_max_100*2/int-1);
    u_2(i,1)=-(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con_1=q_val_1(1)+q_val_1(2)*exp(-h(i,1)*q_val_1(3));
    t_1(i,1)=exp(mu_val_con+sig_val_con_1^0.5*u_2(i,1));
end

for i=1:1:(R_max_100*2/int)*2+1
    Codn_cont_100_1(i,1)=h(i,1);
    Codn_cont_100_1(i,2)=t_1(i,1);
end
   

Num_dot=26;
Num_oncon=16;                      %the No. of dot which is on contour%
Num_samehs=10;                      %the number of dot which have same hs%
Codn_fail=zeros(Num_dot,2);
for i=1:1:(Num_dot-Num_samehs-1)
    Codn_fail(i,1)=Codn_cont_100_1(86,1)+0.2*(Num_dot-Num_samehs-i);
    Codn_fail(i,2)=Codn_cont_100_1(86,2);
end
Codn_fail(Num_oncon,1)=Codn_cont_100_1(86,1);
Codn_fail(Num_oncon,2)=Codn_cont_100_1(86,2);
for i=1:1:Num_samehs
    Codn_fail(i+Num_oncon,1)=Codn_cont_100_1(86,1);
    Codn_fail(i+Num_oncon,2)=Codn_cont_100_1(86,2)+0.2*i;
end

mu_val_f=p_val(1)+p_val(2).*Codn_fail(:,1).^p_val(3);
sig_val_f=q_val_1(1)+q_val_1(2).*exp(-Codn_fail(:,1).*q_val_1(3));

for i=1:1:Num_dot
    Codn_trs_f(i,1)=(1-exp(-((Codn_fail(i,1)-lp_final)/lamda_1_final)^kay_1_final));
%     Codn_trs_f(i,2)=(0.5*erfc(-(log(Codn_fail(i,2))-mu_val_f(i))/(sig_val_f(i)*2^0.5)));
    Codn_phy_f(i,1)=norminv(Codn_trs_f(i,1),0,1);
    Codn_phy_f(i,2)=(log(Codn_fail(i,2))-mu_val_f(i,1))/sig_val_f(i,1)^0.5;
end

figure(32)
h1=plot(Codn_cont_100_1(:,2),Codn_cont_100_1(:,1),'b','LineWidth',4);
hold on;
h2=plot(Codn_fail(:,2),Codn_fail(:,1),'r*','MarkerSize',20);
hold on;
h3=plot(Codn_fail(:,2),Codn_fail(:,1),'k','LineWidth',4);
fill(Codn_fail(:,2),Codn_fail(:,1),'g')
text(18,14.2,'A','FontSize',20)
AX=legend([h1 h2 h3],'the 100-year environmental contour line','boundry points for worse sea states','boundry line for worse sea states','Location','NorthWest');
LEG = findobj(AX,'type','text');
set(LEG,'FontSize',25)
ylabel('Significant Wave Height(m)','FontWeight','bold','FontSize',25);
xlabel('Spectral Peak Period(s)','FontWeight','bold','FontSize',25);
axis([15 21 14 18]);
% axis([0 30 0 18]);
set(gca,'fontsize',25)

figure(33)
h1=plot(u_1(:,1),u_2(:,1),'b','LineWidth',4);
hold on;
h2=plot(Codn_phy_f(:,2),Codn_phy_f(:,1),'r*','MarkerSize',20);
hold on;
h3=plot(Codn_phy_f(:,2),Codn_phy_f(:,1),'k','LineWidth',4);
fill(Codn_phy_f(:,2),Codn_phy_f(:,1),'g')
text(2,3.8,'A','FontSize',20)
AX=legend([h1 h2 h3],'the 100-year environmental contour line','boundry points for worse sea states','boundry line for worse sea states','Location','NorthWest');
LEG = findobj(AX,'type','text');
set(LEG,'FontSize',25)
ylabel('U1','FontWeight','bold','FontSize',25);
xlabel('U2','FontWeight','bold','FontSize',25);
axis([0 5 3 5]);
% axis([-5 5 -5 5]);
set(gca,'fontsize',25)
