clc
clf
clear all
close all
Wdata=load('\\sambaad.stud.ntnu.no\tianzuoy\Desktop\Thesisdata.txt');

%------------------------------Chapter 1. Notation of Generic Response System--------------------------------%

%----------------------------Chapter 2. Joint Probability Distribution Function--------------------------------%

%------------------------------Scatter Diagram-----------------------------------%

%find largest and lowest wave height and wave period%
Hs_max_real=max(Wdata(:,7));      
Hs_min_real=min(Wdata(:,7));     
Tp_max_real=max(Wdata(:,8));     
Tp_min_real=min(Wdata(:,8));   

Hs_max=17;    %manually find%
Hs_min=0;     %manually find%
Tp_max=23;    %manually find%
Tp_min=2;     %manually find%

%now we use wave height i as column, use wave period j as row%
n=length(Wdata(:,7));
interval_hs=0.5;
interval_tp=1;
scatter=zeros(Hs_max/interval_hs,(Tp_max-Tp_min)/interval_tp);

for k=1:1:n;
    for i=Hs_min/interval_hs:1:Hs_max/interval_hs-1;
        for j=Tp_min/interval_tp:1:Tp_max/interval_tp-1;
            if (Wdata(k,7)>i*0.5)&(Wdata(k,7)<=i*0.5+0.5)&(Wdata(k,8)>j)&(Wdata(k,8)<=j+1);
                scatter(i+1,j-1)=scatter(i+1,j-1)+1;
            end
        end
    end
end
N=sum(sum(scatter,2));

%------------------------------Distribution of Hs-----------------------------------%

%get the probability by plotting on the probability paper, need define interval for the cumulative function%
interval=0.2;
num_row=17/interval-1;                         %because the minimum wave height is 0.3, so there will be no wave in interval 0-0.2%
h_distribution=zeros(num_row,1);

for i=1:1:num_row
    for j=1:1:163133
        if (Wdata(j,7)>(i*interval))&(Wdata(j,7)<=(i+1)*interval)
            h_distribution(i,1)=h_distribution(i,1)+1;
        end
    end
end

fHm0=zeros(num_row,1);
for i=1:1:num_row
    fHm0(i,1)=h_distribution(i,1)/(N+1);
    h_s(i,1)=i*interval;
    ln_h_s(i,1)=log(i*interval);
end

F_H=cumsum(fHm0);
y=log(-log(1-F_H));

%In this thesis, we use three parameter Weibull distribution.%

lp=0:0.2:(2-0.2);    %lp: location parameter. By experience that lp should be less than 1. So the range is taken from 0 to 2 with an interval of 0.2%
ln_hs=zeros(num_row,2/0.2);
      
for i=1:1:num_row
    for j=1:1:2/0.2
              ln_hs(i,j)=log(h_s(i)-lp(j));
    end
end

kay_1=zeros(2/0.2,1);
lamda_1=zeros(2/0.2,1);
devia_1=zeros(2/0.2,1);


for i=1:1:2/0.2
  [cfun,gof,output]=fit(ln_hs(i:num_row,i),y(i:num_row,1),'poly1');
  cfun;
  gof;
  output;
  kay_1(i,1)=cfun.p1;
  lamda_1(i,1)=exp(-cfun.p2/cfun.p1);
    for j=i:1:num_row
        devia_1(i,1)=devia_1(i,1)+(kay_1(i,1)*ln_hs(j,i)-kay_1(i,1)*log(lamda_1(i,1))-y(j,1))^2;
    end
        devia_1(i,1)=(devia_1(i,1)/(num_row-i))^0.5;
end

% figure(5)
% h1=plot(lp(1:2/0.2),devia_1,'r.','MarkerSize',5);    %as can be seen from the figure, when lp=0.4, the deviation has the minimum value.%
%                                                   %when lp=0.4, lamda_1= , kay_1= %
% ylabel('Standard Deviation','FontWeight','bold','FontSize',16);
% xlabel('Location Parameter','FontWeight','bold','FontSize',16);
% axis([0 2 0 0.4]);
% 
% % now use eye fittinig B)%
% for i=1:1:5               %here it plots when lp=0, 0.2, 0.4, 0.6, 0.8%
%     figure(i+5)
%     h1=plot(ln_hs(i:84,i),y(i:84,1),'r.','MarkerSize',5);
%     ylabel('ln(-ln(1-F(h_s)))','FontWeight','bold','FontSize',16);
%     xlabel('ln(h_s-lp)','FontWeight','bold','FontSize',16);
%     hold on;
%     h2=plot(ln_hs(i:84,i),kay_1(i,1)*ln_hs(i:84,i)-kay_1(i,1)*log(lamda_1(i,1)),'LineWidth',2);
%     legend([h1 h2],'Original Points','Fitted Curve','Location','SouthEast');
% end                       %by both diviation and eye fitting, we can see that when lp=0.4, it is the best fit%
                                                  
lp_final=0.4;
kay_1_final=1.2851;
lamda_1_final=2.2491;

% figure(11)
% y_fig2=zeros(84,1);
% for i=1:1:84
%     y_fig2(i,1)=1-exp(-((h_s(i,1)-lp_final)/lamda_1_final)^kay_1_final);
% end
% h1=plot(h_s(3:84),y_fig2(3:84),'LineWidth',2);
% hold on;
% h2=plot(h_s(1:84),F_H(1:84),'r.','MarkerSize',5);
% 
% legend([h1 h2],'Fitted Curve','Original Points');
% ylabel('Cumulative Probability of h_s','FontWeight','bold','FontSize',16);
% xlabel('h_s','FontWeight','bold','FontSize',16);
% axis([0 18 0 1.2])

hs_extr=zeros(6,1);
q_extr=[0.63;0.1;0.01;0.001;0.0001;0.00001];
for i=1:1:6
%     hs_extr(i,1)=exp(1/kay_1_final*log(-log(1-q_extr(i)/2920))+log(lamda_1_final))+lp_final;
    hs_extr(i,1)=lamda_1_final*(-log(q_extr(i)/2920))^(1/kay_1_final)+lp_final;
end
  
%-------------------Distribution of T_p given H_s-------------------------%

%first get mean and variance number of Tp in each interval%

for i=0:1:(num_row-1)
    index=find(Wdata(:,7)>(i*interval)&Wdata(:,7)<=(i*interval)+1);
    Length_tp=length(index);
    Tp_mean(i+1)=sum(log(Wdata(index,8)))/Length_tp;
    Tp_var(i+1)=sum((log(Wdata(index,8))).^2)/Length_tp-(Tp_mean(i+1)).^2;
end

%now the nonlinear fit for miu and var%
p=[-1;1;-1];                                                           %define two initial value%
q=[0.0011;0.1147;0.308];
mu=@(p,x)(p(1)+p(2)*x.^p(3));                                          %function of the variable%
varia=@(q,x)(q(1)+q(2)*exp(-x.*q(3)));

% p_val=nlinfit(Hs_ran(2:(17/interval+1)),Tp_mean,mu,p);                 %nonlinear fit process%
% q_val=nlinfit(Hs_ran(2:(17/interval+1)),Tp_var,varia,q);

p_val=[1.09;1.019;0.2];                                                %by studying the automatic fitting, some optimized value has been proposed%

Hs_estm_max=25;
Tp_estm_max=30;

for i=1:1:Hs_estm_max/interval+1
    Hs_ran(i,1)=(i-1)*interval;
end

mu_val=p_val(1)+p_val(2).*Hs_ran(1:Hs_estm_max/interval).^p_val(3);
% q_val=[0.00073;0.1122;0.32];    
% q_val=[0.001;0.0992;0.30]; 
% q_val=[0.003;0.1022;0.33];
q_val=[0.005;0.1022;0.36];  

sig_val=q_val(1)+q_val(2).*exp(-Hs_ran(1:Hs_estm_max/interval).*q_val(3));

% figure(12)
% h2=plot(Hs_ran(2:76),Tp_mean(2:76),'r.','MarkerSize',5);               %76 is 17/interval+1-10, this is also wield to me, but it's the only way it works%
% hold on;
% h1=plot(Hs_ran(1:Hs_estm_max/interval),mu_val,'LineWidth',2);          %86 is 17/interval+1, below in figure(3) is the same%
% axis([0 28 1.5 3.5]);
% ylabel('Mean Value of Tp for Each Hs interval','FontWeight','bold','FontSize',16);
% xlabel('Hs','FontWeight','bold','FontSize',16);
% legend([h1 h2],'Fitted Curve','Original Points');
% 
% figure(13)
% h2=plot(Hs_ran(2:76),Tp_var(2:76),'r.','MarkerSize',5);
% hold on;
% h1=plot(Hs_ran(1:Hs_estm_max/interval),sig_val,'LineWidth',2);
% % axis([0 28 0 0.08]);
% ylabel('sig-val','FontWeight','bold','FontSize',16);
% xlabel('Hs-ran','FontWeight','bold','FontSize',16);
% legend([h1 h2],'Fitted Curve','Original Points');



%-----------------------Verification of Joint Distribution Function-------------------------%

%get the probability density for each interval of hs%
scatter_veri_hs_bs=zeros(Hs_estm_max/interval,1);    %before scale%
scatter_veri_hs=zeros(Hs_estm_max/interval,1);       %after scale%

for i=3:1:round(Hs_estm_max/interval)-1
    scatter_veri_hs_bs(i,1)=(1-exp(-((Hs_ran(i+1)-lp_final)/lamda_1_final)^kay_1_final))-(1-exp(-((Hs_ran(i)-lp_final)/lamda_1_final)^kay_1_final));
end

P_veri_hs_bs=sum(scatter_veri_hs_bs); 

for i=3:1:round(Hs_estm_max/interval)-1
    scatter_veri_hs(i,1)=scatter_veri_hs_bs(i,1)/P_veri_hs_bs;
end
P_veri_hs=sum(scatter_veri_hs); 

 %get the probability for tp given hs%
scatter_veri_tp_bs=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
scatter_veri_tp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
P_veri_tp_bs=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp_bs(i,j)=(0.5*erfc(-(log(j*interval)-mu_val(i))/(sig_val(i)^0.5*2^0.5)))-(0.5*erfc(-(log((j-1)*interval)-mu_val(i))/(sig_val(i)^0.5*2^0.5)));
    end
end

P_veri_tp_bs=sum(scatter_veri_tp_bs,2);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp(i,j)=scatter_veri_tp_bs(i,j)/P_veri_tp_bs(i,1);
    end
end

P_veri_tp=sum(scatter_veri_tp,2);

%get the probability for each hs and tp interval%
scatter_veri_hstp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_hstp(i,j)=scatter_veri_hs(i,1)*scatter_veri_tp(i,j);
    end
end

P_veri_hstp=sum(sum(scatter_veri_hstp,2));

%---------------------------------Chapter 3. Uncertainty Quatification-----------------------------------%

c_1=1;     %scale coefficient for location parameter%
c_2=2;     %coefficient which control linear and quadratic%
c_3=100;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=21;    %coefficient which control when occurs the most probable peak period%
c_5=60;   %coefficient which control sensitive to period or not%
c_6=0.1;   %measure of variability around the mean 30-minute maximum%

% f_hstp=kay_1_final/lamda_1_final*((hs-lp)/lamda_1_final)^(kay_1_final-1)*exp(-((hs-lp)/lamda_1_final)^kay_1_final)*    1/(tp*(2*pi*(q(1)+q(2)*exp(-hs*q(3))))^0.5)*exp(-0.5*((log(tp)-(p(1)+p(2)*hs^p(3)))/(q(1)+q(2)*exp(-hs*q(3))))^2);  
                                                                                                                                                                  
% F_x_hstp=exp(-exp((-x+(c_1*hs^c_2*(1+(cos((2*pi*(tp-c_4)/c_5)))^c_3)-0.57722*(0.7797*c_2*c_6*(c_1*hs^c_2*(1+(cos((2*pi*(tp-c_4)/c_5)))^c_3)))))/(0.7797*c_2*c_6*(c_1*hs^c_2*(1+(cos((2*pi*(tp-c_4)/c_5)))^c_3)))));

%using definition of integration%
scatter_rsp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);        %matrix of response for all sea state%
scatter_rsp_hstp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);   %matrix of response for each hs and tp interval%
int=1;
if c_2==1&&c_5==100
    X_extm_max=67;                     %define X_estm_max=160 is because P_veri_rsp(X_estm_max=160)=1.000000(exact 1), so X_estm_max=160 is a safe estimation of maximum response value%
else if c_2==2&&c_5==100
        X_extm_max=1420;
    else if c_2==1&&c_5==60
            X_extm_max=53;
        else 
            X_extm_max=756;
        end
    end
end
P_veri_rsp=zeros(X_extm_max/int,1);
Ad_y=zeros(X_extm_max/int,1);                                        %fitted y value for Gumbel distribution%
Ad_y_fit=zeros(X_extm_max/int,1); 

hs_rsp=zeros(Hs_estm_max/interval,1);  %middle point for each hs interval%     
tp_rsp=zeros(Tp_estm_max/interval,1);  %middle point for each tp interval%
scatter_rsp_hstp_veri=zeros(Hs_estm_max/interval,Tp_estm_max/interval);

%problem may lies in how to get the scatter diagram, should be F(x+1)-F(x), not each F(x) for each x%
for k=1:1:2000
    x(k,1)=k;
end

for k=1:1:X_extm_max/int
    for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        x(k,1)=k;
        hs_rsp(i,1)=(i-0.5)*interval;
        tp_rsp(j,1)=(j-0.5)*interval;
        
        scatter_rsp_hstp(i,j)=exp(-exp((-x(k)+(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)-0.57722*(0.7797*c_2*c_6*(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)))))/(0.7797*c_2*c_6*(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)))));
        scatter_rsp(i,j)=scatter_veri_hstp(i,j)*scatter_rsp_hstp(i,j);
%         miu=(c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3))
%         sig=(c_2*c_6*c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3))
%         alfa=((c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3))-0.57722*0.7797*(c_2*c_6*c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3)))
%         beta=(0.7797*(c_2*c_6*c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3)))
    end
    end
    P_veri_rsp(k,1)=sum(sum(scatter_rsp,2));
    Ad_y(k,1)=-log(-log(P_veri_rsp(k,1)));
end

%The corresponding exceedance per 3-hour sea state is 10e-5/2920 = 1/292000000. The corresponding cumulative probability = 1-1/292000000. 
%If introduce into ln (-ln (F)) you get 19.49. There is no need to go higher response levels than what corresponds to 20.
%In the Ad_y matrix, Ad_y(94,1)=19.9768, >19.49. Thus only consier values below 94
index=find(Ad_y(:,1)>10&Ad_y(:,1)<20);               %purpose is to do a better fitting for tail data, not affected by the previous data%
C=find(Ad_y(:,1)>10&Ad_y(:,1)<20,1,'last');            %find the last original data needed in the plot%
D=find(Ad_y(:,1)>10&Ad_y(:,1)<20,1,'first');
Q=C+10/int;

[dfun,gof,output]=fit(x(index),Ad_y(index),'poly1');
dfun;
gof;
output;

for k=1:1:X_extm_max/int
    Ad_y_fit(k,1)=dfun.p1*x(k)+dfun.p2;
end


% figure(14)
% h1=plot(x(1:C),Ad_y(1:C),'r.','MarkerSize',5);
% hold on;
% h2=plot(x(D:Q),Ad_y_fit(D:Q),'LineWidth',2);
% legend([h1 h2],'Original Data','Estimated Line','Location','SouthEast');
% ylabel('Cumulative Probability on Gumbel Probability Paper','FontWeight','bold','FontSize',16);
% xlabel('Response Value','FontWeight','bold','FontSize',16);


%verification of fitted model%
F_10=1-1/(10*365*24/3);
F_100=1-1/(100*365*24/3);          %ULS case%
F_10000=1-1/(10000*365*24/3);      %ALS case%
F_100000=1-1/(100000*365*24/3);

x_10=1/dfun.p1*(-dfun.p2+(-log(-log(F_10))));
x_100=1/dfun.p1*(-dfun.p2+(-log(-log(F_100))))
x_10000=1/dfun.p1*(-dfun.p2+(-log(-log(F_10000))))
x_100000=1/dfun.p1*(-dfun.p2+(-log(-log(F_100000))))    %set to be the upper limit for all the fitting%


%non-exceedance,exceedance for response and relative cases%
scatter_nonex=zeros(Hs_estm_max/interval,Tp_estm_max/interval);        %scatter diagram for non-exceedance probability for given hs and tp%
scatter_ex=zeros(Hs_estm_max/interval,Tp_estm_max/interval);           %scatter diagram for exceedance probability for given hs and tp%
scatter_nonex_veri=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
scatter_ex_rsp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);       %scatter diagram for exceedance probability for generic cases%
scatter_rel_ex_rsp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);   %scatter diagram for relative exceedance probability for generic cases%

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        hs_rsp(i,1)=(i-0.5)*interval;
        tp_rsp(j,1)=(j-0.5)*interval;
        mu_la=c_1*hs_rsp(i,1)^c_2*(1+(cos(2*pi*(tp_rsp(j,1)-c_4)/c_5))^c_3);
        sigma_la=c_2*c_6*mu_la;
        beta_la=0.7797*sigma_la;
        alpha_la=mu_la-0.5772*beta_la;
        scatter_nonex(i,j)=exp(-exp((-x_100+(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)-0.57722*(0.7797*c_2*c_6*(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)))))/(0.7797*c_2*c_6*(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)))));
        scatter_ex(i,j)=1-scatter_nonex(i,j);
        scatter_ex_rsp(i,j)=scatter_veri_hstp(i,j)*scatter_ex(i,j);
    end
end

A=sum(sum(scatter_ex_rsp,2));
for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_rel_ex_rsp(i,j)=scatter_ex_rsp(i,j)/A;
    end
end


%contour line of scatter_rsp%
Codn=zeros(Hs_estm_max/interval*Tp_estm_max/interval,3);
for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        Codn(Tp_estm_max/interval*i-Tp_estm_max/interval+j,1)=hs_rsp(i,1);
        Codn(Tp_estm_max/interval*i-Tp_estm_max/interval+j,2)=tp_rsp(j,1);
        Codn(Tp_estm_max/interval*i-Tp_estm_max/interval+j,3)=scatter_rel_ex_rsp(i,j);
    end
end

% figure(31)     %the question here is how to plot scatter_rel_ex_rsp%
% [HS TP] = meshgrid(9:0.005:20, 14.5:0.005:19);
% RSP = griddata(Codn(:,1), Codn(:,2), Codn(:,3), HS, TP);
% F = [.05 .1 .05; .1 .4 .1; .05 .1 .05];
% ZC = conv2(RSP,F,'same');
% ZC1= conv2(ZC,F,'same');
% zlevs = 0.01:0.016:0.23;
% contour(HS, TP, ZC1, zlevs, 'ShowText','on')
% ylabel('TP','FontWeight','bold','FontSize',16);
% xlabel('HS','FontWeight','bold','FontSize',16);
% % axis([11 20 15 19])
% colormap cool
% set(gca,'YDir','Reverse')


%--------------------------------------------Below Belong to Chapter 2--------------------------------------------------%

 %some figures for fitting of tp given hs%     
 %first, method of moment. Find mu_tp and sig_tp, with known distribution function, using autofitting tool in matlab to find the parameters%
I=6;
J=Tp_estm_max;
F_tp_mom=zeros(I,150);
inte=2;
Tp_mean_mom=zeros(I,1);        %8 is (Hs_estm-1)/2%
Tp_var_mom=zeros(I,1);
F_tp=zeros(I,150);                      %I take ten examples from hs(2,4,6,8,..., 20)and get each hs's cumulative probability for increasing tp%
F_tp_real=zeros(I,150);
ln_tp=zeros(150,1);
X=zeros(150,I);


for i=1:1:I
    index=find(Wdata(:,7)>(i*inte-interval)&Wdata(:,7)<=(i*inte));
    Length_tp=length(index);
    Tp_mean_mom(i)=sum(log(Wdata(index,8)))/Length_tp;
    Tp_var_mom(i)=sum((log(Wdata(index,8))).^2)/Length_tp-(Tp_mean_mom(i)).^2;
   
   for j=1:1:150   
     F_tp_mom(i,j)=0.5*erfc(-(log(tp_rsp(j))-Tp_mean_mom(i))/(2*Tp_var_mom(i))^0.5);
     index_hs=find((Wdata(:,7)<hs_rsp(10*i)+0.1)&(Wdata(:,7)>hs_rsp(10*i)-0.1));
     index_tp_hs=find((Wdata(:,8)<j*0.2)&(Wdata(:,7)<hs_rsp(10*i)+0.1)&(Wdata(:,7)>hs_rsp(10*i)-0.1));
     F_tp_real(i,j)=length(index_tp_hs)/length(index_hs);
     ln_tp(j)=log(tp_rsp(j));
     X(j,i)=norminv(F_tp_real(i,j),0,1);
   end
   
%    figure(i+17)
%    h1=plot(tp_rsp(1:150,1),F_tp_real(i,1:150),'r.','MarkerSize',5);
%    ylabel('cumulative probability for tp by method of moment','FontWeight','bold','FontSize',16);
%    xlabel('tp','FontWeight','bold','FontSize',16);
%    hold on;
%    h2=plot(tp_rsp(1:150,1),F_tp_mom(i,1:150),'LineWidth',2);
%    legend([h1 h2],'Original Points','Fitted Curve','Location','SouthEast');
%    axis([0 30 0 1.2])

end
   
%seconde, use linear fitting method
miu_2=zeros(I,1);
sig_2=zeros(I,1);

for i=1:1:6
    index=find(X(:,i)>-10&X(:,i)<10);      
    [cfun,gof,output]=fit(ln_tp(index),X(index,i),'poly1');
    cfun;
    gof;
    output;
    sig_2(i,1)=1/cfun.p1;
    miu_2(i,1)=-cfun.p2/cfun.p1;

%    figure(i+23)
%    h1=plot(tp_rsp(1:150,1),F_tp_real(i,1:150),'r.','MarkerSize',5);
%    ylabel('cumulative probability for tp','FontWeight','bold','FontSize',16);
%    xlabel('tp','FontWeight','bold','FontSize',16);
%    hold on;
%    h2=plot(tp_rsp(1:150,1),normcdf(ln_tp(:),miu_2(i,1),sig_2(i,1)),'LineWidth',2);
%    legend([h1 h2],'Original Points','Fitted Curve','Location','SouthEast');
%    axis([0 30 0 1.2])
end
% comparison for the previous two methods, whcih simulates better?
%--------------------------------------------Previous Belong to Chapter 2--------------------------------------------------%


%environmental contour line method%
B=norminv(0.01/2920);                                 %here remains the question how to find the approximate number but not integral, i.e. 4.4983 to 4.5 but not 5%
R_max_100=4.5;                                        %radius for the 10e-2 annual probability sphere%
int=0.1;                                              %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                      %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_100=zeros((R_max_100*2/int)*2+1,2);         %coordinates for each point in the physical space%


for i=1:1:R_max_100*2/int+1
    u_1(i,1)=-R_max_100+int*(i-1);
    u_2(i,1)=(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con=q_val(1)+q_val(2)*exp(-h(i,1)*q_val(3));
    t(i,1)=exp(mu_val_con+sig_val_con^0.5*u_2(i,1));
end

for i=R_max_100*2/int+2:1:(R_max_100*2/int)*2+1
    u_1(i,1)=R_max_100-int*(i-R_max_100*2/int-1);
    u_2(i,1)=-(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con=q_val(1)+q_val(2)*exp(-h(i,1)*q_val(3));
    t(i,1)=exp(mu_val_con+sig_val_con^0.5*u_2(i,1));
end

for i=1:1:(R_max_100*2/int)*2+1
    Codn_cont_100(i,1)=h(i,1);
    Codn_cont_100(i,2)=t(i,1);
end
   
R_max_10000=5.4;                                        %radius for the 10e-4 annual probability sphere%
int=0.1;                                                %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                        %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_10000=zeros((R_max_10000*2/int)*2+1,2);       %coordinates for each point in the physical space%


for i=1:1:R_max_10000*2/int+1
    u_1(i,1)=-R_max_10000+int*(i-1);
    u_2(i,1)=(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con=q_val(1)+q_val(2)*exp(-h(i,1)*q_val(3));
    t(i,1)=exp(mu_val_con+sig_val_con^0.5*u_2(i,1));
end

for i=R_max_10000*2/int+2:1:(R_max_10000*2/int)*2+1
    u_1(i,1)=R_max_10000-int*(i-R_max_10000*2/int-1);
    u_2(i,1)=-(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con=q_val(1)+q_val(2)*exp(-h(i,1)*q_val(3));
    t(i,1)=exp(mu_val_con+sig_val_con^0.5*u_2(i,1));
end

for i=1:1:(R_max_10000*2/int)*2+1
    Codn_cont_10000(i,1)=h(i,1);
    Codn_cont_10000(i,2)=t(i,1);
end
   
% figure(32)
% h1=plot(Codn_cont_100(:,2),Codn_cont_100(:,1),'g','LineWidth',2);
% hold on;
% h2=plot(Codn_cont_10000(:,2),Codn_cont_10000(:,1),'LineWidth',2);
% legend([h1 h2],'10e-2 annual probability','10e-4 annual probability','Location','NorthEast');
% ylabel('Significant wave height','FontWeight','bold','FontSize',16);
% xlabel('Spectral peak period','FontWeight','bold','FontSize',16);


%study of the contour line%
h_exc=[12.2;14.19;16.54;20.97];         %significant wave height for q= 0.63, 10-1, 10-2 and 10-4%
mu_exc=zeros(4,1);                      %respective mu, also conditional mean for each hs above%
var_exc=zeros(4,1);                     %respective var for hs above%
X_low=zeros(4,1);                       %lower value for range of 90% of tp%
X_high=zeros(4,1);                      %higher value for range of 90% of tp%

for i=1:1:4
    mu_exc(i,1)=p_val(1)+p_val(2)*h_exc(i,1)^p_val(3);
    var_exc(i,1)=q_val(1)+q_val(2)*exp(-h_exc(i,1)*q_val(3));
    X_low(i,1)=norminv(0.05,mu_exc(i,1),var_exc(i,1)^0.5);
    X_high(i,1)=norminv(0.95,mu_exc(i,1),var_exc(i,1)^0.5);
end

%calculattion and comparison of mean of tp for each class of hs%
T_zrcrs=zeros(125,1);
for i=1:1:125
    T_zrcrs(i,1)=2*pi*(1/(2*(p_val(1)+p_val(2)*hs_rsp(i,1)^p_val(3))+0.5*2^2*(q_val(1)+q_val(2)*exp(-hs_rsp(i,1)*q_val(3)))))^0.5;
end

% figure (33)
% h=plot(hs_rsp(:,1),T_zrcrs(:,1),'r.','MarkerSize',5);
% ylabel('average zero-crossing period','FontWeight','bold','FontSize',16);
% xlabel('Significant wave height','FontWeight','bold','FontSize',16);
% axis([0 26 2 4]);

%comparison with the material 5 from Prof., this figure has same axis as Figure7 in the material%
Mean_tp=zeros(Hs_estm_max/interval,1);
Std_tp=zeros(Hs_estm_max/interval,1);
Mean_tp_real=zeros(Hs_estm_max/interval,1);
Std_tp_real=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    Mean_tp(i,1)=exp(mu_val(i,1)+sig_val(i,1)/2);
    Std_tp(i,1)=(exp(sig_val(i,1))-1)^0.5*exp(mu_val(i,1)+sig_val(i,1)/2);
    index=find(Wdata(:,7)>(i*interval-interval)&Wdata(:,7)<=(i*interval));
    Length_tp=length(index);
    Mean_tp_real(i)=sum((Wdata(index,8)))/Length_tp;
    Std_tp_real(i)=(sum(((Wdata(index,8))).^2)/Length_tp-(Mean_tp_real(i)).^2)^0.5;
end

%further information should be directed to code 'for environmental contour line.m'%
% figure (34)
% h1=plot(hs_rsp(:),Mean_tp_real(:),'r.','MarkerSize',5);
% hold on;
% h2=plot(hs_rsp(:),Mean_tp(:),'LineWidth',2);
% ylabel('Mean Tp for given Hs','FontWeight','bold','FontSize',16);
% xlabel('Significant Wave Height','FontWeight','bold','FontSize',16);
% legend([h1 h2],'Original Points','Fitted Curve');
% 
% figure (35)
% h1=plot(hs_rsp(:),Std_tp_real(:),'r.','MarkerSize',5);
% hold on;
% h2=plot(hs_rsp(:),Std_tp(:),'LineWidth',2);
% ylabel('Standard Deviation for Tp give Hs','FontWeight','bold','FontSize',16);
% xlabel('Significant Wave Height','FontWeight','bold','FontSize',16);
% legend([h1 h2],'Original Points','Fitted Curve');

%percentile estimate%
%100-year sea state%
S_100=zeros(181,1);          %S is estimate for the largest response and the worst sea state%
mu_pe_100=zeros(181,1);
sig_pe_100=zeros(181,1);
alfa_pe_100=zeros(181,1);
beita_pe_100=zeros(181,1);

for i=1:1:181
    mu_pe_100(i,1)=c_1*Codn_cont_100(i,1)^c_2*(1+(cos(2*pi*(Codn_cont_100(i,2)-c_4)/c_5))^c_3);    %pe fo percentile estimate%
    sig_pe_100(i,1)=c_2*c_6*mu_pe_100(i,1);
    alfa_pe_100(i,1)=mu_pe_100(i,1)-0.57722*0.7797*sig_pe_100(i,1);
    beita_pe_100(i,1)=0.7797*sig_pe_100(i,1);
    S_100(i,1)=mu_pe_100(i,1)+1.3*sig_pe_100(i,1);
end
[val index_100] = max(S_100(:));
P_100=exp(-exp(-(x_100-(mu_pe_100(index_100)-0.57722*0.7797*sig_pe_100(index_100)))/(0.7797*sig_pe_100(index_100))))
mu_pe_100(index_100,1)
sig_pe_100(index_100,1)
alfa_pe_100(index_100,1)
beita_pe_100(index_100,1)


%10000-year sea state%
S_10000=zeros(217,1);          %S is estimate for the largest response and the worst sea state%
mu_pe_10000=zeros(217,1);
sig_pe_10000=zeros(217,1);
alfa_pe_10000=zeros(217,1);
beita_pe_10000=zeros(217,1);

for i=1:1:217
    mu_pe_10000(i,1)=c_1*Codn_cont_10000(i,1)^c_2*(1+(cos((2*pi*(Codn_cont_10000(i,2)-c_4)/c_5)))^c_3);
    sig_pe_10000(i,1)=c_2*c_6*mu_pe_10000(i,1);
    alfa_pe_10000(i,1)=mu_pe_10000(i,1)-0.57722*0.7797*sig_pe_10000(i,1);
    beita_pe_10000(i,1)=0.7797*sig_pe_10000(i,1);    
    S_10000(i,1)=mu_pe_10000(i,1)+1.3*sig_pe_10000(i,1);
end
[val index_10000] = max(S_10000(:));
P_10000=exp(-exp(-(x_10000-(mu_pe_10000(index_10000)-0.57722*0.7797*sig_pe_10000(index_10000)))/(0.7797*sig_pe_10000(index_10000))))
mu_pe_10000(index_10000,1)
sig_pe_10000(index_10000,1)
alfa_pe_10000(index_10000,1)
beita_pe_10000(index_10000,1)
%note, c_1 has a big effect on the final percentile P_100 and P_10000. here do we need to keep P_100 or P_10000 on a certain level of 85%-90% and then do the compare? or any value is ok? %





%---------------------------------Chapter 4. Peak Over Threshold Method-----------------------------------%

c_1=1;     %scale coefficient for location parameter%
c_2=1;     %coefficient which control linear and quadratic%
c_3=1;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=100;   %coefficient which control sensitive to period or not%
c_6=0.1;   

%short term distribution of response in POT method, Gumbel distribution%
Hs_th=6;                        %threshold for storm, usually taken as 6m%
ind=find(Wdata(:,7)>=Hs_th);    %ind is the index of every 3h-step in the 57 years, find from Wdata%

Nos=1;                          %Nos is number of storms, make Nos=1 because in the following program, the first storm will not be counted%
for i=1:1:length(ind)-1
    if ind(i+1)-ind(i)==1
        Nos=Nos;
    else
        Nos=Nos+1;
    end
end

E=zeros(Nos,1);                 %the number in E denotes the begining of each storm%
E(1,1)=1;                       %due to the code, the first storm is not counted, so define E(1,1)=1%
j=2;
for i=2:1:length(ind)
    if ind(i)-ind(i-1)>1
        E(j,1)=i;
        j=j+1;
    end
end
       
Num_ran=zeros(Nos,1);                    %number of steps in each storm%
for i=1:1:Nos-1
    Num_ran(i)=E(i+1)-E(i);
end
Num_ran(Nos,1)=length(ind)-E(Nos)+1;
Exp_duration=sum(Num_ran(:))/length(Num_ran(:));    %the average number of 3-hour events for each storm event, not for further calculation, just get a feeling for length of storm%

y_max=zeros(length(E)-1,1);                        %y_max is the largest value in each storm, out of the Monte Carlo simulation of each step%
y_tilda=zeros(length(E)-1,1);                      %y_tilda is the largest most probable value in each strom, y_tilda is set equal to alfa_pot%
v_pot=zeros(length(E)-1,1);                        %v_pot is the ratio between y_max and y_tilda, v_pot is also for each storm, not for each step%

%one assumption here is that, the 3h-maximum response is modelled by the Gumbel distribution%

% % Option 1, Doing Monte Carlo Simulation for each step of the storm and find the largest one%
% Num_rlz=100;                               %Number generated for each Monte Carlo Simulation%
% Num_step=E(length(E))-1;
% alfa_pot=zeros(Num_step,1);           %alfa_pot is the parameter for the Gumbel distribution%
% beita_pot=zeros(Num_step,1);          %beita_pot is the parameter for the Gumbel distribution%
% y_tilda=zeros(length(E)-1,1);
% 
% % rng('default')                           %to make matlab generate same set of random numbers every time%
% u_pot=random('unif',0,1,Num_rlz,1);        %u_pot is the random number generated from 0 and 1, used for Monte Carlo simulation%
% x_pot=zeros(Num_step,Num_rlz);                %x_pot is the response value simulated for each step, i.e. the simulated response by using Monte Carlo simulation%
% Num_step=E(length(E))-1;
% 
% for i=1:1:length(E)-1
%     
%     for j=E(i,1):1:(E(i+1)-1)
%         alfa_pot(j,1)=c_1*Wdata(ind(j),7)^c_2*(1+(cos((2*pi*(Wdata(ind(j),8)-c_4)/c_5)))^c_3);
%         beita_pot(j,1)=c_2*c_6*alfa_pot(j,1);
%         u_pot=random('unif',0,1,Num_rlz,1);
%         
%         for k=1:1:Num_rlz
%             x_pot(j,k)=alfa_pot(j,1)-beita_pot(j,1)*log(-log(u_pot(k,1)));
%         end
% 
%     end 
%     
%     y_tilda(i,1)=max(alfa_pot(E(i,1):(E(i+1)-1),1));
%     y_max(i,1)=max(max(x_pot(E(i,1):(E(i+1)-1),:)));
%     v_pot(i,1)=y_max(i,1)/y_tilda(i,1);
% end

%Option 2, doing Monte Carlo Simulation once for each step of storm. Since there are large enough number of storms, the effect of uncertainties should be eliminated%
alfa_pot=zeros(length(ind),1);     %alfa_pot is the parameter for the Gumbel distribution%
beita_pot=zeros(length(ind),1);    %beita_pot is the parameter for the Gumbel distribution%

u_pot=random('unif',0,1,length(ind),1);  %u_pot is the random number generated from 0 and 1, used for Monte Carlo simulation%
x_pot=zeros(length(ind),1);              %x_pot is the response value simulated for each step, i.e. the simulated response by using Monte Carlo simulation%

for i=1:1:length(ind)
    alfa_pot(i,1)=c_1*Wdata(ind(i),7)^c_2*(1+(cos((2*pi*(Wdata(ind(i),8)-c_4)/c_5)))^c_3);
    beita_pot(i,1)=c_2*c_6*alfa_pot(i,1);
    x_pot(i,1)=alfa_pot(i,1)-beita_pot(i,1)*log(-log(u_pot(i,1)));
end

for i=1:1:Nos-1
    y_max(i,1)=max(x_pot(E(i):(E(i+1)-1),1));
    y_tilda(i,1)=max(alfa_pot(E(i):(E(i+1)-1),1));
    v_pot(i,1)=y_max(i,1)/y_tilda(i,1);
end
y_max(Nos,1)=max(x_pot(E(Nos):length(ind),1));            %the code above cannot cover all the y_max, y_tilda, y_pot, so a supplement is added here%
y_tilda(Nos,1)=max(alfa_pot(E(Nos):length(ind),1));
v_pot(Nos,1)=y_max(Nos,1)/y_tilda(Nos,1);


% %start here:insert a littele program here to produce a figure. plot the ind(28)-ind(38) steps%
% x_simu=zeros(11,1);           %simple explation for the numbers here: index=845-855 in Wdata is a storm with 11 3-hour steps. index=28-38 corresponds to the storm in ind(the matrix)%
% for i=1:1:11
%     x_simu(i,1)=1.5+3*(i-1);
% end
% 
% figure(35)
% h1=plot(x_simu(:),alfa_pot(28:38,1),'b','LineWidth',2);
% hold on;
% h2=plot(x_simu(:),x_pot(28:38,1),'r','LineWidth',2);
% hold on;
% h3=plot(x_simu(:),Wdata(845:855,7),'k','LineWidth',2);
% hold on;
% h4=plot(x_simu(:),Wdata(845:855,8),'g','LineWidth',2);
% legend([h1 h2 h3 h4],'y tilda','y realization','H_s','T_p','FontSize',16);
% ylabel('H_s[m] T_p[s] Response','FontWeight','bold','FontSize',16);
% xlabel('Storm Duration[h]','FontWeight','bold','FontSize',16);
% %end here%

%one assumption here is that v_pot obeys Gumbel distribution%
v_mean=sum(v_pot(:,1))/length(v_pot);                     %v_mean is the mean value for v_pot%
v_std=(sum((v_pot(:,1)).^2)/length(v_pot)-v_mean^2)^0.5;  %v_std is the standard deviation for v_pot%
beita_gumb=0.7797*v_std;                                  %beita_gumb is the parameter for the Gumbel distribution%
alfa_gumb=v_mean-0.57722*beita_gumb;                      %alfa_gumb is the parameter for the Gumbel distribution%

v_pot_r=sort(v_pot);                                      %sort v_pot in an asending order for further calculation and plotting%
f_v_pot=zeros(length(v_pot),1);                           %definition of f_v_pot, since each storm has same probability of occurence, the probability for each storm is 1/length(v_pot)%
for i=1:1:length(v_pot)
    f_v_pot(i,1)=1/(length(v_pot)+1);
end
F_v_pot=cumsum(f_v_pot);                                  %cumulative probability of v_pot%

y_v_pot=zeros(length(v_pot),1);                           %cumulative probability calculated from the fitted model, i.e. from alfa_gumb and beita_gumb%
x_gb=zeros(length(v_pot),1);                              %x-value on probablity paper, still v, no change for this one%
y_gb_e=zeros(length(v_pot),1);                            %y-value on probablity paper, calculated from estimatd parameters%
y_gb_r=zeros(length(v_pot),1);                            %y_value on probablity paper, calculated from real value%

for i=1:1:length(v_pot)
    y_v_pot(i,1)=exp(-exp(-(v_pot_r(i,1)-alfa_gumb)/beita_gumb));
    x_gb(i,1)=v_pot_r(i,1);
    y_gb_e(i,1)=x_gb(i,1)/beita_gumb-alfa_gumb/beita_gumb;
    y_gb_r(i,1)=-log(-log(F_v_pot(i,1)));
end

% figure(36)
% h1=plot(x_gb(:),y_gb_e(:),'LineWidth',2);
% hold on;
% h2=plot(x_gb(:),y_gb_r(:),'r.','MarkerSize',5);
% legend([h1 h2],'Fitted Curve','Original Points');
% ylabel('Cumulative Probability on Probablity Paper','FontWeight','bold','FontSize',16);
% xlabel('v','FontWeight','bold','FontSize',16);
% % axis([0.8 2 0 1.1])
 
% figure(37)
% h1=plot(v_pot_r(:),y_v_pot(:),'LineWidth',2);
% hold on;
% h2=plot(v_pot_r(:),F_v_pot(:),'r.','MarkerSize',5);
% legend([h1 h2],'Fitted Curve','Original Points');
% ylabel('Cumulative Probability of v','FontWeight','bold','FontSize',16);
% xlabel('v','FontWeight','bold','FontSize',16);
% axis([0.8 2 0 1.1])


% Num_rlz=20;                                  %Number of realization of both numbers of storms and Monte Carlo Simulation for each step%
Num_storm=1299;

%1.least severe storm%
Num_step=4;                                   %the least severe storm has 4 steps, ind=341-344%
Ind_first_storm_l=341;
Num_rlz=Num_step;

% rng('default')                              %to make matlab generate same set of random numbers every time%
u_pot_l=random('unif',0,1,Num_rlz,1);         %u_pot_l is the random number generated from 0 and 1, used for Monte Carlo simulation%
x_pot_l=zeros(Num_step,Num_rlz);              %x_pot_l is the response value simulated for each step, i.e. the simulated response by using Monte Carlo simulation%
v_pot_l=zeros(Num_storm,1);                     %v_pot_l is the ratio between realization and most porbable value
alfa_pot_l=zeros(Num_step,1);
beita_pot_l=zeros(Num_step,1);
y_max=zeros(Num_storm,1);

for i=1:1:Num_storm
    
    for j=1:1:Num_step
        alfa_pot_l(j,1)=c_1*Wdata(Ind_first_storm_l+j-1,7)^c_2*(1+(cos((2*pi*(Wdata(Ind_first_storm_l+j-1,8)-c_4)/c_5)))^c_3);
        beita_pot_l(j,1)=c_2*c_6*alfa_pot_l(j,1);
        u_pot_l=random('unif',0,1,Num_rlz,1);
        
        for k=1:1:Num_rlz
            x_pot_l(j,k)=alfa_pot_l(j,1)-beita_pot_l(j,1)*log(-log(u_pot_l(k,1)));
        end
    end
    
    y_max(i,1)=max(max(x_pot_l(:,:)));
    y_tilda=max(alfa_pot_l(:,1));
    v_pot_l(i,1)=y_max(i,1)/y_tilda;
end


%one assumption here is that v_pot obeys Gumbel distribution%
v_mean_l=sum(v_pot_l(:,1))/length(v_pot_l);                       %v_mean is the mean value for v_pot%
v_std_l=(sum((v_pot_l(:,1)).^2)/length(v_pot_l)-v_mean_l^2)^0.5;  %v_std is the standard deviation for v_pot%
beita_gumb_l=0.7797*v_std_l;                                      %beita_gumb is the parameter for the Gumbel distribution%
alfa_gumb_l=v_mean_l-0.57722*beita_gumb_l;                        %alfa_gumb is the parameter for the Gumbel distribution%

v_pot_r_l=sort(v_pot_l);                                      %sort v_pot in an asending order for further calculation and plotting%
f_v_pot_l=zeros(length(v_pot_l),1);                           %definition of f_v_pot, since each storm has same probability of occurence, the probability for each storm is 1/length(v_pot)%
for i=1:1:length(v_pot_l)
    f_v_pot_l(i,1)=1/(length(v_pot_l)+1);
end
F_v_pot_l=cumsum(f_v_pot_l);                                  %cumulative probability of v_pot%

x_gb_l=zeros(length(v_pot_l),1);                              %x-value on probablity paper, still v, no change for this one%
y_gb_e_l=zeros(length(v_pot_l),1);                            %y-value on probablity paper, calculated from estimatd parameters%
y_gb_r_l=zeros(length(v_pot_l),1);                            %y_value on probablity paper, calculated from real value%

for i=1:1:length(v_pot_l)
    x_gb_l(i,1)=v_pot_r_l(i,1);
    y_gb_e_l(i,1)=x_gb_l(i,1)/beita_gumb_l-alfa_gumb_l/beita_gumb_l;
    y_gb_r_l(i,1)=-log(-log(F_v_pot_l(i,1)));
end

% figure(37)
% h1=plot(x_gb_l(:),y_gb_e_l(:),'LineWidth',2);
% hold on;
% h2=plot(x_gb_l(:),y_gb_r_l(:),'r.','MarkerSize',5);
% legend([h1 h2],'Fitted Curve','Original Points');
% ylabel('Cumulative Probability on Probablity Paper','FontWeight','bold','FontSize',16);
% xlabel('v','FontWeight','bold','FontSize',16);
% % axis([0.8 2 0 1.1])
 



%2. Medium Severe Storm
Num_step=15;                                   %the least severe storm has 4 steps, ind=35499-35513%
Ind_first_storm_m=35499;
Num_rlz=Num_step;

% rng('default')                              %to make matlab generate same set of random numbers every time%
u_pot_m=random('unif',0,1,Num_rlz,1);         %u_pot_l is the random number generated from 0 and 1, used for Monte Carlo simulation%
x_pot_m=zeros(Num_step,Num_rlz);              %x_pot_l is the response value simulated for each step, i.e. the simulated response by using Monte Carlo simulation%
v_pot_m=zeros(Num_storm,1);                     %v_pot_l is the ratio between realization and most porbable value
alfa_pot_m=zeros(Num_step,1);
beita_pot_m=zeros(Num_step,1);
y_max=zeros(Num_storm,1);

for i=1:1:Num_storm
    
    for j=1:1:Num_step
        alfa_pot_m(j,1)=c_1*Wdata(Ind_first_storm_m+j-1,7)^c_2*(1+(cos((2*pi*(Wdata(Ind_first_storm_m+j-1,8)-c_4)/c_5)))^c_3);
        beita_pot_m(j,1)=c_2*c_6*alfa_pot_m(j,1);
        u_pot_m=random('unif',0,1,Num_rlz,1);
        
        for k=1:1:Num_rlz
            x_pot_m(j,k)=alfa_pot_m(j,1)-beita_pot_m(j,1)*log(-log(u_pot_m(k,1)));
        end
    end
    
    y_max(i,1)=max(max(x_pot_m(:,:)));
    y_tilda=max(alfa_pot_m(:,1));
    v_pot_m(i,1)=y_max(i,1)/y_tilda;
end

%one assumption here is that v_pot obeys Gumbel distribution%
v_mean_m=sum(v_pot_m(:,1))/length(v_pot_m);                       %v_mean is the mean value for v_pot%
v_std_m=(sum((v_pot_m(:,1)).^2)/length(v_pot_m)-v_mean_m^2)^0.5;  %v_std is the standard deviation for v_pot%
beita_gumb_m=0.7797*v_std_m;                                      %beita_gumb is the parameter for the Gumbel distribution%
alfa_gumb_m=v_mean_m-0.57722*beita_gumb_m;                        %alfa_gumb is the parameter for the Gumbel distribution%

v_pot_r_m=sort(v_pot_m);                                      %sort v_pot in an asending order for further calculation and plotting%
f_v_pot_m=zeros(length(v_pot_m),1);                           %definition of f_v_pot, since each storm has same probability of occurence, the probability for each storm is 1/length(v_pot)%
for i=1:1:length(v_pot_m)
    f_v_pot_m(i,1)=1/(length(v_pot_m)+1);
end
F_v_pot_m=cumsum(f_v_pot_m);                                  %cumulative probability of v_pot%

x_gb_m=zeros(length(v_pot_m),1);                              %x-value on probablity paper, still v, no change for this one%
y_gb_e_m=zeros(length(v_pot_m),1);                            %y-value on probablity paper, calculated from estimatd parameters%
y_gb_r_m=zeros(length(v_pot_m),1);                            %y_value on probablity paper, calculated from real value%

for i=1:1:length(v_pot_m)
    x_gb_m(i,1)=v_pot_r_m(i,1);
    y_gb_e_m(i,1)=x_gb_m(i,1)/beita_gumb_m-alfa_gumb_m/beita_gumb_m;
    y_gb_r_m(i,1)=-log(-log(F_v_pot_m(i,1)));
end

% figure(38)
% h1=plot(x_gb_m(:),y_gb_e_m(:),'LineWidth',2);
% hold on;
% h2=plot(x_gb_m(:),y_gb_r_m(:),'r.','MarkerSize',5);
% legend([h1 h2],'Fitted Curve','Original Points');
% ylabel('Cumulative Probability on Probablity Paper','FontWeight','bold','FontSize',16);
% xlabel('v','FontWeight','bold','FontSize',16);
% % axis([0.8 2 0 1.1])


% 3. Most Severe Storm
Num_step=9;                                   %the least severe storm has 4 steps, ind=35499-35513%
Ind_first_storm_s=141313;
Num_rlz=Num_step;

% rng('default')                              %to make matlab generate same set of random numbers every time%
u_pot_s=random('unif',0,1,Num_rlz,1);         %u_pot_l is the random number generated from 0 and 1, used for Monte Carlo simulation%
x_pot_s=zeros(Num_step,Num_rlz);              %x_pot_l is the response value simulated for each step, i.e. the simulated response by using Monte Carlo simulation%
v_pot_s=zeros(Num_storm,1);                     %v_pot_l is the ratio between realization and most porbable value
alfa_pot_s=zeros(Num_step,1);
beita_pot_s=zeros(Num_step,1);
y_max=zeros(Num_storm,1);

for i=1:1:Num_storm
    
    for j=1:1:Num_step
        alfa_pot_s(j,1)=c_1*Wdata(Ind_first_storm_s+j-1,7)^c_2*(1+(cos((2*pi*(Wdata(Ind_first_storm_s+j-1,8)-c_4)/c_5)))^c_3);
        beita_pot_s(j,1)=c_2*c_6*alfa_pot_s(j,1);
        u_pot_s=random('unif',0,1,Num_rlz,1);
        
        for k=1:1:Num_rlz
            x_pot_s(j,k)=alfa_pot_s(j,1)-beita_pot_s(j,1)*log(-log(u_pot_s(k,1)));
        end
    end
    
    y_max(i,1)=max(max(x_pot_s(:,:)));
    y_tilda=max(alfa_pot_s(:,1));
    v_pot_s(i,1)=y_max(i,1)/y_tilda;
end

%one assumption here is that v_pot obeys Gumbel distribution%
v_mean_s=sum(v_pot_s(:,1))/length(v_pot_s);                       %v_mean is the mean value for v_pot%
v_std_s=(sum((v_pot_s(:,1)).^2)/length(v_pot_s)-v_mean_s^2)^0.5;  %v_std is the standard deviation for v_pot%
beita_gumb_s=0.7797*v_std_s;                                      %beita_gumb is the parameter for the Gumbel distribution%
alfa_gumb_s=v_mean_s-0.57722*beita_gumb_s;                        %alfa_gumb is the parameter for the Gumbel distribution%

v_pot_r_s=sort(v_pot_s);                                      %sort v_pot in an asending order for further calculation and plotting%
f_v_pot_s=zeros(length(v_pot_s),1);                           %definition of f_v_pot, since each storm has same probability of occurence, the probability for each storm is 1/length(v_pot)%
for i=1:1:length(v_pot_s)
    f_v_pot_s(i,1)=1/(length(v_pot_s)+1);
end
F_v_pot_s=cumsum(f_v_pot_s);                                  %cumulative probability of v_pot%

x_gb_s=zeros(length(v_pot_s),1);                              %x-value on probablity paper, still v, no change for this one%
y_gb_e_s=zeros(length(v_pot_s),1);                            %y-value on probablity paper, calculated from estimatd parameters%
y_gb_r_s=zeros(length(v_pot_s),1);                            %y_value on probablity paper, calculated from real value%

for i=1:1:length(v_pot_s)
    x_gb_s(i,1)=v_pot_r_s(i,1);
    y_gb_e_s(i,1)=x_gb_s(i,1)/beita_gumb_s-alfa_gumb_s/beita_gumb_s;
    y_gb_r_s(i,1)=-log(-log(F_v_pot_s(i,1)));
end



figure(40)
h1=plot(x_gb(:),y_gb_e(:),'-b','LineWidth',4);
hold on;
h2=plot(x_gb(:),y_gb_r(:),'b+','MarkerSize',8);

h3=plot(x_gb_l(:),y_gb_e_l(:),'--m','LineWidth',4);
hold on;
h4=plot(x_gb_l(:),y_gb_r_l(:),'m*','MarkerSize',8);

h5=plot(x_gb_m(:),y_gb_e_m(:),'-.g','LineWidth',4);
hold on;
h6=plot(x_gb_m(:),y_gb_r_m(:),'go','MarkerSize',8);

h7=plot(x_gb_s(:),y_gb_e_s(:),':k','LineWidth',4);
hold on;
h8=plot(x_gb_s(:),y_gb_r_s(:),'kx','MarkerSize',8);

AX=legend([h1 h3 h5 h7],'Fitting for All Storm','Fitting for Least Severe Storm','Fitting for Medium Severe Storm','Fitting for Most Severe Storm','Location','NorthWest');
LEG = findobj(AX,'type','text');
set(LEG,'FontSize',25)
ylabel('Gumbel Probability Paper','FontWeight','bold','FontSize',25);
xlabel('v','FontWeight','bold','FontSize',25);
axis([0.7 2 -3 8])
set(gca,'fontsize',25)



