clc
clf
clear all
close all
Wdata=load('\\sambaad.stud.ntnu.no\tianzuoy\Desktop\Thesisdata.txt');

%------------------------------Chapter 1. Notation of Generic Response System--------------------------------%

% %this part is better explained in another matlab code demo_of_para_for_rsp%
% 
% %linear response case independent of spectral period%
% c_1=1;                 %scale coefficient for location parameter%
% c_2=1;                 %coefficient which control linear and quadratic%
% c_3=1;                 %negligible when response independent of Tp, large value when response sensitive of Tp%
% c_4=15;                %coefficient which control when occurs the most probable peak period%
% c_5=100;               %coefficient which control sensitive to period or not%
% c_6=0.1;               %coefficient whch control the uncertainty% 
% Hs=0:0.1:16;           %significant wave height%
% Tp=2:0.1:23;
% alfa_1_h=zeros(161,1);
% alfa_1_t=zeros(211,1);
% miu_p_t=zeros(211,1);
% sigma_p_t=zeros(211,1);
% 
% for i=1:1:161
%     alfa_1_h(i,1)=c_1*Hs(i)^c_2*(1+(cos((2*pi*(Tp(100)-c_4)/c_5)))^c_3);
% end
% 
% for i=1:1:211
%     alfa_1_t(i,1)=c_1*Hs(101)^c_2*(1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3);
% end
% 
% %quadratic response case independent of spectral period Tp%
% c_1=1;     %scale coefficient for location parameter%
% c_2=2;     %coefficient which control linear and quadratic%
% c_3=1;     %negligible when response independent of Tp, large value when response sensitive of Tp%
% c_4=15;    %coefficient which control when occurs the most probable peak period%
% c_5=100;   %coefficient which control sensitive to period or not%
% c_6=0.1;   %measure of variability around the mean 30-minute maximum%
% 
% alfa_2_t=zeros(211,1);
% alfa_2_h=zeros(161,1);
% 
% for i=1:1:161
%     alfa_2_h(i,1)=c_1*Hs(i)^c_2*(1+(cos((2*pi*(Tp(100)-c_4)/c_5)))^c_3);
% end
% 
% for i=1:1:211
%     alfa_2_t(i,1)=c_1*Hs(101)^c_2*(1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3);
% end
% 
% 
% figure(1)
% h1=plot(Hs(1:161),alfa_1_h(1:161),'b','LineWidth',2);
% hold on;
% h2=plot(Hs(1:161),alfa_2_h(1:161),'r','LineWidth',2);
% legend([h1 h2],'Linear Response Case','Quadratic Response Case','Location','SouthEast');
% ylabel('Location Paramter alfa','FontWeight','bold','FontSize',16);
% xlabel('Significant Wave Height','FontWeight','bold','FontSize',16);
% 
% figure(2)
% h1=plot(Tp(1:211),alfa_1_t(1:211),'b','LineWidth',2);
% hold on;
% h2=plot(Tp(1:211),alfa_2_t(1:211),'r','LineWidth',2);
% legend([h1 h2],'Linear Response Case','Quadratic Response Case','Location','SouthEast');
% ylabel('Location Paramter alfa','FontWeight','bold','FontSize',16);
% xlabel('Peak Period','FontWeight','bold','FontSize',16);
% axis([0 25 0 220]);


% %linear response case sensitive to spectral period%
% c_1=1;     %scale coefficient for location parameter%
% c_2=1;     %coefficient which control linear and quadratic%
% c_3=100;     %negligible when response independent of Tp, large value when response sensitive of Tp%
% c_4=15;    %coefficient which control when occurs the most probable peak period%
% c_5=60;   %coefficient which control sensitive to period or not%
% c_6=0.1;   %measure of variability around the mean 30-minute maximum%
% 
% alfa_3=zeros(211,1);
% 
% for i=1:1:211
%     alfa_3(i,1)=c_1*Hs(101)^c_2*(1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3);
% end
% 
% %quadratic response case sensitive to spectral period%
% c_1=1;     %scale coefficient for location parameter%
% c_2=2;     %coefficient which control linear and quadratic%
% c_3=100;     %negligible when response independent of Tp, large value when response sensitive of Tp%
% c_4=15;    %coefficient which control when occurs the most probable peak period%
% c_5=60;   %coefficient which control sensitive to period or not%
% c_6=0.1;   %measure of variability around the mean 30-minute maximum%
% 
% alfa_4=zeros(211,1);
% 
% for i=1:1:211
%     alfa_4(i,1)=c_1*Hs(101)^c_2*(1+(cos((2*pi*(Tp(i)-c_4)/c_5)))^c_3);
% end
% 
% figure(3)
% h1=plot(Tp(1:211),alfa_3(1:211),'b','LineWidth',2);
% hold on;
% h2=plot(Tp(1:211),alfa_4(1:211),'r','LineWidth',2);
% legend([h1 h2],'Linear Response Case','Quadratic Response Case','Location','SouthEast');
% ylabel('Location Paramter alfa','FontWeight','bold','FontSize',16);
% xlabel('Peak Period','FontWeight','bold','FontSize',16);
% axis([0 25 0 220]);

%----------------------------Chapter 2. Joint Probability Distribution Function--------------------------------%

%------------------------------Scatter Diagram-----------------------------------%

%find largest and lowest wave height and wave period%
Hs_max_real=max(Wdata(:,7));      
Hs_min_real=min(Wdata(:,7));     
Tp_max_real=max(Wdata(:,8));     
Tp_min_real=min(Wdata(:,8));   

Hs_max=17;    %manually find%
Hs_min=0;     %manually find%
Tp_max=23;    %manually find%
Tp_min=2;     %manually find%

%now we use wave height i as column, use wave period j as row%
n=length(Wdata(:,7));
interval_hs=0.5;
interval_tp=1;
scatter=zeros(Hs_max/interval_hs,(Tp_max-Tp_min)/interval_tp);

for k=1:1:n;
    for i=Hs_min/interval_hs:1:Hs_max/interval_hs-1;
        for j=Tp_min/interval_tp:1:Tp_max/interval_tp-1;
            if (Wdata(k,7)>i*0.5)&(Wdata(k,7)<=i*0.5+0.5)&(Wdata(k,8)>j)&(Wdata(k,8)<=j+1);
                scatter(i+1,j-1)=scatter(i+1,j-1)+1;
            end
        end
    end
end
N=sum(sum(scatter,2));

%------------------------------Distribution of Hs-----------------------------------%

%get the probability by plotting on the probability paper, need define interval for the cumulative function%
interval=0.2;
num_row=17/interval-1;                         %because the minimum wave height is 0.3, so there will be no wave in interval 0-0.2%
h_distribution=zeros(num_row,1);

for i=1:1:num_row
    for j=1:1:163133
        if (Wdata(j,7)>(i*interval))&(Wdata(j,7)<=(i+1)*interval)
            h_distribution(i,1)=h_distribution(i,1)+1;
        end
    end
end

fHm0=zeros(num_row,1);
for i=1:1:num_row
    fHm0(i,1)=h_distribution(i,1)/(N+1);
    h_s(i,1)=i*interval;
    ln_h_s(i,1)=log(i*interval);
end

F_H=cumsum(fHm0);
y=log(-log(1-F_H));

%In this thesis, we use three parameter Weibull distribution.%

lp=0:0.2:(2-0.2);    %lp: location parameter. By experience that lp should be less than 1. So the range is taken from 0 to 2 with an interval of 0.2%
ln_hs=zeros(num_row,2/0.2);
      
for i=1:1:num_row
    for j=1:1:2/0.2
              ln_hs(i,j)=log(h_s(i)-lp(j));
    end
end

kay_1=zeros(2/0.2,1);
lamda_1=zeros(2/0.2,1);
devia_1=zeros(2/0.2,1);


for i=1:1:2/0.2
  [cfun,gof,output]=fit(ln_hs(i:num_row,i),y(i:num_row,1),'poly1');
  cfun;
  gof;
  output;
  kay_1(i,1)=cfun.p1;
  lamda_1(i,1)=exp(-cfun.p2/cfun.p1);
    for j=i:1:num_row
        devia_1(i,1)=devia_1(i,1)+(kay_1(i,1)*ln_hs(j,i)-kay_1(i,1)*log(lamda_1(i,1))-y(j,1))^2;
    end
        devia_1(i,1)=(devia_1(i,1)/(num_row-i))^0.5;
end

% figure(5)
% h1=plot(lp(1:2/0.2),devia_1,'r.','MarkerSize',5);    %as can be seen from the figure, when lp=0.4, the deviation has the minimum value.%
%                                                   %when lp=0.4, lamda_1= , kay_1= %
% ylabel('Standard Deviation','FontWeight','bold','FontSize',16);
% xlabel('Location Parameter','FontWeight','bold','FontSize',16);
% axis([0 2 0 0.4]);
% 
% % now use eye fittinig B)%
% for i=1:1:5               %here it plots when lp=0, 0.2, 0.4, 0.6, 0.8%
%     figure(i+5)
%     h1=plot(ln_hs(i:84,i),y(i:84,1),'r*','MarkerSize',12);
%     ylabel('Weibull Probability Paper','FontWeight','bold','FontSize',25);
%     xlabel('ln(h_s- \theta)','FontWeight','bold','FontSize',25);
%     hold on;
%     h2=plot(ln_hs(i:84,i),kay_1(i,1)*ln_hs(i:84,i)-kay_1(i,1)*log(lamda_1(i,1)),'LineWidth',4);
%     AX=legend([h1 h2],'Original Points','Fitted Curve','Location','NorthWest');
%     LEG = findobj(AX,'type','text');
%     set(LEG,'FontSize',25)
%     set(gca,'fontsize',25)
% end                       %by both diviation and eye fitting, we can see that when lp=0.4, it is the best fit%
                                                  
lp_final=0.4;
kay_1_final=1.2851;
lamda_1_final=2.2491;

% figure(11)
% y_fig2=zeros(84,1);
% for i=1:1:84
%     y_fig2(i,1)=1-exp(-((h_s(i,1)-lp_final)/lamda_1_final)^kay_1_final);
% end
% h1=plot(h_s(3:84),y_fig2(3:84),'LineWidth',4);
% hold on;
% h2=plot(h_s(1:84),F_H(1:84),'r*','MarkerSize',8);
% 
% AX=legend([h1 h2],'Fitted Curve','Original Points','Location','NorthWest');
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',25)
% ylabel('Cumulative Probability of h_s','FontWeight','bold','FontSize',25);
% xlabel('Significant Wave Height h_s(m)','FontWeight','bold','FontSize',25);
% axis([0 18 0 1.2])
% set(gca,'fontsize',25)

hs_extr=zeros(6,1);
q_extr=[0.63;0.1;0.01;0.001;0.0001;0.00001];
for i=1:1:6
%     hs_extr(i,1)=exp(1/kay_1_final*log(-log(1-q_extr(i)/2920))+log(lamda_1_final))+lp_final;
    hs_extr(i,1)=lamda_1_final*(-log(q_extr(i)/2920))^(1/kay_1_final)+lp_final;
end
  
%-------------------Distribution of T_p given H_s-------------------------%

%first get mean and variance number of Tp in each interval%

for i=0:1:(num_row-1)
    index=find(Wdata(:,7)>(i*interval)&Wdata(:,7)<=(i*interval)+1);
    Length_tp=length(index);
    Tp_mean(i+1)=sum(log(Wdata(index,8)))/Length_tp;
    Tp_var(i+1)=sum((log(Wdata(index,8))).^2)/Length_tp-(Tp_mean(i+1)).^2;
end

%now the nonlinear fit for miu and var%
p=[-1;1;-1];                                                           %define two initial value%
q=[0.0011;0.1147;0.308];
mu=@(p,x)(p(1)+p(2)*x.^p(3));                                          %function of the variable%
varia=@(q,x)(q(1)+q(2)*exp(-x.*q(3)));

% p_val=nlinfit(Hs_ran(2:(17/interval+1)),Tp_mean,mu,p);                 %nonlinear fit process%
% q_val=nlinfit(Hs_ran(2:(17/interval+1)),Tp_var,varia,q);

p_val=[1.09;1.019;0.2];                                                %by studying the automatic fitting, some optimized value has been proposed%

Hs_estm_max=25;
Tp_estm_max=30;

for i=1:1:Hs_estm_max/interval+1
    Hs_ran(i,1)=(i-1)*interval;
end

mu_val=p_val(1)+p_val(2).*Hs_ran(1:Hs_estm_max/interval).^p_val(3);
% q_val=[0.00073;0.1122;0.32];    
% q_val=[0.001;0.0992;0.30]; 
% q_val=[0.003;0.1022;0.33];
q_val=[0.005;0.1022;0.36];  

sig_val=q_val(1)+q_val(2).*exp(-Hs_ran(1:Hs_estm_max/interval).*q_val(3));

% figure(12)
% h2=plot(Hs_ran(2:76),Tp_mean(2:76),'r*','MarkerSize',10);               %76 is 17/interval+1-10, this is also wield to me, but it's the only way it works%
% hold on;
% h1=plot(Hs_ran(1:Hs_estm_max/interval),mu_val,'LineWidth',4);          %86 is 17/interval+1, below in figure(3) is the same%
% axis([0 25 1.5 3.1]);
% set(gca,'fontsize',25)
% ylabel('Mean Value of ln(T_p) for Each H_s Interval','FontWeight','bold','FontSize',25);
% xlabel('H_s(m)','FontWeight','bold','FontSize',25);
% AX=legend([h1 h2],'Fitted Curve','Original Points','Location','Northwest');
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',25)
%
% figure(13)
% h2=plot(Hs_ran(2:76),Tp_var(2:76),'r*','MarkerSize',10);
% hold on;
% h1=plot(Hs_ran(1:Hs_estm_max/interval),sig_val,'LineWidth',4);
% % axis([0 28 0 0.08]);
% set(gca,'fontsize',25)
% ylabel('Variance of ln(T_p) for Each H_s Interval','FontWeight','bold','FontSize',25);
% xlabel('H_s(m)','FontWeight','bold','FontSize',25);
% AX=legend([h1 h2],'Fitted Curve','Original Points','Location','Northwest');
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',25)


%-----------------------Verification of Joint Distribution Function-------------------------%

%get the probability density for each interval of hs%
scatter_veri_hs_bs=zeros(Hs_estm_max/interval,1);    %before scale%
scatter_veri_hs=zeros(Hs_estm_max/interval,1);       %after scale%

for i=3:1:round(Hs_estm_max/interval)-1
    scatter_veri_hs_bs(i,1)=(1-exp(-((Hs_ran(i+1)-lp_final)/lamda_1_final)^kay_1_final))-(1-exp(-((Hs_ran(i)-lp_final)/lamda_1_final)^kay_1_final));
end

P_veri_hs_bs=sum(scatter_veri_hs_bs); 

for i=3:1:round(Hs_estm_max/interval)-1
    scatter_veri_hs(i,1)=scatter_veri_hs_bs(i,1)/P_veri_hs_bs;
end
P_veri_hs=sum(scatter_veri_hs); 

 %get the probability for tp given hs%
scatter_veri_tp_bs=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
scatter_veri_tp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
P_veri_tp_bs=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp_bs(i,j)=(0.5*erfc(-(log(j*interval)-mu_val(i))/(sig_val(i)^0.5*2^0.5)))-(0.5*erfc(-(log((j-1)*interval)-mu_val(i))/(sig_val(i)^0.5*2^0.5)));
    end
end

P_veri_tp_bs=sum(scatter_veri_tp_bs,2);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_tp(i,j)=scatter_veri_tp_bs(i,j)/P_veri_tp_bs(i,1);
    end
end

P_veri_tp=sum(scatter_veri_tp,2);

%get the probability for each hs and tp interval%
scatter_veri_hstp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_veri_hstp(i,j)=scatter_veri_hs(i,1)*scatter_veri_tp(i,j);
    end
end

P_veri_hstp=sum(sum(scatter_veri_hstp,2));







%---------------------------------Chapter 3. Uncertainty Quatification-----------------------------------%

c_1=1;     %scale coefficient for location parameter%
c_2=2;     %coefficient which control linear and quadratic%
c_3=100;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=60;   %coefficient which control sensitive to period or not%
c_6=0.1;   %measure of variability around the mean 30-minute maximum%

% f_hstp=kay_1_final/lamda_1_final*((hs-lp)/lamda_1_final)^(kay_1_final-1)*exp(-((hs-lp)/lamda_1_final)^kay_1_final)*    1/(tp*(2*pi*(q(1)+q(2)*exp(-hs*q(3))))^0.5)*exp(-0.5*((log(tp)-(p(1)+p(2)*hs^p(3)))/(q(1)+q(2)*exp(-hs*q(3))))^2);  
                                                                                                                                                                  
% F_x_hstp=exp(-exp((-x+(c_1*hs^c_2*(1+(cos((2*pi*(tp-c_4)/c_5)))^c_3)-0.57722*(0.7797*c_2*c_6*(c_1*hs^c_2*(1+(cos((2*pi*(tp-c_4)/c_5)))^c_3)))))/(0.7797*c_2*c_6*(c_1*hs^c_2*(1+(cos((2*pi*(tp-c_4)/c_5)))^c_3)))));

%using definition of integration%
scatter_rsp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);        %matrix of response for all sea state%
scatter_rsp_hstp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);   %matrix of response for each hs and tp interval%
int=1;
if c_2==1&&c_5==100
    X_extm_max=67;                     %define X_estm_max=160 is because P_veri_rsp(X_estm_max=160)=1.000000(exact 1), so X_estm_max=160 is a safe estimation of maximum response value%
else if c_2==2&&c_5==100
        X_extm_max=1420;
    else if c_2==1&&c_5==60
            X_extm_max=53;
        else 
            X_extm_max=1056;
        end
    end
end
P_veri_rsp=zeros(X_extm_max/int,1);
Ad_y=zeros(X_extm_max/int,1);                                        %fitted y value for Gumbel distribution%
Ad_y_fit=zeros(X_extm_max/int,1); 

hs_rsp=zeros(Hs_estm_max/interval,1);  %middle point for each hs interval%     
tp_rsp=zeros(Tp_estm_max/interval,1);  %middle point for each tp interval%
scatter_rsp_hstp_veri=zeros(Hs_estm_max/interval,Tp_estm_max/interval);

%problem may lies in how to get the scatter diagram, should be F(x+1)-F(x), not each F(x) for each x%
for k=1:1:2000
    x(k,1)=k;
end

for k=1:1:X_extm_max/int
    for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        x(k,1)=k;
        hs_rsp(i,1)=(i-0.5)*interval;
        tp_rsp(j,1)=(j-0.5)*interval;
        
        scatter_rsp_hstp(i,j)=exp(-exp((-x(k)+(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)-0.57722*(0.7797*c_2*c_6*(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)))))/(0.7797*c_2*c_6*(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)))));
        scatter_rsp(i,j)=scatter_veri_hstp(i,j)*scatter_rsp_hstp(i,j);
%         miu=(c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3))
%         sig=(c_2*c_6*c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3))
%         alfa=((c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3))-0.57722*0.7797*(c_2*c_6*c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3)))
%         beta=(0.7797*(c_2*c_6*c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3)))
    end
    end
    P_veri_rsp(k,1)=sum(sum(scatter_rsp,2));
    Ad_y(k,1)=-log(-log(P_veri_rsp(k,1)));
end

%The corresponding exceedance per 3-hour sea state is 10e-5/2920 = 1/292000000. The corresponding cumulative probability = 1-1/292000000. 
%If introduce into ln (-ln (F)) you get 19.49. There is no need to go higher response levels than what corresponds to 20.
%In the Ad_y matrix, Ad_y(94,1)=19.9768, >19.49. Thus only consier values below 94
index=find(Ad_y(:,1)>10&Ad_y(:,1)<20);               %purpose is to do a better fitting for tail data, not affected by the previous data%
C=find(Ad_y(:,1)>10&Ad_y(:,1)<20,1,'last');            %find the last original data needed in the plot%
D=find(Ad_y(:,1)>10&Ad_y(:,1)<20,1,'first');
Q=C+5/int;

[dfun,gof,output]=fit(x(index),Ad_y(index),'poly1');
dfun;
gof;
output;

for k=1:1:X_extm_max/int
    Ad_y_fit(k,1)=dfun.p1*x(k)+dfun.p2;
end

% figure(14)
% h1=plot(x(1:C),Ad_y(1:C),'r*','MarkerSize',8);
% hold on;
% h2=plot(x(D:Q),Ad_y_fit(D:Q),'LineWidth',4);
% AX=legend([h1 h2],'Original Data','Estimated Line','Location','NorthWest');
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',25)
% ylabel('Gumbel Probability Paper','FontWeight','bold','FontSize',25);
% xlabel('Response Value','FontWeight','bold','FontSize',25);
% set(gca,'fontsize',25)
% % axis([0 55 -5 25])
% set(gca,'fontsize',25)

%verification of fitted model%
F_10=1-1/(10*365*24/3);
F_100=1-1/(100*365*24/3);          %ULS case%
F_10000=1-1/(10000*365*24/3);      %ALS case%
F_100000=1-1/(100000*365*24/3);

x_10=1/dfun.p1*(-dfun.p2+(-log(-log(F_10))))
x_100=1/dfun.p1*(-dfun.p2+(-log(-log(F_100))))
x_10000=1/dfun.p1*(-dfun.p2+(-log(-log(F_10000))))
% x_100000=1/dfun.p1*(-dfun.p2+(-log(-log(F_100000))))    %set to be the upper limit for all the fitting%


%non-exceedance,exceedance for response and relative cases%
scatter_nonex=zeros(Hs_estm_max/interval,Tp_estm_max/interval);        %scatter diagram for non-exceedance probability for given hs and tp%
scatter_ex=zeros(Hs_estm_max/interval,Tp_estm_max/interval);           %scatter diagram for exceedance probability for given hs and tp%
scatter_nonex_veri=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
scatter_ex_rsp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);       %scatter diagram for exceedance probability for generic cases%
scatter_rel_ex_rsp=zeros(Hs_estm_max/interval,Tp_estm_max/interval);   %scatter diagram for relative exceedance probability for generic cases%

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        hs_rsp(i,1)=(i-0.5)*interval;
        tp_rsp(j,1)=(j-0.5)*interval;
        mu_la=c_1*hs_rsp(i,1)^c_2*(1+(cos(2*pi*(tp_rsp(j,1)-c_4)/c_5))^c_3);
        sigma_la=c_2*c_6*mu_la;
        beta_la=0.7797*sigma_la;
        alpha_la=mu_la-0.5772*beta_la;
        scatter_nonex(i,j)=exp(-exp((-x_100+(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)-0.57722*(0.7797*c_2*c_6*(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)))))/(0.7797*c_2*c_6*(c_1*hs_rsp(i)^c_2*(1+(cos((2*pi*(tp_rsp(j)-c_4)/c_5)))^c_3)))));
        scatter_ex(i,j)=1-scatter_nonex(i,j);
        scatter_ex_rsp(i,j)=scatter_veri_hstp(i,j)*scatter_ex(i,j);
    end
end

A=sum(sum(scatter_ex_rsp,2));
for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        scatter_rel_ex_rsp(i,j)=scatter_ex_rsp(i,j)/A;
    end
end


%contour line of scatter_rsp%
Codn=zeros(Hs_estm_max/interval*Tp_estm_max/interval,3);
for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        Codn(Tp_estm_max/interval*i-Tp_estm_max/interval+j,1)=hs_rsp(i,1);
        Codn(Tp_estm_max/interval*i-Tp_estm_max/interval+j,2)=tp_rsp(j,1);
        Codn(Tp_estm_max/interval*i-Tp_estm_max/interval+j,3)=scatter_rel_ex_rsp(i,j);
    end
end

% figure(31)     %the question here is how to plot scatter_rel_ex_rsp%
% [HS TP] = meshgrid(9:0.005:20, 14.5:0.005:19);
% RSP = griddata(Codn(:,1), Codn(:,2), Codn(:,3), HS, TP);
% F = [.05 .1 .05; .1 .4 .1; .05 .1 .05];
% ZC = conv2(RSP,F,'same');
% ZC1= conv2(ZC,F,'same');
% zlevs = 0.01:0.016:0.23;
% contour(HS, TP, ZC1, zlevs, 'ShowText','on')
% ylabel('TP','FontWeight','bold','FontSize',16);
% xlabel('HS','FontWeight','bold','FontSize',16);
% % axis([11 20 15 19])
% colormap cool
% set(gca,'YDir','Reverse')


%--------------------------------------------Below Belong to Chapter 2--------------------------------------------------%

 %some figures for fitting of tp given hs%     
 %first, method of moment. Find mu_tp and sig_tp, with known distribution function, using autofitting tool in matlab to find the parameters%
I=6;
J=Tp_estm_max;
F_tp_mom=zeros(I,150);
inte=2;
Tp_mean_mom=zeros(I,1);        %8 is (Hs_estm-1)/2%
Tp_var_mom=zeros(I,1);
F_tp=zeros(I,150);                      %I take ten examples from hs(2,4,6,8,..., 20)and get each hs's cumulative probability for increasing tp%
F_tp_real=zeros(I,150);
ln_tp=zeros(150,1);
X=zeros(150,I);


% for i=1:1:I
%     index=find(Wdata(:,7)>(i*inte-interval)&Wdata(:,7)<=(i*inte));
%     Length_tp=length(index);
%     Tp_mean_mom(i)=sum(log(Wdata(index,8)))/Length_tp;
%     Tp_var_mom(i)=sum((log(Wdata(index,8))).^2)/Length_tp-(Tp_mean_mom(i)).^2;
%    
%    for j=1:1:150   
%      F_tp_mom(i,j)=0.5*erfc(-(log(tp_rsp(j))-Tp_mean_mom(i))/(2*Tp_var_mom(i))^0.5);
%      index_hs=find((Wdata(:,7)<hs_rsp(10*i)+0.1)&(Wdata(:,7)>hs_rsp(10*i)-0.1));
%      index_tp_hs=find((Wdata(:,8)<j*0.2)&(Wdata(:,7)<hs_rsp(10*i)+0.1)&(Wdata(:,7)>hs_rsp(10*i)-0.1));
%      F_tp_real(i,j)=length(index_tp_hs)/length(index_hs);
%      ln_tp(j)=log(tp_rsp(j));
%      X(j,i)=norminv(F_tp_real(i,j),0,1);
%    end
%    
%    figure(i+17)
%    h1=plot(tp_rsp(1:150,1),F_tp_real(i,1:150),'r*','MarkerSize',10);
%    ylabel('Cumulative Probability for t_p','FontWeight','bold','FontSize',30);
%    xlabel('t_p(s)','FontWeight','bold','FontSize',30);
%    hold on;
%    h2=plot(tp_rsp(1:150,1),F_tp_mom(i,1:150),'LineWidth',4);
%    AX=legend([h1 h2],'Original Points','Fitted Curve','Location','NorthWest');
%    LEG = findobj(AX,'type','text');
%    set(LEG,'FontSize',30)
%    axis([0 30 0 1.1])
%    set(gca,'fontsize',30)
% end
   
%seconde, use linear fitting method
% miu_2=zeros(I,1);
% sig_2=zeros(I,1);
% 
% for i=1:1:6
%     index=find(X(:,i)>-10&X(:,i)<10);      
%     [cfun,gof,output]=fit(ln_tp(index),X(index,i),'poly1');
%     cfun;
%     gof;
%     output;
%     sig_2(i,1)=1/cfun.p1;
%     miu_2(i,1)=-cfun.p2/cfun.p1;
% 
%    figure(i+23)
%    h1=plot(tp_rsp(1:150,1),F_tp_real(i,1:150),'r*','MarkerSize',10);
%    ylabel('Cumulative Probability for t_p','FontWeight','bold','FontSize',30);
%    xlabel('t_p(s)','FontWeight','bold','FontSize',30);
%    hold on;
%    h2=plot(tp_rsp(1:150,1),normcdf(ln_tp(:),miu_2(i,1),sig_2(i,1)),'LineWidth',4);
%    AX=legend([h1 h2],'Original Points','Fitted Curve','Location','NorthWest');
%    LEG = findobj(AX,'type','text');
%    set(LEG,'FontSize',30)
%    axis([0 30 0 1.1])
%    set(gca,'fontsize',30)
% end
% comparison for the previous two methods, whcih simulates better?
%--------------------------------------------Previous Belong to Chapter 2--------------------------------------------------%


%environmental contour line method%
B=norminv(0.01/2920);                                 %here remains the question how to find the approximate number but not integral, i.e. 4.4983 to 4.5 but not 5%
R_max_100=4.5;                                        %radius for the 10e-2 annual probability sphere%
int=0.1;                                              %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                      %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_100*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t=zeros((R_max_100*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_100=zeros((R_max_100*2/int)*2+1,2);         %coordinates for each point in the physical space%


for i=1:1:R_max_100*2/int+1
    u_1(i,1)=-R_max_100+int*(i-1);
    u_2(i,1)=(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con=q_val(1)+q_val(2)*exp(-h(i,1)*q_val(3));
    t(i,1)=exp(mu_val_con+sig_val_con^0.5*u_2(i,1));
end

for i=R_max_100*2/int+2:1:(R_max_100*2/int)*2+1
    u_1(i,1)=R_max_100-int*(i-R_max_100*2/int-1);
    u_2(i,1)=-(R_max_100^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con=q_val(1)+q_val(2)*exp(-h(i,1)*q_val(3));
    t(i,1)=exp(mu_val_con+sig_val_con^0.5*u_2(i,1));
end

for i=1:1:(R_max_100*2/int)*2+1
    Codn_cont_100(i,1)=h(i,1);
    Codn_cont_100(i,2)=t(i,1);
end
   
R_max_10000=5.4;                                        %radius for the 10e-4 annual probability sphere%
int=0.1;                                                %interval for the increment of the axis of the annual probability sphere%
u_1=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to hs in the axial system of standard normal distribution%
                                                        %the purpose of '+1' in '(R_max*2/int)*2+1' is to make the contour a complete circle. But to notice that without the '+1', it has covered every point needed% %
u_2=zeros((R_max_10000*2/int)*2+1,1);                   %parameter related to tp in the axial system of standard normal distribution%
h=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for hs in the physical space%
t=zeros((R_max_10000*2/int)*2+1,1);                     %coordinates for tp in the physical space%
Codn_cont_10000=zeros((R_max_10000*2/int)*2+1,2);       %coordinates for each point in the physical space%


for i=1:1:R_max_10000*2/int+1
    u_1(i,1)=-R_max_10000+int*(i-1);
    u_2(i,1)=(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con=q_val(1)+q_val(2)*exp(-h(i,1)*q_val(3));
    t(i,1)=exp(mu_val_con+sig_val_con^0.5*u_2(i,1));
end

for i=R_max_10000*2/int+2:1:(R_max_10000*2/int)*2+1
    u_1(i,1)=R_max_10000-int*(i-R_max_10000*2/int-1);
    u_2(i,1)=-(R_max_10000^2-u_1(i,1)^2)^0.5;
    h(i,1)=lp_final+lamda_1_final*(-log(1-normcdf(u_1(i,1),0,1)))^(1/kay_1_final);
    
    mu_val_con=p_val(1)+p_val(2)*h(i,1)^p_val(3);
    sig_val_con=q_val(1)+q_val(2)*exp(-h(i,1)*q_val(3));
    t(i,1)=exp(mu_val_con+sig_val_con^0.5*u_2(i,1));
end

for i=1:1:(R_max_10000*2/int)*2+1
    Codn_cont_10000(i,1)=h(i,1);
    Codn_cont_10000(i,2)=t(i,1);
end
   
% figure(32)
% h1=plot(Codn_cont_100(:,2),Codn_cont_100(:,1),'g','LineWidth',2);
% hold on;
% h2=plot(Codn_cont_10000(:,2),Codn_cont_10000(:,1),'LineWidth',2);
% legend([h1 h2],'10e-2 annual probability','10e-4 annual probability','Location','NorthEast');
% ylabel('Significant wave height','FontWeight','bold','FontSize',16);
% xlabel('Spectral peak period','FontWeight','bold','FontSize',16);


%study of the contour line%
h_exc=[12.2;14.19;16.54;20.97];         %significant wave height for q= 0.63, 10-1, 10-2 and 10-4%
mu_exc=zeros(4,1);                      %respective mu, also conditional mean for each hs above%
var_exc=zeros(4,1);                     %respective var for hs above%
X_low=zeros(4,1);                       %lower value for range of 90% of tp%
X_high=zeros(4,1);                      %higher value for range of 90% of tp%

for i=1:1:4
    mu_exc(i,1)=p_val(1)+p_val(2)*h_exc(i,1)^p_val(3);
    var_exc(i,1)=q_val(1)+q_val(2)*exp(-h_exc(i,1)*q_val(3));
    X_low(i,1)=norminv(0.05,mu_exc(i,1),var_exc(i,1)^0.5);
    X_high(i,1)=norminv(0.95,mu_exc(i,1),var_exc(i,1)^0.5);
end

%calculattion and comparison of mean of tp for each class of hs%
T_zrcrs=zeros(125,1);
for i=1:1:125
    T_zrcrs(i,1)=2*pi*(1/(2*(p_val(1)+p_val(2)*hs_rsp(i,1)^p_val(3))+0.5*2^2*(q_val(1)+q_val(2)*exp(-hs_rsp(i,1)*q_val(3)))))^0.5;
end

% figure (33)
% h=plot(hs_rsp(:,1),T_zrcrs(:,1),'r.','MarkerSize',5);
% ylabel('average zero-crossing period','FontWeight','bold','FontSize',16);
% xlabel('Significant wave height','FontWeight','bold','FontSize',16);
% axis([0 26 2 4]);

%comparison with the material 5 from Prof., this figure has same axis as Figure7 in the material%
Mean_tp=zeros(Hs_estm_max/interval,1);
Std_tp=zeros(Hs_estm_max/interval,1);
Mean_tp_real=zeros(Hs_estm_max/interval,1);
Std_tp_real=zeros(Hs_estm_max/interval,1);

for i=1:1:Hs_estm_max/interval
    Mean_tp(i,1)=exp(mu_val(i,1)+sig_val(i,1)/2);
    Std_tp(i,1)=(exp(sig_val(i,1))-1)^0.5*exp(mu_val(i,1)+sig_val(i,1)/2);
    index=find(Wdata(:,7)>(i*interval-interval)&Wdata(:,7)<=(i*interval));
    Length_tp=length(index);
    Mean_tp_real(i)=sum((Wdata(index,8)))/Length_tp;
    Std_tp_real(i)=(sum(((Wdata(index,8))).^2)/Length_tp-(Mean_tp_real(i)).^2)^0.5;
end

%further information should be directed to code 'for environmental contour line.m'%
% figure (34)
% h1=plot(hs_rsp(:),Mean_tp_real(:),'r.','MarkerSize',5);
% hold on;
% h2=plot(hs_rsp(:),Mean_tp(:),'LineWidth',2);
% ylabel('Mean Tp for given Hs','FontWeight','bold','FontSize',16);
% xlabel('Significant Wave Height','FontWeight','bold','FontSize',16);
% legend([h1 h2],'Original Points','Fitted Curve');
% 
% figure (35)
% h1=plot(hs_rsp(:),Std_tp_real(:),'r.','MarkerSize',5);
% hold on;
% h2=plot(hs_rsp(:),Std_tp(:),'LineWidth',2);
% ylabel('Standard Deviation for Tp give Hs','FontWeight','bold','FontSize',16);
% xlabel('Significant Wave Height','FontWeight','bold','FontSize',16);
% legend([h1 h2],'Original Points','Fitted Curve');

%percentile estimate%
%100-year sea state%
S_100=zeros(181,1);          %S is estimate for the largest response and the worst sea state%
mu_pe_100=zeros(181,1);
sig_pe_100=zeros(181,1);
alfa_pe_100=zeros(181,1);
beita_pe_100=zeros(181,1);

for i=1:1:181
    mu_pe_100(i,1)=c_1*Codn_cont_100(i,1)^c_2*(1+(cos(2*pi*(Codn_cont_100(i,2)-c_4)/c_5))^c_3);    %pe fo percentile estimate%
    sig_pe_100(i,1)=c_2*c_6*mu_pe_100(i,1);
    alfa_pe_100(i,1)=mu_pe_100(i,1)-0.57722*0.7797*sig_pe_100(i,1);
    beita_pe_100(i,1)=0.7797*sig_pe_100(i,1);
    S_100(i,1)=mu_pe_100(i,1)+1.3*sig_pe_100(i,1);
end
[val index_100] = max(S_100(:));
P_100=exp(-exp(-(x_100-(mu_pe_100(index_100)-0.57722*0.7797*sig_pe_100(index_100)))/(0.7797*sig_pe_100(index_100))))
mu_pe_100(index_100,1);
sig_pe_100(index_100,1);
alfa_pe_100(index_100,1);
beita_pe_100(index_100,1);


%10000-year sea state%
S_10000=zeros(217,1);          %S is estimate for the largest response and the worst sea state%
mu_pe_10000=zeros(217,1);
sig_pe_10000=zeros(217,1);
alfa_pe_10000=zeros(217,1);
beita_pe_10000=zeros(217,1);

for i=1:1:217
    mu_pe_10000(i,1)=c_1*Codn_cont_10000(i,1)^c_2*(1+(cos((2*pi*(Codn_cont_10000(i,2)-c_4)/c_5)))^c_3);
    sig_pe_10000(i,1)=c_2*c_6*mu_pe_10000(i,1);
    alfa_pe_10000(i,1)=mu_pe_10000(i,1)-0.57722*0.7797*sig_pe_10000(i,1);
    beita_pe_10000(i,1)=0.7797*sig_pe_10000(i,1);    
    S_10000(i,1)=mu_pe_10000(i,1)+1.3*sig_pe_10000(i,1);
end
[val index_10000] = max(S_10000(:));
P_10000=exp(-exp(-(x_10000-(mu_pe_10000(index_10000)-0.57722*0.7797*sig_pe_10000(index_10000)))/(0.7797*sig_pe_10000(index_10000))))
mu_pe_10000(index_10000,1);
sig_pe_10000(index_10000,1);
alfa_pe_10000(index_10000,1);
beita_pe_10000(index_10000,1);
%note, c_1 has a big effect on the final percentile P_100 and P_10000. here do we need to keep P_100 or P_10000 on a certain level of 85%-90% and then do the compare? or any value is ok? %





%---------------------------------Chapter 4. Peak Over Threshold Method-----------------------------------%

c_1=1;     %scale coefficient for location parameter%
c_2=1;     %coefficient which control linear and quadratic%
c_3=1;     %negligible when response independent of Tp, large value when response sensitive of Tp%
c_4=15;    %coefficient which control when occurs the most probable peak period%
c_5=100;   %coefficient which control sensitive to period or not%
c_6=0.1;   

%short term distribution of response in POT method, Gumbel distribution%
Hs_th=6;                        %threshold for storm, usually taken as 6m%
ind=find(Wdata(:,7)>=Hs_th);    %ind is the index of every 3h-step in the 57 years, find from Wdata%

Nos=1;                          %Nos is number of storms, make Nos=1 because in the following program, the first storm will not be counted%
for i=1:1:length(ind)-1
    if ind(i+1)-ind(i)==1
        Nos=Nos;
    else
        Nos=Nos+1;
    end
end

E=zeros(Nos,1);                 %the number in E denotes the begining of each storm%
E(1,1)=1;                       %due to the code, the first storm is not counted, so define E(1,1)=1%
j=2;
for i=2:1:length(ind)
    if ind(i)-ind(i-1)>1
        E(j,1)=i;
        j=j+1;
    end
end
       
Num_ran=zeros(Nos,1);                    %number of steps in each storm%
for i=1:1:Nos-1
    Num_ran(i)=E(i+1)-E(i);
end
Num_ran(Nos,1)=length(ind)-E(Nos)+1;
Exp_duration=sum(Num_ran(:))/length(Num_ran(:));    %the average number of 3-hour events for each storm event, not for further calculation, just get a feeling for length of storm%


y_max=zeros(length(E)-1,1);                        %y_max is the largest value in each storm, out of the Monte Carlo simulation of each step%
y_tilda=zeros(length(E)-1,1);                      %y_tilda is the largest most probable value in each strom, y_tilda is set equal to alfa_pot%
v_pot=zeros(length(E)-1,1);                        %v_pot is the ratio between y_max and y_tilda, v_pot is also for each storm, not for each step%

%one assumption here is that, the 3h-maximum response is modelled by the Gumbel distribution%
Num_rlz=100;                               %Number generated for each Monte Carlo Simulation%
Num_step=E(length(E))-1;
alfa_pot=zeros(Num_step,1);           %alfa_pot is the parameter for the Gumbel distribution%
beita_pot=zeros(Num_step,1);          %beita_pot is the parameter for the Gumbel distribution%
y_tilda=zeros(length(E)-1,1);

% rng('default')                           %to make matlab generate same set of random numbers every time%
u_pot=random('unif',0,1,Num_rlz,1);        %u_pot is the random number generated from 0 and 1, used for Monte Carlo simulation%
x_pot=zeros(Num_step,Num_rlz);                %x_pot is the response value simulated for each step, i.e. the simulated response by using Monte Carlo simulation%
Num_step=E(length(E))-1;

for i=1:1:length(E)-1
    
    for j=E(i,1):1:(E(i+1)-1)
        alfa_pot(j,1)=c_1*Wdata(ind(j),7)^c_2*(1+(cos((2*pi*(Wdata(ind(j),8)-c_4)/c_5)))^c_3);
        beita_pot(j,1)=c_2*c_6*alfa_pot(j,1);
        u_pot=random('unif',0,1,Num_rlz,1);
        
        for k=1:1:Num_rlz
            x_pot(j,k)=alfa_pot(j,1)-beita_pot(j,1)*log(-log(u_pot(k,1)));
        end

    end 
    
    y_tilda(i,1)=max(alfa_pot(E(i,1):(E(i+1)-1),1));
    y_max(i,1)=max(max(x_pot(E(i,1):(E(i+1)-1),:)));
    v_pot(i,1)=y_max(i,1)/y_tilda(i,1);
end


%start here:insert a littele program here to produce a figure. plot the ind(28)-ind(38) steps%
x_simu=zeros(11,1);           %simple explation for the numbers here: index=845-855 in Wdata is a storm with 11 3-hour steps. index=28-38 corresponds to the storm in ind(the matrix)%
for i=1:1:11
    x_simu(i,1)=1.5+3*(i-1);
end

% figure(35)
% h1=plot([3,3],[12,alfa_pot(28,1)],'--m','LineWidth',4);
% hold on;
% h=plot([3,6],[alfa_pot(28,1),alfa_pot(28,1)],'--m','LineWidth',4);
% for i=1:1:9
%     hold on;
%     h=plot([3+3*i,3+3*i],[alfa_pot(27+i,1),alfa_pot(28+i,1)],'--m','LineWidth',4);
%     hold on;
%     h=plot([3+3*i,6+3*i],[alfa_pot(28+i,1),alfa_pot(28+i,1)],'--m','LineWidth',4);
% end
% hold on;
% h2=plot(x_simu(:),x_pot(28:38,1),'--g','LineWidth',4);
% hold on;
% h3=plot(x_simu(:),Wdata(845:855,7),'-.b','LineWidth',4);
% hold on;
% h4=plot(x_simu(:),Wdata(845:855,8),':k','LineWidth',4);
% AX=legend([h1 h2 h3 h4],'y tilda','y realization','H_s','T_p','FontSize',25);
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',17)
% ylabel('H_s, T_p, Response','FontWeight','bold','FontSize',25);
% xlabel('Storm Duration[h]','FontWeight','bold','FontSize',25);
% axis([0 35 6 23])
% set(gca,'fontsize',25)
% %end here%

%a little program here
%the following little code is to check how many one step storm is in the storm history, this might not be accounted as one storm, storm should be with at least three steps in the future study%
KKK=0;                                  %KKK is the storm with only one step h_s=6m%
ind_KKK=zeros(length(E),1);             %ind_KKK is the index of the one step in Wdata, help to locate the one step storm%
for i=1:1:length(E)-1
    if E(i+1)-E(i)==1
        if Wdata(ind(E(i)),7)==6;
            ind_KKK(i,1)=ind(E(i));
            KKK=KKK+1;
        end
    end
end

JJJ=0;
III=zeros(length(E),1);
for i=1:1:length(E)-1
    III(i,1)=max( Wdata(ind(E(i)):ind(E(i+1)-1),7)) ;
    if (III(i,1)>=6)&(III(i,1)<10.1);
        JJJ=JJJ+1;
    end
    
end


%one assumption here is that v_pot obeys Gumbel distribution%
v_mean=sum(v_pot(:,1))/length(v_pot);                     %v_mean is the mean value for v_pot%
v_std=(sum((v_pot(:,1)).^2)/length(v_pot)-v_mean^2)^0.5;  %v_std is the standard deviation for v_pot%
beita_gumb=0.7797*v_std;                                  %beita_gumb is the parameter for the Gumbel distribution%
alfa_gumb=v_mean-0.57722*beita_gumb;                      %alfa_gumb is the parameter for the Gumbel distribution%

v_pot_r=sort(v_pot);                                      %sort v_pot in an asending order for further calculation and plotting%
f_v_pot=zeros(length(v_pot),1);                           %definition of f_v_pot, since each storm has same probability of occurence, the probability for each storm is 1/length(v_pot)%
for i=1:1:length(v_pot)
    f_v_pot(i,1)=1/(length(v_pot)+1);
end
F_v_pot=cumsum(f_v_pot);                                  %cumulative probability of v_pot%

y_v_pot=zeros(length(v_pot),1);                           %cumulative probability calculated from the fitted model, i.e. from alfa_gumb and beita_gumb%
x_gb=zeros(length(v_pot),1);                              %x-value on probablity paper, still v, no change for this one%
y_gb_e=zeros(length(v_pot),1);                            %y-value on probablity paper, calculated from estimatd parameters%
y_gb_r=zeros(length(v_pot),1);                            %y_value on probablity paper, calculated from real value%
for i=1:1:length(v_pot)
    y_v_pot(i,1)=exp(-exp(-(v_pot_r(i,1)-alfa_gumb)/beita_gumb));
    x_gb(i,1)=v_pot_r(i,1);
    y_gb_e(i,1)=x_gb(i,1)/beita_gumb-alfa_gumb/beita_gumb;
    y_gb_r(i,1)=-log(-log(F_v_pot(i,1)));
end

% figure(36)
% h1=plot(x_gb(:),y_gb_e(:),'LineWidth',4);
% hold on;
% h2=plot(x_gb(:),y_gb_r(:),'r*','MarkerSize',6);
% AX=legend([h1 h2],'Fitted Curve','Original Points','Location','NorthWest');
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',25)
% ylabel('Cumulative Probability on Probablity Paper','FontWeight','bold','FontSize',25);
% xlabel('v','FontWeight','bold','FontSize',25);
% axis([1.3 2.2 -3 8])
% set(gca,'fontsize',25)
%  
% figure(37)
% h1=plot(v_pot_r(:),y_v_pot(:),'LineWidth',4);
% hold on;
% h2=plot(v_pot_r(:),F_v_pot(:),'r*','MarkerSize',6);
% AX=legend([h1 h2],'Fitted Curve','Original Points','Location','NorthWest');
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',25)
% ylabel('Cumulative Probability of v','FontWeight','bold','FontSize',25);
% xlabel('v','FontWeight','bold','FontSize',25);
% axis([1.2 2 0 1.1])
% set(gca,'fontsize',25)


%long term distribution of reponse in POT method, three parameter Weibull distribution%
y_tilda_r=sort(y_tilda);                     %sort y_tilda in an asending order for further calculation%
y_tilda_l=log(-log(1-F_v_pot));              %Weibull fitting to the cumulative probablity against y_tilda%

% %use three parameter Weilbull model to fit the data%
% y_lp=5.8:0.01:6;                           %lp: location parameter.%
% F=round((6-5.8)/0.01+1);                   %number of y_lp, used in following calculation%
% ln_y=zeros(length(y_tilda),F);             %x-axis value for the probablity paper of three parameter Weibull distribution%
% 
% for i=1:1:length(y_tilda)
%     for j=1:1:F
%         ln_y(i,j)=log(y_tilda_r(i)-y_lp(j));
%     end
% end
% 
% kay_2=zeros(F,1);
% lamda_2=zeros(F,1);
% devia_2=zeros(F,1);
% G=zeros(length(y_tilda),1);
% 
% for i=1:1:F                                        %linear fitting for different location parameter%
%   [efun,gof,output]=fit(ln_y((i+1003):length(y_tilda),i),y_tilda_l((i+1003):length(y_tilda),1),'poly1');
%   efun;
%   gof;
%   output;
%   kay_2(i,1)=efun.p1;
%   lamda_2(i,1)=exp(-efun.p2/efun.p1);
%     for j=(i+3):1:length(y_tilda)                  %there is a bug here, since ln_y has to be real number, and only by doing i+3 can get real number from the diagram%
%         devia_2(i,1)=devia_2(i,1)+(kay_2(i,1)*ln_y(j,i)-kay_2(i,1)*log(lamda_2(i,1))-y_tilda_l(j,1))^2;
%     end
%         devia_2(i,1)=(devia_2(i,1)/(length(y_tilda)-i))^0.5;
% end

% figure(38)                                         %plot for the minimum deviation%
% h1=plot(y_lp(1:F),devia_2,'r.','MarkerSize',5);    
% ylabel('Standard Deviation','FontWeight','bold','FontSize',16);
% xlabel('Location Parameter','FontWeight','bold','FontSize',16);

% %it can be seen from figure(38)that the least deviation is 11.74m. however, 11.7m is chosen here for furter calculation, because this will result in better description for the upper tail in linear fitting for v%
if c_2==1&&c_5==100
    lp_2_final=11.7;                                   %from figure(38) it can be seen that the fourth point has the smallest deviation value%
    kay_2_final=1.1190;                                 %the kay and lamda value can be determinded when the location parameter is determined%
    lamda_2_final=3.4447;                    
else if c_2==2&&c_5==100
        lp_2_final=70;                                   %from figure(38) it can be seen that the fourth point has the smallest deviation value%
        kay_2_final=0.9343;                                 %the kay and lamda value can be determinded when the location parameter is determined%
        lamda_2_final=46.5817;
    else if c_2==1&&c_5==60
            lp_2_final=5.9;                                   %from figure(38) it can be seen that the fourth point has the smallest deviation value%
            kay_2_final=0.8838;                                 %the kay and lamda value can be determinded when the location parameter is determined%
            lamda_2_final=4.4867;
        else 
                lp_2_final=35.5;                                   %from figure(38) it can be seen that the fourth point has the smallest deviation value%
                kay_2_final=0.8436;                                 %the kay and lamda value can be determinded when the location parameter is determined%
                lamda_2_final=43.7615;
        end
    end
end

I=find(y_tilda_r(:)>lp_2_final,1);                  %I is the index larger and closest to lp_2_final, for further calculation%
J=round(lp_2_final)+1;                                               %J is the integral larger and closest to lp_2_final%

y_pot2=zeros(length(y_tilda)-I+1,1);                %cumulative probablity calculated from estimated parameters%
x_3pwb=zeros(length(y_tilda)-I+1,1);                %x value for probability paper for 3parameter Weibull distribution%
y_3pwb_e=zeros(length(y_tilda)-I+1,1);              %y value for probability paper for 3parameter Weibull distribution, calculated from estimated parameter%
y_3pwb_r=zeros(length(y_tilda)-I+1,1);              %y value for probability paper for 3parameter Weibull distribution, calculated from real value%             

for i=I:1:length(y_tilda)
    y_pot2(i,1)=1-exp(-((y_tilda_r(i,1)-lp_2_final)/lamda_2_final)^kay_2_final);
    x_3pwb(i,1)=log(y_tilda_r(i,1)-lp_2_final);
    y_3pwb_e(i,1)=kay_2_final*x_3pwb(i,1)-kay_2_final*log(lamda_2_final);
    y_3pwb_r(i,1)=y_tilda_l(i,1);
end

% figure(39)
% % h1=plot(x_3pwb(I:length(y_tilda)),y_3pwb_e(I:length(y_tilda)),'LineWidth',4);
% h1=plot(x_3pwb(I:length(y_tilda)),y_3pwb_e(I:length(y_tilda)),'LineWidth',4);
% hold on;
% h2=plot(x_3pwb(1:length(y_tilda)),y_3pwb_r(1:length(y_tilda)),'r*','MarkerSize',8);
% AX=legend([h1 h2],'Fitted Curve','Original Points','Location','NorthWest');
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',25)
% ylabel('Weibull Probability Paper','FontWeight','bold','FontSize',25);
% xlabel('ln(y tilde-y_0)','FontWeight','bold','FontSize',25);
% set(gca,'fontsize',25)
% axis([-5 4 -7 3])


% figure(40)
% h1=plot(y_tilda_r(I:length(y_tilda)),y_pot2(I:length(y_tilda)),'LineWidth',4);
% hold on;
% h2=plot(y_tilda_r(1:length(y_tilda)),F_v_pot(1:length(y_tilda)),'r*','MarkerSize',8);
% AX=legend([h1 h2],'Fitted Curve','Original Points','Location','NorthWest');
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',25)
% ylabel('Cumulative Probability of y tilde','FontWeight','bold','FontSize',25);
% xlabel('y tilde','FontWeight','bold','FontSize',25);
% axis([10 28 0 1.1])
% set(gca,'fontsize',25)


%long term analysis of response%
%long term disribution for y_tilda%

if c_2==1&&c_5==100
    y_estm_max=100;                                                     %estimated maximum value of y%
    y_tilda_esma=50;   
    int=0.1;
else if c_2==2&&c_5==100
          y_estm_max=1500;                                                     %estimated maximum value of y%
          y_tilda_esma=1400; 
          int=1;
    else if c_2==1&&c_5==60
               y_estm_max=100;                                                     %estimated maximum value of y%
               y_tilda_esma=50; 
               int=0.1;
        else 
                    y_estm_max=1500;                                                     %estimated maximum value of y%
                    y_tilda_esma=1300; 
                    int=1;
        end
    end
end


scatter_rsp_pot=zeros(y_tilda_esma/int-J/int+1,y_estm_max/int);    %scatter diagram for response, since lp_2_final=11.75, the scale of scatter is affected by this%
scatter_y_tilda_bs=zeros(y_tilda_esma/int-J/int+1,1);              %scatter diagram for y_tilda before scale to exact 1%
scatter_y_tilda=zeros(y_tilda_esma/int-J/int+1,1);                 %scatter diagram for y_tilda after scale to exact1%
P_veri_rsp_pot=zeros(y_estm_max/int,1);                            

scatter_y_tilda_bs(1,1)=(1-exp(-((J-lp_2_final)/lamda_2_final)^kay_2_final));     %first step to do integration, find the probability for each interval, the diagram here is similar to the scatter diagram for each hs-tp interval%        
for i=J/int+1:1:y_tilda_esma/int
    scatter_y_tilda_bs(i-J/int+1,1)=(1-exp(-((i*int-lp_2_final)/lamda_2_final)^kay_2_final))-(1-exp(-(((i-1)*int-lp_2_final)/lamda_2_final)^kay_2_final));
end
P_veri_pot_bs=sum(scatter_y_tilda_bs(:));

for i=J/int:1:y_tilda_esma/int
    scatter_y_tilda(i-J/int+1,1)=scatter_y_tilda_bs(i-J/int+1,1)/P_veri_pot_bs;
end
P_veri_pot=sum(scatter_y_tilda(:));                                 %there is no problem with the value of P_veri_pot, so if the final sum is larger than 1, it has to be the reason of response function%

%long term response distribution for y, the double integration part%
y_tilda_rsp=zeros(y_tilda_esma/int-J/int+1,1);                      %middle point for each y interval%     
y_rsp=zeros(y_estm_max/int,1);                                      %definition of response%

for i=1:1:y_estm_max/int
    for j=J/int:1:y_tilda_esma/int
        y_rsp(i,1)=i*int;                                           %definition of response,from 1 to the estimated largest value%
        y_tilda_rsp(j-J/int+1,1)=(j-0.5)*int;                       %middle point for each y interval, use the mid-point value times the interval probability%
                 
        scatter_rsp_pot(j-J/int+1,i)=exp(-exp(-(y_rsp(i,1)-y_tilda_rsp(j-J/int+1,1)*alfa_gumb)/(beita_gumb*y_tilda_rsp(j-J/int+1,1))))*scatter_y_tilda(j-J/int+1,1);
    end
    P_veri_rsp_pot(i,1)=sum(scatter_rsp_pot(:,i));
end

% figure(40)                                                         %this plot is  the cumulative probablity against response value%
% h1=plot(y_rsp(1:y_estm_max/int),P_veri_rsp_pot(1:y_estm_max/int),'r*','MarkerSize',8);
% hold on;
% h2=plot(y_rsp(1:y_estm_max/int),P_veri_rsp_pot(1:y_estm_max/int),'LineWidth',4);
% ylabel('Cumulative Probability of y rsp','FontWeight','bold','FontSize',25);
% xlabel('y rsp','FontWeight','bold','FontSize',25);
% axis([0 100 0 1.1])

%in the following, a lot of extreme value is plotted on the Gumbel probablity paper, but it NOT NECESSARILY mean that it obeys Gumbel distribution, just to show its linear property in a certain region. In most cases, the Gumbel probability paper gives reasonable results%
H=-log(-log(P_veri_rsp_pot(1:y_estm_max/int)));                      %y-axis value in Gumbel probability paper%        

figure(41)
h1=plot(y_rsp(1:y_estm_max/int),H(1:y_estm_max/int),'r*','MarkerSize',8);
ylabel('-log(-log(F))','FontWeight','bold','FontSize',25);
xlabel('y rsp','FontWeight','bold','FontSize',25);
AX=legend([h1],'Original Data');
LEG = findobj(AX,'type','text');
set(LEG,'FontSize',27)
set(gca,'fontsize',25)
% grid


%---------------------------------Chapter 5. Verification Code for Different Method-----------------------------------%

%Verification Code 1, All Sea State && Time Domain && Response
%All sea state, means that all Wdata are considered, instead of POT method
%Time Domain, means that taking hs and tp from Wdata directly, instead of long term analysis, which is scatter diagram for each hs and tp inerval%
%Response, means that response is calculated using c_1-c_6, instead of wave crest height%
% 
[Wdatam,mx]=max(Wdata(:,7));    %find the index of the maximum value of hs in Wdata%
mx_h=max(Wdata(:,7));           %the value of the maximum value%

Wdata_a=repmat(Wdata,1);        %establish this new matrix, which is same with Wdata%
Wdata_a(mx,7)=14.7;             %change the largest value 16.6 to 14.7%

% [Wdata_a,mx]=max(Wdata_a(:,7));    %find the index of the maximum value of hs in Wdata%
% mx_h=max(Wdata_a(:,7))


X=100;                                              %X is the estimated largest value for x%
F_verify=zeros(length(Wdata(:,7)),X);               %F_verify is the probability calculated from alfa_gumb and beita_gumb also, but now alfa_gumb and beita_gumb are calculated with hs and tp taken directly from Wdata%
F_verify_sum=zeros(1,X);  
int=0.1;
for i=1:1:X
    for j=1:1:length(Wdata(:,7))
        F_verify(j,i)=exp(-exp((-x(i)+(c_1*Wdata(j,7)^c_2*(1+(cos((2*pi*(Wdata(j,8)-c_4)/c_5)))^c_3)-0.57722*(0.7797*c_2*c_6*(c_1*Wdata(j,7)^c_2*(1+(cos((2*pi*(Wdata(j,8)-c_4)/c_5)))^c_3)))))/(0.7797*c_2*c_6*(c_1*Wdata(j,7)^c_2*(1+(cos((2*pi*(Wdata(j,8)-c_4)/c_5)))^c_3)))));
    end
    F_verify_sum(1,i)=sum(F_verify(:,i))/length(Wdata(:,7));
end

K=-log(-log(F_verify_sum(1,:)));                    %y-axis in the Gumbel probability paper%               
for i=1:1:X                                         %since it is easier to use in a column than in a row, so do a transfer here%
    K(i,1)=K(1,i);
    K(1,i)=0;
end

L=94;                                               %since from 95 to 100, the value is inf%
[gfun,gof,output]=fit(x(1:L,1),K(1:L,1),'poly1');
  gfun;
  gof;
  output;
  beita_veri=1/gfun.p1;
  miu_veri=-gfun.p2/gfun.p1;
  
y_gum_veri=zeros(y_estm_max/int,1);
for i=1:1:X
  y_gum_veri(i,1)=gfun.p1*x(i,1)+gfun.p2 ;
end

figure(42)
h1=plot(x(1:L),y_gum_veri(1:L),'LineWidth',4);
hold on;
h2=plot(x(1:X),K(1:X),'r*','MarkerSize',8);
AX=legend([h1 h2],'Fitted Curve','Original Points','Location','NorthWest');
LEG = findobj(AX,'type','text');
set(LEG,'FontSize',25)
xlabel('response','FontWeight','bold','FontSize',25);
ylabel('Gumbel Probability Paper','FontWeight','bold','FontSize',25);
set(gca,'fontsize',25)


%it can be seen that the fitting region was only linear on a certain region, so may just focus on the target probability%
F_p=1-1/(10*2920);
% F_p=1-1/(100*2920);
F_p=1-1/(10000*2920);
y_tre=-log(-log(F_p))






%Verification Code 2, All Sea State && Time Domain && Crest Height%
M=30;                                             %M is the estimate largest value for crest height%
F_veri_td=zeros(length(Wdata_a(:,7)),M/interval);   %cumulative probability of crest height for given hs and tp.%
F_veri_td_sum=zeros(M/interval,1);                %cumulative probability of crest height%

for i=1:1:M/interval
    for j=1:1:length(Wdata_a(:,7))
        %Wave crest height given hs and tp is assumed to be Raylegh distributed. Below is the Rayleigh distribution%
        F_veri_td(j,i)=(1-exp(-8*(i/Wdata_a(j,7))^2))^(3*60*60/(0.77*Wdata_a(j,8)));
    end
    F_veri_td_sum(i,1)=sum(F_veri_td(:,i))/length(Wdata_a(:,7));    
end

O=-log(-log(F_veri_td_sum(:,1)));                  %y-axis in the Gumbel probability paper%
P=33;                                              %since from 33 to 60, the value is inf%

% figure(43)
% h1=plot(x(1:P),O(1:P),'r.','MarkerSize',8);
% ylabel('-log(-log(F))','FontWeight','bold','FontSize',22);
% xlabel('Wave Crest Height','FontWeight','bold','FontSize',22);
% % AX=legend([h1],'Gumbel Probability Paper for Response Value against Cumulative Probability');
% % LEG = findobj(AX,'type','text');
% % set(LEG,'FontSize',17)
% % grid
% set(gca,'fontsize',15)



%Verification Code 3, All Sea State && Long Term Analysis && Crest Height%
scatter_rsp_pot=zeros(Hs_estm_max/interval,Tp_estm_max/interval);     %scatter diagram for crest height given hs and tp%
P_veri_rsp_pot=zeros(M,1);                                            %cumulative probablity for differetn crest height%

for k=1:1:M                                                           %M is the estimate largest value for crest height%
    for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        x(k,1)=k;
        hs_rsp(i,1)=(i-0.5)*interval;
        tp_rsp(j,1)=(j-0.5)*interval;
        
        scatter_rsp_hstp_pot(i,j)=(1-exp(-8*(x(k,1)/hs_rsp(i,1))^2))^(3*60*60/(0.77* tp_rsp(j,1)));
        scatter_rsp_pot(i,j)=scatter_veri_hstp(i,j)*scatter_rsp_hstp_pot(i,j);
%         miu=(c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3))
%         sig=(c_2*c_6*c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3))
%         alfa=((c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3))-0.57722*0.7797*(c_2*c_6*c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3)))
%         beta=(0.7797*(c_2*c_6*c_1*h^c_2*(1+(cos(2*pi*(t-c_4)/c_5))^c_3)))
    end
    end
    P_veri_rsp_pot(k,1)=sum(sum(scatter_rsp_pot,2));
    Ad_y_pot(k,1)=-log(-log(P_veri_rsp_pot(k,1)));                    %y-axis in the Gumbel probability paper% 
end

[ifun,gof,output]=fit(x(1:M,1),Ad_y_pot(1:M,1),'poly1');              %in this case, the Gumbel fitting gives a very good simulation%
  ifun;
  gof;
  output;
  beita_veri_as=1/ifun.p1;
  miu_veri_as=-ifun.p2/ifun.p1;

y_gum_veri_1=zeros(M,1);                                              %point calculated from fitted straight line's parameter%
for i=1:1:X
  y_gum_veri_1(i,1)=ifun.p1*x(i,1)+ifun.p2 ;
end
    
F_p=1-1/(10*2920);                   %non-exceedance probablity in 10 years of 3h event%
% F_p=1-1/(100*2920);                  %non-exceedance probablity in 100 years of 3h event%
y_tre=-log(-log(F_p));               %this value is calculated for x_tre_as%
x_tre_as=(y_tre-ifun.p2)/ifun.p1;    %correpond response to either 10 or 100 years of 3h event%

% figure(44)
% h1=plot(x(1:M),y_gum_veri_1(1:M),'LineWidth',4);
% hold on;
% h2=plot(x(1:M),Ad_y_pot(1:M),'r.','MarkerSize',8);
% AX=legend([h1 h2],'Fitted Curve','Original Points');
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',17)
% ylabel('-log(-log(F))','FontWeight','bold','FontSize',22);
% xlabel('Wave Crest Height','FontWeight','bold','FontSize',22);
% % grid
% set(gca,'fontsize',15)

%Verification Code 4, All Sea State && Long Term Analysis && Crest Height(considering weight effect from each hs and tp interval)%
%the code below is a realization of the Environmental contour method-9 in the lecture notes%
scatter_rsp_agch=zeros(Hs_estm_max/interval,Tp_estm_max/interval);    %all global crest height%
scatter_rsp_agcha=zeros(Hs_estm_max/interval,Tp_estm_max/interval);
P_veri_rsp_agch=zeros(M,1);
v_zcf_a=zeros(Tp_estm_max/interval,1);                                %zero-crossing frequency for each Tp interval%

for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        tp_rsp(j,1)=(j-0.5)*interval;                                 %here I use mid-interval to calculated the zero-crossing frequency%
        v_zcf_a(j,1)=1/(0.77*tp_rsp(j,1));
        scatter_rsp_agcha(i,j)=v_zcf_a(j,1)*scatter_veri_hstp(i,j);   %taking weight from hs and tp interval%  
    end
end
v_zcf=sum(sum(scatter_rsp_agcha,2));                                  %mean zero-crossing frequency%

for k=1:1:M
    for i=1:1:Hs_estm_max/interval
    for j=1:1:Tp_estm_max/interval
        x(k,1)=k;
        hs_rsp(i,1)=(i-0.5)*interval;
        tp_rsp(j,1)=(j-0.5)*interval;
        
        scatter_rsp_hstp_agch(i,j)=(1-exp(-8*(x(k,1)/hs_rsp(i,1))^2)); %it can be seen that the only different from the previous one is that, in this method, the zero-crossing frequency is taken into consideration%
        scatter_rsp_agch(i,j)=v_zcf_a(j,1)*scatter_veri_hstp(i,j)*scatter_rsp_hstp_agch(i,j);   
    end
    end
    P_veri_rsp_agch(k,1)=sum(sum(scatter_rsp_agch,2))/v_zcf;
    Ad_y_agch(k,1)=-log(-log(P_veri_rsp_agch(k,1)));
end
 
num_crt_py=365*24*3600*v_zcf;        %number of crest per year%
num_crt=10000*365*24*3600*v_zcf;        %number of crest in n years%
F_p_agch=1-1/num_crt;                %non-exceedance probability for 10 or 100 year number of crest%
R=-log(-log(F_p_agch));

figure(45)
h1=plot(x(1:M),Ad_y_agch(1:M),'r.','MarkerSize',8);
ylabel('-log(-log(F))','FontWeight','bold','FontSize',22);
xlabel('Wave Crest Height','FontWeight','bold','FontSize',22);
% AX=legend([h1],'Gumbel Probability Paper for Response Value against Cumulative Probability');
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',17)
% grid
set(gca,'fontsize',15)







%Verification Code 5, POT Method && Time Domain && Wave Crest%
x_pot_c=zeros(length(ind),1);              %x_pot_c is the realization of crest height from Monte Carlo simulation, x_pot is simulated for each step of each storm%
x_pot_c_t=zeros(length(ind),1);            %x_pot_c_t is the most probable crest height for each step of each storm, calculated from Rayleigh distribution, details see SH's note VI-1%
x_pot_c_p=zeros(length(ind),1);            %x_pot_c_p is the most probable crest height for each step of each storm, calculated by make the random number u=0.37, which is supposed to be the probability for most probable crest height%
u_pot=random('unif',0,1,length(ind),1);

%here it is assumed that the wave crest given hs and tp obeys Rayleigh distribution%
for i=1:1:length(ind)
    x_pot_c(i,1)=Wdata_a(ind(i),7)*(-(1/8)*log(1-u_pot(i)^(0.77*Wdata_a(ind(i),8)/10800)))^0.5;   %Monte Carlo simulation for wave crest height realization%
    x_pot_c_t(i,1)=Wdata_a(ind(i),7)*(-1/8*log((0.77*Wdata_a(ind(i),8))/10800))^0.5;              %most probable wave crest height calculated from Rayleigh distribution's definition%
    x_pot_c_p(i,1)=Wdata_a(ind(i),7)*(-(1/8)*log(1-0.37^(0.77*Wdata_a(ind(i),8)/10800)))^0.5;     %most probable wave crest height calculated by making u_pot=0.37%
end
x_pot_c_s=sort(x_pot_c);                   %sort x_potc, x_pot_c_t, x_pot_c_p in an asending order%
x_pot_c_t_s=sort(x_pot_c_t);
x_pot_c_p_s=sort(x_pot_c_p);

f_x_pot=zeros(length(x_pot_c),1);          %density probability for each step of all the storms in 57 years%
for i=1:1:length(x_pot_c)
    f_x_pot(i,1)=1/(length(x_pot_c)+1);
end
F_x_pot=cumsum(f_x_pot);                   %cumulative probability for all the steps of all the storms in 57 years%

y_x_pot=zeros(length(x_pot_c),1);
for i=1:1:length(x_pot_c)
    y_x_pot(i,1)=-log(-log(F_x_pot(i)));   %y-axis in Gumbel probability paper, from figure below it can be seen that it does not behave as Gumbel distribution, but part of it still behaves as linear%
end

% figure(46)    
% h1=plot(x_pot_c_s(:),y_x_pot(:),'r.','MarkerSize',5);
% hold on;
% h2=plot(x_pot_c_t_s(:),y_x_pot(:),'g.','MarkerSize',5);
% hold on;
% h3=plot(x_pot_c_p_s(:),y_x_pot(:),'b.','MarkerSize',5);
% legend([h1 h2 h3],'random','not by using 0.37','using 0.37');
% ylabel('Gumbel Probability Paper of Cumulative Probability','FontWeight','bold','FontSize',16);
% xlabel('x','FontWeight','bold','FontSize',16);
% axis([4.5 15.5 -2 11])
% grid

% figure(47)                                          %this figure is to show that most probable crest height from different method gives almost the same result%
% h1=plot(x_pot_c_t_s(:),x_pot_c_p_s(:),'r.','MarkerSize',5);
% ylabel('Most Probable Crest Height from Rayleigh Difinition','FontWeight','bold','FontSize',16);
% xlabel('Most Probable Crest Height by making Cumulative Probability equal to 0.37','FontWeight','bold','FontSize',16);

v_max=zeros(Nos,1);                                 %v_max denotes the largest crest height in each storm%
v_tilda=zeros(Nos,1);                               %v_tilda denotes the largest most probable crest height in each storm%
v_pot_c=zeros(Nos,1);                               %v_pot_c denotes the ration between v_max and v_tilda%
    
for i=1:1:Nos-1
    v_max(i,1)=max(x_pot_c(E(i):(E(i+1)-1),1));     %find the largest realization value in each storm%   
    v_tilda(i,1)=max(x_pot_c_t(E(i):(E(i+1)-1),1)); %find the largest most probable value in each storm%
    v_pot_c(i,1)=v_max(i,1)/v_tilda(i,1);           %the ration between v_max and v_tilda%
end
v_max(Nos,1)=max(x_pot_c(E(Nos):length(ind),1));    %modification code, make it full%
v_tilda(Nos,1)=max(x_pot_c_t(E(Nos):length(ind),1));
v_pot_c(Nos,1)=v_max(Nos,1)/v_tilda(Nos,1);


figure(47)
h1=plot([3,3],[6,x_pot_c_t(28,1)],'-m','LineWidth',4);
hold on;
h=plot([3,6],[x_pot_c_t(28,1),x_pot_c_t(28,1)],'-m','LineWidth',4);
for i=1:1:9
    hold on;
    h=plot([3+3*i,3+3*i],[x_pot_c_t(27+i,1),x_pot_c_t(28+i,1)],'-m','LineWidth',4);
    hold on;
    h=plot([3+3*i,6+3*i],[x_pot_c_t(28+i,1),x_pot_c_t(28+i,1)],'-m','LineWidth',4);
end
hold on;
h2=plot(x_simu(:),x_pot_c(28:38,1),'--g','LineWidth',4);
% hold on;
% h3=plot(x_simu(:),Wdata(845:855,7),'-.b','LineWidth',4);
% hold on;
% h4=plot(x_simu(:),Wdata(845:855,8),':k','LineWidth',4);
AX=legend([h1 h2],'c tilda','c realization','FontSize',17);
LEG = findobj(AX,'type','text');
set(LEG,'FontSize',17)
ylabel('Crest Height','FontWeight','bold','FontSize',22);
xlabel('Storm Duration[h]','FontWeight','bold','FontSize',22);
% axis([0 35 6 20])
%end here%
set(gca,'fontsize',15)

v_mean_c=sum(v_pot_c(:,1))/length(v_pot_c);         %mean value for v_pot_c%
v_std_c=(sum((v_pot_c(:,1)).^2)/length(v_pot_c)-v_mean_c^2)^0.5;  %standard deviation for v_pot_c%

%here it is assumed that v_pot_c obeys Gumbel disribution%
beita_gumb_c=0.7797*v_std_c;                        %beita value for the Gumbel distribution%
alfa_gumb_c=v_mean_c-0.57722*beita_gumb_c;          %alfa value for the Gumbel distribution%

v_pot_r_c=sort(v_pot_c);                            %important note here, sort v_pot in an asending order for further calculation%

y_v_pot_c=zeros(length(v_pot_c),1);                 %cumulative probability calculated from estimated paramters%
y_gmb_ch_r=zeros(length(v_pot_c),1);                %y-axis on Gumbel probability paper, calcultaed from real cumulative probability%
y_gmb_ch_c=zeros(length(v_pot_c),1);                %y-axis on Gumbel probability paper, calculated from estimated parameters%

F_v_pot(1299,1)=F_v_pot(1298,1);

for i=1:1:length(v_pot_c)
    y_v_pot_c(i,1)=exp(-exp(-(v_pot_r_c(i,1)-alfa_gumb_c)/beita_gumb_c));
    y_gmb_ch_r(i,1)=-log(-log(F_v_pot(i,1)));
    y_gmb_ch_c(i,1)=-log(-log(y_v_pot_c(i,1)));
end

% figure(48)
% h1=plot(v_pot_r_c(:),y_gmb_ch_c(:),'LineWidth',4);
% hold on;
% h2=plot(v_pot_r_c(:),y_gmb_ch_r(:),'r.','MarkerSize',8);
% AX=legend([h1 h2],'Fitted Curve','Original Points','Location','NorthWest');
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',17)
% ylabel('Gumbel Probability Paper','FontWeight','bold','FontSize',22);
% xlabel('v','FontWeight','bold','FontSize',22);
% set(gca,'fontsize',15)

% figure(49)
% h1=plot(v_pot_r_c(:),y_v_pot_c(:),'LineWidth',2);
% hold on;
% h2=plot(v_pot_r_c(:),F_v_pot(:),'r.','MarkerSize',5);
% legend([h1 h2],'Fitted Curve','Original Points');
% ylabel('Cumulative Probability of v','FontWeight','bold','FontSize',16);
% xlabel('v','FontWeight','bold','FontSize',16);
% axis([0.8 1.6 0 1.1])


%long term distribution of reponse in POT method regarding wave crest%
%first do some data study to the y_tilda, rank it for further calculation%
v_tilda_r=sort(v_tilda);                   %important note here, sort y_tilda in an asending order for further calculation%
v_tilda_l=log(-log(1-F_v_pot));            %y-axis for three parameter Weibull distribution probablity paper%
v_tilda_s=-log(-log(F_v_pot));

%use three parameter weilbull model to fit the data%
v_lp=5.5:0.01:5.7;                         %lp: location parameter.%
S=round((5.7-5.5)/0.01+1);                        %number of v_lp%

ln_y_c=zeros(length(v_tilda),S);           %x-axis for three parameter Weibull distribution probablity paper%
for i=1:1:length(v_tilda)
    for j=1:1:S
        ln_y_c(i,j)=log(v_tilda_r(i)-v_lp(j));
    end
end

kay_3=zeros(S,1);                          %kay in the three parameter Weibull distribution%
lamda_3=zeros(S,1);                        %lamda in the three parameter Weibull distribution%
devia_3=zeros(S,1);                        %deviation for each location parameter, to choose the least one%

for i=1:1:S
  [kfun,gof,output]=fit(ln_y_c((i+3):length(v_tilda),i),v_tilda_l((i+3):length(v_tilda),1),'poly1');
  kfun;
  gof;
  output;
  kay_3(i,1)=kfun.p1;
  lamda_3(i,1)=exp(-kfun.p2/kfun.p1);
    for j=(i+3):1:length(v_tilda)                  %there is a munual modification here, since ln_y has to be real number, and only by doing i+3 can get real number from the diagram%
        devia_3(i,1)=devia_3(i,1)+(kay_3(i,1)*ln_y_c(j,i)-kay_3(i,1)*log(lamda_3(i,1))-v_tilda_l(j,1))^2;
    end
        devia_3(i,1)=(devia_3(i,1)/(length(v_tilda)-i))^0.5;
end

% figure(50)
% h1=plot(v_lp(1:S),devia_3,'r.','MarkerSize',5);    
% ylabel('Standard Deviation','FontWeight','bold','FontSize',16);
% xlabel('Location Parameter','FontWeight','bold','FontSize',16);
% %from figure(49) it can be seen that the 9th point has the smallest deviation value%

% lp_3_final=5.58;                          %lp_3_final, kay_3_final, lamda_3_final can be thus decided according to the smallest deviation value%
% kay_3_final=1.0579;
% lamda_3_final=1.5291;
% T=find(y_tilda_r(:)>lp_3_final,1);        %T is the number larger and closest to lp_2_final, for further calculation%

       
lp_3_final=5.54;
kay_3_final=1.1649;
lamda_3_final=1.5782;
T=find(y_tilda_r(:)>lp_3_final,1);

v_pot2=zeros(length(v_tilda)-T+1,1);      %cumulative probability for the most probable crest height%
for i=T:1:length(y_tilda)
    v_pot2(i,1)=1-exp(-((v_tilda_r(i,1)-lp_3_final)/lamda_3_final)^kay_3_final);
end

% figure(51)
% h1=plot(v_tilda_r(T:length(v_tilda)),v_pot2(T:length(v_tilda)),'LineWidth',2);
% hold on;
% h2=plot(v_tilda_r(1:length(v_tilda)),F_v_pot(1:length(v_tilda)),'r.','MarkerSize',5);
% legend([h1 h2],'Fitted Curve','Original Points');
% ylabel('Cumulative Probability of v tilda','FontWeight','bold','FontSize',16);
% xlabel('v tilda','FontWeight','bold','FontSize',16);
% axis([5 16 0 1.1])


y_now=zeros(length(v_tilda),1);                    %y_now is the -log(1-F), can be calculated when the three parameter Weibull are decided%
x_now_1=zeros(length(v_tilda),1);                  %x_now_l is the log(x-lp) in the probability paper version%
U=9;                                               %U is the integral larger and closest to lp_2_final%

for i=U:1:length(v_tilda)
    y_now(i,1)=kay_3_final*log(v_tilda_r(i)-lp_3_final)-kay_3_final*log(lamda_3_final);
    x_now_1(i,1)=log(v_tilda_r(i,1)-lp_3_final);   %take log here only because the line would be a straight line%
end

% figure(52)
% h1=plot(v_tilda_r(U:length(v_tilda)),v_tilda_l(U:length(v_tilda)),'r.','MarkerSize',5);
% hold on;
% h2=plot(v_tilda_r(U:length(v_tilda)),y_now(U:length(v_tilda)),'LineWidth',2)
% legend([h1 h2],'Fitted Curve','Original Points');
% ylabel('Cumulative Probability of c tilda','FontWeight','bold','FontSize',16);
% xlabel('c tilda','FontWeight','bold','FontSize',16);
% % grid

% figure(53)
% h1=plot(x_now_1(U:length(v_tilda)),v_tilda_l(U:length(v_tilda)),'r.','MarkerSize',8);
% hold on;
% h2=plot(x_now_1(U:length(v_tilda)),y_now(U:length(v_tilda)),'LineWidth',4)
% axis([-3.2 2.5 -4.2 2.2])
% AX=legend([h1 h2],'Original Points','Fitted Curve','Location','NorthWest');
% LEG = findobj(AX,'type','text');
% set(LEG,'FontSize',17)
% ylabel('-ln(1-F(c))','FontWeight','bold','FontSize',22);
% xlabel('ln(c_ tilda-lp)','FontWeight','bold','FontSize',22);
% set(gca,'fontsize',15)
% set(gca,'fontsize',15)
% % grid

%long term analysis of response%
%long term disribution for y_tilda%
v_estm_max=30;                                                       %estimated maximum value of y%
v_tilda_esma=25;                                                     %estimated maximum value of y_tilda, i.e. largest most probable 3 hour response of hurricane%
int=0.1;
scatter_rsp_pot_c=zeros(v_tilda_esma/int-U/int+1,v_estm_max/int);    %since lp_2_final=11.75, the scale of scatter is affected by this%
scatter_y_tilda_bs_c=zeros(v_tilda_esma/int-U/int+1,1);              %density probability for each interval of v_tilda, similar to scatter for hs_tp interval, notice: before scale%
scatter_y_tilda_c=zeros(v_tilda_esma/int-U/int+1,1);                 %density probability for each interval of v_tilda, similar to scatter for hs_tp interval, notice: after scale%
P_veri_rsp_pot_c=zeros(v_estm_max/int,1);

U=6;                                                                 %notice, U is the first integral larger than lp_3_final%
scatter_y_tilda_bs_c(1,1)=(1-exp(-((U-lp_3_final)/lamda_3_final)^kay_3_final));          
for i=U/int+1:1:v_tilda_esma/int
    scatter_y_tilda_bs_c(i-U/int+1,1)=(1-exp(-((i*int-lp_3_final)/lamda_3_final)^kay_3_final))-(1-exp(-(((i-1)*int-lp_3_final)/lamda_3_final)^kay_3_final));
end
P_veri_pot_bs_c=sum(scatter_y_tilda_bs_c(:));

for i=U/int:1:v_tilda_esma/int
    scatter_y_tilda_c(i-U/int+1,1)=scatter_y_tilda_bs_c(i-U/int+1,1)/P_veri_pot_bs_c;
end
P_veri_pot_c=sum(scatter_y_tilda_c(:));

%long term crest height distribution%
v_tilda_rsp=zeros(v_tilda_esma/int-U/int+1,1);              %middle point for each v interval%     
v_rsp=zeros(v_estm_max/int,1);                              %middle point for each v_tilda interval%

for i=1:1:v_estm_max/int
    for j=U/int:1:v_tilda_esma/int
        v_rsp(i,1)=i*int;
        v_tilda_rsp(j-U/int+1,1)=(j-0.5)*int;
                 
        scatter_rsp_pot_c(j-U/int+1,i)=exp(-exp(-(v_rsp(i,1)-v_tilda_rsp(j-U/int+1,1)*alfa_gumb_c)/(beita_gumb_c*v_tilda_rsp(j-U/int+1,1))))*scatter_y_tilda_c(j-U/int+1,1);
    end
    P_veri_rsp_pot_c(i,1)=sum(scatter_rsp_pot_c(:,i));
end
W=-log(-log(P_veri_rsp_pot_c(1:v_estm_max/int)));                  %y-axis in Gumbel probability paper%

% figure(54)
% h1=plot(v_rsp(1:v_estm_max/int),P_veri_rsp_pot_c(1:v_estm_max/int),'r.','MarkerSize',5);
% ylabel('Cumulative Probability of crest height','FontWeight','bold','FontSize',16);
% xlabel('crest height','FontWeight','bold','FontSize',16);
% 
% figure(55)
% h1=plot(v_rsp(1:v_estm_max/int),W(1:v_estm_max/int),'r.','MarkerSize',8);
% ylabel('Gumbel Probability Paper','FontWeight','bold','FontSize',22);
% xlabel('crest height','FontWeight','bold','FontSize',22);
% axis([0 32 -7 20])
% set(gca,'fontsize',15)

figure(56)
h1=plot(v_rsp(1:v_estm_max/int),W(1:v_estm_max/int),'b.','MarkerSize',8);
hold on;
h2=plot(v_tilda_r(1:length(v_tilda)),v_tilda_s(1:length(v_tilda)),'r*','MarkerSize',8);
AX=legend([h1 h2],'gumble plot for c','gumble plot for c tilda');
LEG = findobj(AX,'type','text');
set(LEG,'FontSize',17)
ylabel('Gumbel Probability Paper','FontWeight','bold','FontSize',22);
xlabel('crest height','FontWeight','bold','FontSize',22);
% grid
set(gca,'fontsize',15)


